Attribute VB_Name = "Funzioni_form_principale"
'----------------------------------COSTANTI PER TABELLE FORM PRINCIPALE-------------------------------------
Global Const Principale_Tabella_LarghezzaQuadrato As Integer = 450
Global Const Principale_Tabella_ColoreAcceso As Long = 16711680 'blu scuro
Global Const Principale_Tabella_ColoreSpento As Long = 0 'bianco (16777215)

'-----------------------------COSTANTI PER TIMELINE--------------------------------
Global Const Principale_Timeline_ColPos As Integer = 0
Global Const Principale_Timeline_ColStringa As Integer = 1
Global Const Principale_Timeline_LarghezzaPos As Integer = 500
Global Const Principale_Timeline_LarghezzaStringa As Integer = 3000

Public Function InizializzaTabellePrincipale() 'inizializza le tabelle all'apertura del form
    Dim IndiceTabella As Integer
    
    For IndiceTabella = 1 To 8 'scorro tutte le tabelle
        With FormPrincipale.Tabella(IndiceTabella)
            'rendo visibile la PRIMA tabella
            If IndiceTabella = 1 Then
                .Visible = True
                FormPrincipale.lblLivelloVisualizzato.Caption = "Livello visualizzato: " & IndiceTabella
            Else
                .Visible = False
            End If
            'imposto la larghezza delle righe e delle colonne di tutte le tabelle
            For i = 0 To 7
                .ColWidth(i) = Principale_Tabella_LarghezzaQuadrato
                .RowHeight(i) = Principale_Tabella_LarghezzaQuadrato
            Next i
            'imposto la propriet fillstyle per colorare tutte le celle selezionate
            .FillStyle = flexFillRepeat
        End With
    Next IndiceTabella
End Function

Public Function TabellaToMatriceCubo() 'legge lo stato attuale del cubo (rappresentato sulla tabella nel form)
    Dim ContaTabelle As Integer
    Dim ContaColonne As Integer
    Dim ContaRighe As Integer
    Dim ContaLaterali As Integer

    For ContaTabelle = 1 To 8 'scorro le varie tabelle
        For ContaRighe = 0 To 7
            For ContaColonne = 0 To 7
                StatoCubo(ContaTabelle, (ContaRighe * 8) + (ContaColonne + 1)) = LeggiCellaTabellaPrincipale(ContaTabelle, ContaRighe, ContaColonne)
            Next ContaColonne
        Next ContaRighe
    Next ContaTabelle
End Function

Public Function LeggiCellaTabellaPrincipale(IndiceTabella As Integer, Riga As Integer, Colonna As Integer) As Integer
'legge una determinata cella della tabella specificata e ritorna 1 se  colorata oppure 0 se  bianca
    With FormPrincipale.Tabella(IndiceTabella)
        .Row = Riga 'seleziono la riga della cella da controllare
        .Col = Colonna 'seleziono la colonna della cella da controllare
        
        If .CellBackColor <> Principale_Tabella_ColoreSpento Then 'se la cella selezionata  colorata
            LeggiCellaTabellaPrincipale = 1
        Else 'se la cella  bianca
            LeggiCellaTabellaPrincipale = 0
        End If
    End With
End Function

Public Function ColoraCellaTabellaPrincipale(IndiceTabella As Integer) 'colora la cella della tabella visualizzata
    With FormPrincipale.Tabella(IndiceTabella)
        If .CellBackColor = Principale_Tabella_ColoreSpento Then 'se la cella  bianca
            .CellBackColor = Principale_Tabella_ColoreAcceso 'colora la cella di blu
        Else 'se la cella  blu
            .CellBackColor = Principale_Tabella_ColoreSpento 'colora la cella di bianco
        End If
    End With
End Function

Public Function InizializzaTimelinePrincipale() 'inizializza la timeline all'apertura del form
    With FormPrincipale.Timeline
        'imposto il numero di righe e delle colonne
        .Rows = 1
        .Cols = 2
        
        'scrivo le intestazioni delle colonne
        .Row = 0 'seleziono la prima riga
        .Col = Principale_Timeline_ColPos 'seleziono la colonna POS
        .Text = "Pos"
        .Col = Principale_Timeline_ColStringa 'seleziono la colonna STRINGA
        .Text = "Stringa"
        
        'imposto la larghezza delle colonne
        .ColWidth(Principale_Timeline_ColPos) = Principale_Timeline_LarghezzaPos
        .ColWidth(Principale_Timeline_ColStringa) = Principale_Timeline_LarghezzaStringa
    End With
End Function

Public Function StringToMatriceCubo(Stringa As String) 'riporta la stringa passata alla funzione sulla matrice STATOCUBO
    Dim ContaTabelle As Integer
    Dim ContaLed As Integer
    Dim Posizione As Integer
    
    For ContaTabelle = 1 To 8
        For ContaLed = 1 To 64
            Posizione = ((ContaTabelle - 1) * 64) + ContaLed
            StatoCubo(ContaTabelle, ContaLed) = Mid(Stringa, Posizione, 1)
        Next ContaLed
    Next ContaTabelle
End Function

Public Function CaricaTimelinePrincipale()
On Error GoTo fine
    Dim PercorsoOpen As String: PercorsoOpen = App.Path & "\" & PathAnimazioni 'path predefinita
    Dim NomeFile As String
    Dim StringaLetta As String
    
    FormPrincipale.CommonDialogPrincipale.InitDir = PercorsoOpen 'directory iniziale
    FormPrincipale.CommonDialogPrincipale.DialogTitle = "CARICAMENTO TIMELINE" 'titolo finestra
    FormPrincipale.CommonDialogPrincipale.Filter = "File di testo (*.txt)|*.txt" 'filtro file txt
    FormPrincipale.CommonDialogPrincipale.ShowOpen 'visualizza la finestra
    
    NomeFile = FormPrincipale.CommonDialogPrincipale.FileName 'segna il nome selezionato (comprensivo di path ed estensione)
    
    If NomeFile <> "" Then 'se l'utente ha scelto il file
        Call InizializzaTimelinePrincipale 'resetto la timeline (completamente vuota)
        
        Open NomeFile For Input As 1 'apro il file scelto dall'utente
        With FormPrincipale.Timeline
            .Col = Principale_Timeline_ColStringa
            Do
                .Rows = .Rows + 1
                .Row = .Rows - 1
                Input #1, StringaLetta
                .Text = StringaLetta
            Loop Until EOF(1) = True 'loop fino alla fine del file
        End With
        
        Close #1
        
        Call RiempiPosTimelinePrincipale 'riempo la colonna delle posizioni
        
        Call MsgBox("Caricamento completato!")
    Else
        Call MsgBox("Caricamento annullato!")
    End If
Exit Function
fine:
    Close #1
    MsgBox Err.Description
End Function

Public Function RiempiPosTimelinePrincipale() 'riempie la colonna POS della timeline
    With FormPrincipale.Timeline
        For i = 1 To .Rows - 1
            .Col = Principale_Timeline_ColPos 'seleziono la colonna POS
            .Row = i
            .Text = i
        Next i
    End With
End Function
