Attribute VB_Name = "Funzioni_movimento_editor"
Global Const StringaAvanti As String = "Avanti"
Global Const StringaDietro As String = "Dietro"
Global Const StringaDestra As String = "Destra"
Global Const StringaSinistra As String = "Sinistra"

Public Function AggiungiMovimento(PosizioneElemento As Integer, VersoMovimento As String)
    Select Case VersoMovimento
        Case StringaAvanti:
            Call MuoviDietroToAvanti(PosizioneElemento)
        Case StringaDietro:
            Call MuoviAvantiToDietro(PosizioneElemento)
        Case StringaDestra:
            Call MuoviSinistraToDestra(PosizioneElemento)
        Case StringaSinistra:
            Call MuoviDestraToSinistra(PosizioneElemento)
    End Select
End Function

Public Function MuoviDietroToAvanti(PosizioneElemento As Integer)
    Dim StringaOriginale As String
    Dim StringaSpostata As String
    Dim MatriceOriginale(1 To 8, 1 To 64) As String
    Dim MatriceSpostata(1 To 8, 1 To 64) As String
    Dim LateraliOriginale(1 To 8, 1 To 8) As String
    Dim LateraliSpostata(1 To 8, 1 To 8) As String
    Dim ContaTabelle As Integer
    Dim ContaLed As Integer
    Dim Posizione As Integer
    
    With FormEditor.Timeline
        .Rows = .Rows + 1 'aggiungo una riga alla timeline
        .Col = Editor_Timeline_ColStringa 'seleziono la colonna delle stringhe
        If PosizioneElemento < .Rows - 1 Then 'se la riga non v aggiunta alla fine
            'scalo gli elementi della timeline fino allo spazio dove v inserito il nuovo elemento
            For i = .Rows - 1 To PosizioneElemento + 2 Step -1
                .Row = i - 1
                StringaDaCopiare = .Text
                .Row = i
                .Text = StringaDaCopiare
            Next i
        End If
        
        .Row = PosizioneElemento 'seleziono la posizione della cella originale
        StringaOriginale = .Text 'copio la stringa originale
        
        'copio la stringa da ruotare nella MATRICE ORIGINALE (solo i primi 512 bit - led centrali)
        For ContaTabelle = 1 To 8
            For ContaLed = 1 To 64
                Posizione = ((ContaTabelle - 1) * 64) + ContaLed
                MatriceOriginale(ContaTabelle, ContaLed) = Mid(StringaOriginale, Posizione, 1)
            Next ContaLed
        Next ContaTabelle
        'copio la stringa da ruotare nella MATRICE ORIGINALE (solo gli ultimi 64 bit - led laterali)
        For ContaTabelle = 1 To 8
            For ContaLed = 1 To 8
                Posizione = 512 + ((ContaTabelle - 1) * 8) + ContaLed
                LateraliOriginale(ContaTabelle, ContaLed) = Mid(StringaOriginale, Posizione, 1)
            Next ContaLed
        Next ContaTabelle
        
        'scambio le posizioni da MATRICE ORIGINALE a MATRICE Spostata
        For ContaTabelle = 1 To 8
            'led centrali
            MatriceSpostata(ContaTabelle, 1) = 0 'SE C'ERA QUALCOSA E' STATO SPOSTATO IN AVANTI
            MatriceSpostata(ContaTabelle, 2) = 0 'SE C'ERA QUALCOSA E' STATO SPOSTATO IN AVANTI
            MatriceSpostata(ContaTabelle, 3) = 0 'SE C'ERA QUALCOSA E' STATO SPOSTATO IN AVANTI
            MatriceSpostata(ContaTabelle, 4) = 0 'SE C'ERA QUALCOSA E' STATO SPOSTATO IN AVANTI
            MatriceSpostata(ContaTabelle, 5) = 0 'SE C'ERA QUALCOSA E' STATO SPOSTATO IN AVANTI
            MatriceSpostata(ContaTabelle, 6) = 0 'SE C'ERA QUALCOSA E' STATO SPOSTATO IN AVANTI
            MatriceSpostata(ContaTabelle, 7) = 0 'SE C'ERA QUALCOSA E' STATO SPOSTATO IN AVANTI
            MatriceSpostata(ContaTabelle, 8) = 0 'SE C'ERA QUALCOSA E' STATO SPOSTATO IN AVANTI
            MatriceSpostata(ContaTabelle, 9) = MatriceOriginale(ContaTabelle, 1)
            MatriceSpostata(ContaTabelle, 10) = MatriceOriginale(ContaTabelle, 2)
            MatriceSpostata(ContaTabelle, 11) = MatriceOriginale(ContaTabelle, 3)
            MatriceSpostata(ContaTabelle, 12) = MatriceOriginale(ContaTabelle, 4)
            MatriceSpostata(ContaTabelle, 13) = MatriceOriginale(ContaTabelle, 5)
            MatriceSpostata(ContaTabelle, 14) = MatriceOriginale(ContaTabelle, 6)
            MatriceSpostata(ContaTabelle, 15) = MatriceOriginale(ContaTabelle, 7)
            MatriceSpostata(ContaTabelle, 16) = MatriceOriginale(ContaTabelle, 8)
            MatriceSpostata(ContaTabelle, 17) = MatriceOriginale(ContaTabelle, 9)
            MatriceSpostata(ContaTabelle, 18) = MatriceOriginale(ContaTabelle, 10)
            MatriceSpostata(ContaTabelle, 19) = MatriceOriginale(ContaTabelle, 11)
            MatriceSpostata(ContaTabelle, 20) = MatriceOriginale(ContaTabelle, 12)
            MatriceSpostata(ContaTabelle, 21) = MatriceOriginale(ContaTabelle, 13)
            MatriceSpostata(ContaTabelle, 22) = MatriceOriginale(ContaTabelle, 14)
            MatriceSpostata(ContaTabelle, 23) = MatriceOriginale(ContaTabelle, 15)
            MatriceSpostata(ContaTabelle, 24) = MatriceOriginale(ContaTabelle, 16)
            MatriceSpostata(ContaTabelle, 25) = MatriceOriginale(ContaTabelle, 17)
            MatriceSpostata(ContaTabelle, 26) = MatriceOriginale(ContaTabelle, 18)
            MatriceSpostata(ContaTabelle, 27) = MatriceOriginale(ContaTabelle, 19)
            MatriceSpostata(ContaTabelle, 28) = MatriceOriginale(ContaTabelle, 20)
            MatriceSpostata(ContaTabelle, 29) = MatriceOriginale(ContaTabelle, 21)
            MatriceSpostata(ContaTabelle, 30) = MatriceOriginale(ContaTabelle, 22)
            MatriceSpostata(ContaTabelle, 31) = MatriceOriginale(ContaTabelle, 23)
            MatriceSpostata(ContaTabelle, 32) = MatriceOriginale(ContaTabelle, 24)
            MatriceSpostata(ContaTabelle, 33) = MatriceOriginale(ContaTabelle, 25)
            MatriceSpostata(ContaTabelle, 34) = MatriceOriginale(ContaTabelle, 26)
            MatriceSpostata(ContaTabelle, 35) = MatriceOriginale(ContaTabelle, 27)
            MatriceSpostata(ContaTabelle, 36) = MatriceOriginale(ContaTabelle, 28)
            MatriceSpostata(ContaTabelle, 37) = MatriceOriginale(ContaTabelle, 29)
            MatriceSpostata(ContaTabelle, 38) = MatriceOriginale(ContaTabelle, 30)
            MatriceSpostata(ContaTabelle, 39) = MatriceOriginale(ContaTabelle, 31)
            MatriceSpostata(ContaTabelle, 40) = MatriceOriginale(ContaTabelle, 32)
            MatriceSpostata(ContaTabelle, 41) = MatriceOriginale(ContaTabelle, 33)
            MatriceSpostata(ContaTabelle, 42) = MatriceOriginale(ContaTabelle, 34)
            MatriceSpostata(ContaTabelle, 43) = MatriceOriginale(ContaTabelle, 35)
            MatriceSpostata(ContaTabelle, 44) = MatriceOriginale(ContaTabelle, 36)
            MatriceSpostata(ContaTabelle, 45) = MatriceOriginale(ContaTabelle, 37)
            MatriceSpostata(ContaTabelle, 46) = MatriceOriginale(ContaTabelle, 38)
            MatriceSpostata(ContaTabelle, 47) = MatriceOriginale(ContaTabelle, 39)
            MatriceSpostata(ContaTabelle, 48) = MatriceOriginale(ContaTabelle, 40)
            MatriceSpostata(ContaTabelle, 49) = MatriceOriginale(ContaTabelle, 41)
            MatriceSpostata(ContaTabelle, 50) = MatriceOriginale(ContaTabelle, 42)
            MatriceSpostata(ContaTabelle, 51) = MatriceOriginale(ContaTabelle, 43)
            MatriceSpostata(ContaTabelle, 52) = MatriceOriginale(ContaTabelle, 44)
            MatriceSpostata(ContaTabelle, 53) = MatriceOriginale(ContaTabelle, 45)
            MatriceSpostata(ContaTabelle, 54) = MatriceOriginale(ContaTabelle, 46)
            MatriceSpostata(ContaTabelle, 55) = MatriceOriginale(ContaTabelle, 47)
            MatriceSpostata(ContaTabelle, 56) = MatriceOriginale(ContaTabelle, 48)
            MatriceSpostata(ContaTabelle, 57) = MatriceOriginale(ContaTabelle, 49)
            MatriceSpostata(ContaTabelle, 58) = MatriceOriginale(ContaTabelle, 50)
            MatriceSpostata(ContaTabelle, 59) = MatriceOriginale(ContaTabelle, 51)
            MatriceSpostata(ContaTabelle, 60) = MatriceOriginale(ContaTabelle, 52)
            MatriceSpostata(ContaTabelle, 61) = MatriceOriginale(ContaTabelle, 53)
            MatriceSpostata(ContaTabelle, 62) = MatriceOriginale(ContaTabelle, 54)
            MatriceSpostata(ContaTabelle, 63) = MatriceOriginale(ContaTabelle, 55)
            MatriceSpostata(ContaTabelle, 64) = MatriceOriginale(ContaTabelle, 56)
            
            'led laterali
            LateraliSpostata(ContaTabelle, 1) = LateraliOriginale(ContaTabelle, 1) 'NON SI SPOSTA
            LateraliSpostata(ContaTabelle, 2) = LateraliOriginale(ContaTabelle, 2) 'NON SI SPOSTA
            LateraliSpostata(ContaTabelle, 3) = LateraliOriginale(ContaTabelle, 3) 'NON SI SPOSTA
            LateraliSpostata(ContaTabelle, 4) = LateraliOriginale(ContaTabelle, 4) 'NON SI SPOSTA
            LateraliSpostata(ContaTabelle, 5) = LateraliOriginale(ContaTabelle, 5) 'NON SI SPOSTA
            LateraliSpostata(ContaTabelle, 6) = LateraliOriginale(ContaTabelle, 6) 'NON SI SPOSTA
            LateraliSpostata(ContaTabelle, 7) = LateraliOriginale(ContaTabelle, 7) 'NON SI SPOSTA
            LateraliSpostata(ContaTabelle, 8) = LateraliOriginale(ContaTabelle, 8) 'NON SI SPOSTA
        Next ContaTabelle
        
        'copio il contenuto della MATRICE Spostata sulla stringa (solo i primi 512 bit - led centrali)
        StringaSpostata = "" 'azzero la stringa da esportare
         For ContaTabelle = 1 To 8
            For ContaLed = 1 To 64
                StringaSpostata = StringaSpostata & MatriceSpostata(ContaTabelle, ContaLed)
            Next ContaLed
        Next ContaTabelle
        'copio il contenuto della MATRICE Spostata sulla stringa (solo gli ultimi 64 bit - led laterali)
        For ContaTabelle = 1 To 8
            For ContaLed = 1 To 8
                StringaSpostata = StringaSpostata & LateraliSpostata(ContaTabelle, ContaLed)
            Next ContaLed
        Next ContaTabelle
    
        'inserisco la stringa subito dopo quella originale
        .Row = PosizioneElemento + 1 'mi sposto alla posizione subito dopo la stringa originale
        .Text = StringaSpostata 'inserisco la stringa Spostata
        
        Call StringToTabellaEditor(.Text) 'riporto il contenuto della stringa sulla tabella
        Call RiempiPosTimelineEditor 'riempo la colonna delle posizioni
        
        .Col = Editor_Timeline_ColStringa 'seleziono la colonna delle stringhe
        .Row = PosizioneElemento + 1
    End With
End Function

Public Function MuoviAvantiToDietro(PosizioneElemento As Integer)
    Dim StringaOriginale As String
    Dim StringaSpostata As String
    Dim MatriceOriginale(1 To 8, 1 To 64) As String
    Dim MatriceSpostata(1 To 8, 1 To 64) As String
    Dim LateraliOriginale(1 To 8, 1 To 8) As String
    Dim LateraliSpostata(1 To 8, 1 To 8) As String
    Dim ContaTabelle As Integer
    Dim ContaLed As Integer
    Dim Posizione As Integer
    
    With FormEditor.Timeline
        .Rows = .Rows + 1 'aggiungo una riga alla timeline
        .Col = Editor_Timeline_ColStringa 'seleziono la colonna delle stringhe
        If PosizioneElemento < .Rows - 1 Then 'se la riga non v aggiunta alla fine
            'scalo gli elementi della timeline fino allo spazio dove v inserito il nuovo elemento
            For i = .Rows - 1 To PosizioneElemento + 2 Step -1
                .Row = i - 1
                StringaDaCopiare = .Text
                .Row = i
                .Text = StringaDaCopiare
            Next i
        End If
        
        .Row = PosizioneElemento 'seleziono la posizione della cella originale
        StringaOriginale = .Text 'copio la stringa originale
        
        'copio la stringa da ruotare nella MATRICE ORIGINALE (solo i primi 512 bit - led centrali)
        For ContaTabelle = 1 To 8
            For ContaLed = 1 To 64
                Posizione = ((ContaTabelle - 1) * 64) + ContaLed
                MatriceOriginale(ContaTabelle, ContaLed) = Mid(StringaOriginale, Posizione, 1)
            Next ContaLed
        Next ContaTabelle
        'copio la stringa da ruotare nella MATRICE ORIGINALE (solo gli ultimi 64 bit - led laterali)
        For ContaTabelle = 1 To 8
            For ContaLed = 1 To 8
                Posizione = 512 + ((ContaTabelle - 1) * 8) + ContaLed
                LateraliOriginale(ContaTabelle, ContaLed) = Mid(StringaOriginale, Posizione, 1)
            Next ContaLed
        Next ContaTabelle
        
        'scambio le posizioni da MATRICE ORIGINALE a MATRICE Spostata
        For ContaTabelle = 1 To 8
            'led centrali
            MatriceSpostata(ContaTabelle, 1) = MatriceOriginale(ContaTabelle, 9)
            MatriceSpostata(ContaTabelle, 2) = MatriceOriginale(ContaTabelle, 10)
            MatriceSpostata(ContaTabelle, 3) = MatriceOriginale(ContaTabelle, 11)
            MatriceSpostata(ContaTabelle, 4) = MatriceOriginale(ContaTabelle, 12)
            MatriceSpostata(ContaTabelle, 5) = MatriceOriginale(ContaTabelle, 13)
            MatriceSpostata(ContaTabelle, 6) = MatriceOriginale(ContaTabelle, 14)
            MatriceSpostata(ContaTabelle, 7) = MatriceOriginale(ContaTabelle, 15)
            MatriceSpostata(ContaTabelle, 8) = MatriceOriginale(ContaTabelle, 16)
            MatriceSpostata(ContaTabelle, 9) = MatriceOriginale(ContaTabelle, 17)
            MatriceSpostata(ContaTabelle, 10) = MatriceOriginale(ContaTabelle, 18)
            MatriceSpostata(ContaTabelle, 11) = MatriceOriginale(ContaTabelle, 19)
            MatriceSpostata(ContaTabelle, 12) = MatriceOriginale(ContaTabelle, 20)
            MatriceSpostata(ContaTabelle, 13) = MatriceOriginale(ContaTabelle, 21)
            MatriceSpostata(ContaTabelle, 14) = MatriceOriginale(ContaTabelle, 22)
            MatriceSpostata(ContaTabelle, 15) = MatriceOriginale(ContaTabelle, 23)
            MatriceSpostata(ContaTabelle, 16) = MatriceOriginale(ContaTabelle, 24)
            MatriceSpostata(ContaTabelle, 17) = MatriceOriginale(ContaTabelle, 25)
            MatriceSpostata(ContaTabelle, 18) = MatriceOriginale(ContaTabelle, 26)
            MatriceSpostata(ContaTabelle, 19) = MatriceOriginale(ContaTabelle, 27)
            MatriceSpostata(ContaTabelle, 20) = MatriceOriginale(ContaTabelle, 28)
            MatriceSpostata(ContaTabelle, 21) = MatriceOriginale(ContaTabelle, 29)
            MatriceSpostata(ContaTabelle, 22) = MatriceOriginale(ContaTabelle, 30)
            MatriceSpostata(ContaTabelle, 23) = MatriceOriginale(ContaTabelle, 31)
            MatriceSpostata(ContaTabelle, 24) = MatriceOriginale(ContaTabelle, 32)
            MatriceSpostata(ContaTabelle, 25) = MatriceOriginale(ContaTabelle, 33)
            MatriceSpostata(ContaTabelle, 26) = MatriceOriginale(ContaTabelle, 34)
            MatriceSpostata(ContaTabelle, 27) = MatriceOriginale(ContaTabelle, 35)
            MatriceSpostata(ContaTabelle, 28) = MatriceOriginale(ContaTabelle, 36)
            MatriceSpostata(ContaTabelle, 29) = MatriceOriginale(ContaTabelle, 37)
            MatriceSpostata(ContaTabelle, 30) = MatriceOriginale(ContaTabelle, 38)
            MatriceSpostata(ContaTabelle, 31) = MatriceOriginale(ContaTabelle, 39)
            MatriceSpostata(ContaTabelle, 32) = MatriceOriginale(ContaTabelle, 40)
            MatriceSpostata(ContaTabelle, 33) = MatriceOriginale(ContaTabelle, 41)
            MatriceSpostata(ContaTabelle, 34) = MatriceOriginale(ContaTabelle, 42)
            MatriceSpostata(ContaTabelle, 35) = MatriceOriginale(ContaTabelle, 43)
            MatriceSpostata(ContaTabelle, 36) = MatriceOriginale(ContaTabelle, 44)
            MatriceSpostata(ContaTabelle, 37) = MatriceOriginale(ContaTabelle, 45)
            MatriceSpostata(ContaTabelle, 38) = MatriceOriginale(ContaTabelle, 46)
            MatriceSpostata(ContaTabelle, 39) = MatriceOriginale(ContaTabelle, 47)
            MatriceSpostata(ContaTabelle, 40) = MatriceOriginale(ContaTabelle, 48)
            MatriceSpostata(ContaTabelle, 41) = MatriceOriginale(ContaTabelle, 49)
            MatriceSpostata(ContaTabelle, 42) = MatriceOriginale(ContaTabelle, 50)
            MatriceSpostata(ContaTabelle, 43) = MatriceOriginale(ContaTabelle, 51)
            MatriceSpostata(ContaTabelle, 44) = MatriceOriginale(ContaTabelle, 52)
            MatriceSpostata(ContaTabelle, 45) = MatriceOriginale(ContaTabelle, 53)
            MatriceSpostata(ContaTabelle, 46) = MatriceOriginale(ContaTabelle, 54)
            MatriceSpostata(ContaTabelle, 47) = MatriceOriginale(ContaTabelle, 55)
            MatriceSpostata(ContaTabelle, 48) = MatriceOriginale(ContaTabelle, 56)
            MatriceSpostata(ContaTabelle, 49) = MatriceOriginale(ContaTabelle, 57)
            MatriceSpostata(ContaTabelle, 50) = MatriceOriginale(ContaTabelle, 58)
            MatriceSpostata(ContaTabelle, 51) = MatriceOriginale(ContaTabelle, 59)
            MatriceSpostata(ContaTabelle, 52) = MatriceOriginale(ContaTabelle, 60)
            MatriceSpostata(ContaTabelle, 53) = MatriceOriginale(ContaTabelle, 61)
            MatriceSpostata(ContaTabelle, 54) = MatriceOriginale(ContaTabelle, 62)
            MatriceSpostata(ContaTabelle, 55) = MatriceOriginale(ContaTabelle, 63)
            MatriceSpostata(ContaTabelle, 56) = MatriceOriginale(ContaTabelle, 64)
            MatriceSpostata(ContaTabelle, 57) = 0 'SE C'ERA QUALCOSA E' STATO SPOSTATO INDIETRO
            MatriceSpostata(ContaTabelle, 58) = 0 'SE C'ERA QUALCOSA E' STATO SPOSTATO INDIETRO
            MatriceSpostata(ContaTabelle, 59) = 0 'SE C'ERA QUALCOSA E' STATO SPOSTATO INDIETRO
            MatriceSpostata(ContaTabelle, 60) = 0 'SE C'ERA QUALCOSA E' STATO SPOSTATO INDIETRO
            MatriceSpostata(ContaTabelle, 61) = 0 'SE C'ERA QUALCOSA E' STATO SPOSTATO INDIETRO
            MatriceSpostata(ContaTabelle, 62) = 0 'SE C'ERA QUALCOSA E' STATO SPOSTATO INDIETRO
            MatriceSpostata(ContaTabelle, 63) = 0 'SE C'ERA QUALCOSA E' STATO SPOSTATO INDIETRO
            MatriceSpostata(ContaTabelle, 64) = 0 'SE C'ERA QUALCOSA E' STATO SPOSTATO INDIETRO
            
            'led laterali
            LateraliSpostata(ContaTabelle, 1) = LateraliOriginale(ContaTabelle, 1) 'NON SI SPOSTA
            LateraliSpostata(ContaTabelle, 2) = LateraliOriginale(ContaTabelle, 2) 'NON SI SPOSTA
            LateraliSpostata(ContaTabelle, 3) = LateraliOriginale(ContaTabelle, 3) 'NON SI SPOSTA
            LateraliSpostata(ContaTabelle, 4) = LateraliOriginale(ContaTabelle, 4) 'NON SI SPOSTA
            LateraliSpostata(ContaTabelle, 5) = LateraliOriginale(ContaTabelle, 5) 'NON SI SPOSTA
            LateraliSpostata(ContaTabelle, 6) = LateraliOriginale(ContaTabelle, 6) 'NON SI SPOSTA
            LateraliSpostata(ContaTabelle, 7) = LateraliOriginale(ContaTabelle, 7) 'NON SI SPOSTA
            LateraliSpostata(ContaTabelle, 8) = LateraliOriginale(ContaTabelle, 8) 'NON SI SPOSTA
        Next ContaTabelle
        
        'copio il contenuto della MATRICE Spostata sulla stringa (solo i primi 512 bit - led centrali)
        StringaSpostata = "" 'azzero la stringa da esportare
         For ContaTabelle = 1 To 8
            For ContaLed = 1 To 64
                StringaSpostata = StringaSpostata & MatriceSpostata(ContaTabelle, ContaLed)
            Next ContaLed
        Next ContaTabelle
        'copio il contenuto della MATRICE Spostata sulla stringa (solo gli ultimi 64 bit - led laterali)
        For ContaTabelle = 1 To 8
            For ContaLed = 1 To 8
                StringaSpostata = StringaSpostata & LateraliSpostata(ContaTabelle, ContaLed)
            Next ContaLed
        Next ContaTabelle
    
        'inserisco la stringa subito dopo quella originale
        .Row = PosizioneElemento + 1 'mi sposto alla posizione subito dopo la stringa originale
        .Text = StringaSpostata 'inserisco la stringa Spostata
        
        Call StringToTabellaEditor(.Text) 'riporto il contenuto della stringa sulla tabella
        Call RiempiPosTimelineEditor 'riempo la colonna delle posizioni
        
        .Col = Editor_Timeline_ColStringa 'seleziono la colonna delle stringhe
        .Row = PosizioneElemento + 1
    End With
End Function

Public Function MuoviSinistraToDestra(PosizioneElemento As Integer)
    Dim StringaOriginale As String
    Dim StringaSpostata As String
    Dim MatriceOriginale(1 To 8, 1 To 64) As String
    Dim MatriceSpostata(1 To 8, 1 To 64) As String
    Dim LateraliOriginale(1 To 8, 1 To 8) As String
    Dim LateraliSpostata(1 To 8, 1 To 8) As String
    Dim ContaTabelle As Integer
    Dim ContaLed As Integer
    Dim Posizione As Integer
    
    With FormEditor.Timeline
        .Rows = .Rows + 1 'aggiungo una riga alla timeline
        .Col = Editor_Timeline_ColStringa 'seleziono la colonna delle stringhe
        If PosizioneElemento < .Rows - 1 Then 'se la riga non v aggiunta alla fine
            'scalo gli elementi della timeline fino allo spazio dove v inserito il nuovo elemento
            For i = .Rows - 1 To PosizioneElemento + 2 Step -1
                .Row = i - 1
                StringaDaCopiare = .Text
                .Row = i
                .Text = StringaDaCopiare
            Next i
        End If
        
        .Row = PosizioneElemento 'seleziono la posizione della cella originale
        StringaOriginale = .Text 'copio la stringa originale
        
        'copio la stringa da ruotare nella MATRICE ORIGINALE (solo i primi 512 bit - led centrali)
        For ContaTabelle = 1 To 8
            For ContaLed = 1 To 64
                Posizione = ((ContaTabelle - 1) * 64) + ContaLed
                MatriceOriginale(ContaTabelle, ContaLed) = Mid(StringaOriginale, Posizione, 1)
            Next ContaLed
        Next ContaTabelle
        'copio la stringa da ruotare nella MATRICE ORIGINALE (solo gli ultimi 64 bit - led laterali)
        For ContaTabelle = 1 To 8
            For ContaLed = 1 To 8
                Posizione = 512 + ((ContaTabelle - 1) * 8) + ContaLed
                LateraliOriginale(ContaTabelle, ContaLed) = Mid(StringaOriginale, Posizione, 1)
            Next ContaLed
        Next ContaTabelle
        
        'scambio le posizioni da MATRICE ORIGINALE a MATRICE Spostata
        For ContaTabelle = 1 To 8
            'led centrali
            MatriceSpostata(ContaTabelle, 1) = 0 'SE C'ERA QUALCOSA E' STATO SPOSTATO VERSO DESTRA
            MatriceSpostata(ContaTabelle, 2) = MatriceOriginale(ContaTabelle, 1)
            MatriceSpostata(ContaTabelle, 3) = MatriceOriginale(ContaTabelle, 2)
            MatriceSpostata(ContaTabelle, 4) = MatriceOriginale(ContaTabelle, 3)
            MatriceSpostata(ContaTabelle, 5) = MatriceOriginale(ContaTabelle, 4)
            MatriceSpostata(ContaTabelle, 6) = MatriceOriginale(ContaTabelle, 5)
            MatriceSpostata(ContaTabelle, 7) = MatriceOriginale(ContaTabelle, 6)
            MatriceSpostata(ContaTabelle, 8) = MatriceOriginale(ContaTabelle, 7)
            MatriceSpostata(ContaTabelle, 9) = 0 'SE C'ERA QUALCOSA E' STATO SPOSTATO VERSO DESTRA
            MatriceSpostata(ContaTabelle, 10) = MatriceOriginale(ContaTabelle, 9)
            MatriceSpostata(ContaTabelle, 11) = MatriceOriginale(ContaTabelle, 10)
            MatriceSpostata(ContaTabelle, 12) = MatriceOriginale(ContaTabelle, 11)
            MatriceSpostata(ContaTabelle, 13) = MatriceOriginale(ContaTabelle, 12)
            MatriceSpostata(ContaTabelle, 14) = MatriceOriginale(ContaTabelle, 13)
            MatriceSpostata(ContaTabelle, 15) = MatriceOriginale(ContaTabelle, 14)
            MatriceSpostata(ContaTabelle, 16) = MatriceOriginale(ContaTabelle, 15)
            MatriceSpostata(ContaTabelle, 17) = 0 'SE C'ERA QUALCOSA E' STATO SPOSTATO VERSO DESTRA
            MatriceSpostata(ContaTabelle, 18) = MatriceOriginale(ContaTabelle, 17)
            MatriceSpostata(ContaTabelle, 19) = MatriceOriginale(ContaTabelle, 18)
            MatriceSpostata(ContaTabelle, 20) = MatriceOriginale(ContaTabelle, 19)
            MatriceSpostata(ContaTabelle, 21) = MatriceOriginale(ContaTabelle, 20)
            MatriceSpostata(ContaTabelle, 22) = MatriceOriginale(ContaTabelle, 21)
            MatriceSpostata(ContaTabelle, 23) = MatriceOriginale(ContaTabelle, 22)
            MatriceSpostata(ContaTabelle, 24) = MatriceOriginale(ContaTabelle, 23)
            MatriceSpostata(ContaTabelle, 25) = 0 'SE C'ERA QUALCOSA E' STATO SPOSTATO VERSO DESTRA
            MatriceSpostata(ContaTabelle, 26) = MatriceOriginale(ContaTabelle, 25)
            MatriceSpostata(ContaTabelle, 27) = MatriceOriginale(ContaTabelle, 26)
            MatriceSpostata(ContaTabelle, 28) = MatriceOriginale(ContaTabelle, 27)
            MatriceSpostata(ContaTabelle, 29) = MatriceOriginale(ContaTabelle, 28)
            MatriceSpostata(ContaTabelle, 30) = MatriceOriginale(ContaTabelle, 29)
            MatriceSpostata(ContaTabelle, 31) = MatriceOriginale(ContaTabelle, 30)
            MatriceSpostata(ContaTabelle, 32) = MatriceOriginale(ContaTabelle, 31)
            MatriceSpostata(ContaTabelle, 33) = 0 'SE C'ERA QUALCOSA E' STATO SPOSTATO VERSO DESTRA
            MatriceSpostata(ContaTabelle, 34) = MatriceOriginale(ContaTabelle, 33)
            MatriceSpostata(ContaTabelle, 35) = MatriceOriginale(ContaTabelle, 34)
            MatriceSpostata(ContaTabelle, 36) = MatriceOriginale(ContaTabelle, 35)
            MatriceSpostata(ContaTabelle, 37) = MatriceOriginale(ContaTabelle, 36)
            MatriceSpostata(ContaTabelle, 38) = MatriceOriginale(ContaTabelle, 37)
            MatriceSpostata(ContaTabelle, 39) = MatriceOriginale(ContaTabelle, 38)
            MatriceSpostata(ContaTabelle, 40) = MatriceOriginale(ContaTabelle, 39)
            MatriceSpostata(ContaTabelle, 41) = 0 'SE C'ERA QUALCOSA E' STATO SPOSTATO VERSO DESTRA
            MatriceSpostata(ContaTabelle, 42) = MatriceOriginale(ContaTabelle, 41)
            MatriceSpostata(ContaTabelle, 43) = MatriceOriginale(ContaTabelle, 42)
            MatriceSpostata(ContaTabelle, 44) = MatriceOriginale(ContaTabelle, 43)
            MatriceSpostata(ContaTabelle, 45) = MatriceOriginale(ContaTabelle, 44)
            MatriceSpostata(ContaTabelle, 46) = MatriceOriginale(ContaTabelle, 45)
            MatriceSpostata(ContaTabelle, 47) = MatriceOriginale(ContaTabelle, 46)
            MatriceSpostata(ContaTabelle, 48) = MatriceOriginale(ContaTabelle, 47)
            MatriceSpostata(ContaTabelle, 49) = 0 'SE C'ERA QUALCOSA E' STATO SPOSTATO VERSO DESTRA
            MatriceSpostata(ContaTabelle, 50) = MatriceOriginale(ContaTabelle, 49)
            MatriceSpostata(ContaTabelle, 51) = MatriceOriginale(ContaTabelle, 50)
            MatriceSpostata(ContaTabelle, 52) = MatriceOriginale(ContaTabelle, 51)
            MatriceSpostata(ContaTabelle, 53) = MatriceOriginale(ContaTabelle, 52)
            MatriceSpostata(ContaTabelle, 54) = MatriceOriginale(ContaTabelle, 53)
            MatriceSpostata(ContaTabelle, 55) = MatriceOriginale(ContaTabelle, 54)
            MatriceSpostata(ContaTabelle, 56) = MatriceOriginale(ContaTabelle, 55)
            MatriceSpostata(ContaTabelle, 57) = 0 'SE C'ERA QUALCOSA E' STATO SPOSTATO VERSO DESTRA
            MatriceSpostata(ContaTabelle, 58) = MatriceOriginale(ContaTabelle, 57)
            MatriceSpostata(ContaTabelle, 59) = MatriceOriginale(ContaTabelle, 58)
            MatriceSpostata(ContaTabelle, 60) = MatriceOriginale(ContaTabelle, 59)
            MatriceSpostata(ContaTabelle, 61) = MatriceOriginale(ContaTabelle, 60)
            MatriceSpostata(ContaTabelle, 62) = MatriceOriginale(ContaTabelle, 61)
            MatriceSpostata(ContaTabelle, 63) = MatriceOriginale(ContaTabelle, 62)
            MatriceSpostata(ContaTabelle, 64) = MatriceOriginale(ContaTabelle, 63)
            
            'led laterali
            LateraliSpostata(ContaTabelle, 1) = LateraliOriginale(ContaTabelle, 1) 'NON SI SPOSTA
            LateraliSpostata(ContaTabelle, 2) = LateraliOriginale(ContaTabelle, 2) 'NON SI SPOSTA
            LateraliSpostata(ContaTabelle, 3) = LateraliOriginale(ContaTabelle, 3) 'NON SI SPOSTA
            LateraliSpostata(ContaTabelle, 4) = LateraliOriginale(ContaTabelle, 4) 'NON SI SPOSTA
            LateraliSpostata(ContaTabelle, 5) = LateraliOriginale(ContaTabelle, 5) 'NON SI SPOSTA
            LateraliSpostata(ContaTabelle, 6) = LateraliOriginale(ContaTabelle, 6) 'NON SI SPOSTA
            LateraliSpostata(ContaTabelle, 7) = LateraliOriginale(ContaTabelle, 7) 'NON SI SPOSTA
            LateraliSpostata(ContaTabelle, 8) = LateraliOriginale(ContaTabelle, 8) 'NON SI SPOSTA
        Next ContaTabelle
        
        'copio il contenuto della MATRICE Spostata sulla stringa (solo i primi 512 bit - led centrali)
        StringaSpostata = "" 'azzero la stringa da esportare
         For ContaTabelle = 1 To 8
            For ContaLed = 1 To 64
                StringaSpostata = StringaSpostata & MatriceSpostata(ContaTabelle, ContaLed)
            Next ContaLed
        Next ContaTabelle
        'copio il contenuto della MATRICE Spostata sulla stringa (solo gli ultimi 64 bit - led laterali)
        For ContaTabelle = 1 To 8
            For ContaLed = 1 To 8
                StringaSpostata = StringaSpostata & LateraliSpostata(ContaTabelle, ContaLed)
            Next ContaLed
        Next ContaTabelle
    
        'inserisco la stringa subito dopo quella originale
        .Row = PosizioneElemento + 1 'mi sposto alla posizione subito dopo la stringa originale
        .Text = StringaSpostata 'inserisco la stringa Spostata
        
        Call StringToTabellaEditor(.Text) 'riporto il contenuto della stringa sulla tabella
        Call RiempiPosTimelineEditor 'riempo la colonna delle posizioni
        
        .Col = Editor_Timeline_ColStringa 'seleziono la colonna delle stringhe
        .Row = PosizioneElemento + 1
    End With
End Function

Public Function MuoviDestraToSinistra(PosizioneElemento As Integer)
    Dim StringaOriginale As String
    Dim StringaSpostata As String
    Dim MatriceOriginale(1 To 8, 1 To 64) As String
    Dim MatriceSpostata(1 To 8, 1 To 64) As String
    Dim LateraliOriginale(1 To 8, 1 To 8) As String
    Dim LateraliSpostata(1 To 8, 1 To 8) As String
    Dim ContaTabelle As Integer
    Dim ContaLed As Integer
    Dim Posizione As Integer
    
    With FormEditor.Timeline
        .Rows = .Rows + 1 'aggiungo una riga alla timeline
        .Col = Editor_Timeline_ColStringa 'seleziono la colonna delle stringhe
        If PosizioneElemento < .Rows - 1 Then 'se la riga non v aggiunta alla fine
            'scalo gli elementi della timeline fino allo spazio dove v inserito il nuovo elemento
            For i = .Rows - 1 To PosizioneElemento + 2 Step -1
                .Row = i - 1
                StringaDaCopiare = .Text
                .Row = i
                .Text = StringaDaCopiare
            Next i
        End If
        
        .Row = PosizioneElemento 'seleziono la posizione della cella originale
        StringaOriginale = .Text 'copio la stringa originale
        
        'copio la stringa da ruotare nella MATRICE ORIGINALE (solo i primi 512 bit - led centrali)
        For ContaTabelle = 1 To 8
            For ContaLed = 1 To 64
                Posizione = ((ContaTabelle - 1) * 64) + ContaLed
                MatriceOriginale(ContaTabelle, ContaLed) = Mid(StringaOriginale, Posizione, 1)
            Next ContaLed
        Next ContaTabelle
        'copio la stringa da ruotare nella MATRICE ORIGINALE (solo gli ultimi 64 bit - led laterali)
        For ContaTabelle = 1 To 8
            For ContaLed = 1 To 8
                Posizione = 512 + ((ContaTabelle - 1) * 8) + ContaLed
                LateraliOriginale(ContaTabelle, ContaLed) = Mid(StringaOriginale, Posizione, 1)
            Next ContaLed
        Next ContaTabelle
        
        'scambio le posizioni da MATRICE ORIGINALE a MATRICE Spostata
        For ContaTabelle = 1 To 8
            'led centrali
            MatriceSpostata(ContaTabelle, 1) = MatriceOriginale(ContaTabelle, 2)
            MatriceSpostata(ContaTabelle, 2) = MatriceOriginale(ContaTabelle, 3)
            MatriceSpostata(ContaTabelle, 3) = MatriceOriginale(ContaTabelle, 4)
            MatriceSpostata(ContaTabelle, 4) = MatriceOriginale(ContaTabelle, 5)
            MatriceSpostata(ContaTabelle, 5) = MatriceOriginale(ContaTabelle, 6)
            MatriceSpostata(ContaTabelle, 6) = MatriceOriginale(ContaTabelle, 7)
            MatriceSpostata(ContaTabelle, 7) = MatriceOriginale(ContaTabelle, 8)
            MatriceSpostata(ContaTabelle, 8) = 0 'SE C'ERA QUALCOSA E' STATO SPOSTATO VERSO SINISTRA
            MatriceSpostata(ContaTabelle, 9) = MatriceOriginale(ContaTabelle, 10)
            MatriceSpostata(ContaTabelle, 10) = MatriceOriginale(ContaTabelle, 11)
            MatriceSpostata(ContaTabelle, 11) = MatriceOriginale(ContaTabelle, 12)
            MatriceSpostata(ContaTabelle, 12) = MatriceOriginale(ContaTabelle, 13)
            MatriceSpostata(ContaTabelle, 13) = MatriceOriginale(ContaTabelle, 14)
            MatriceSpostata(ContaTabelle, 14) = MatriceOriginale(ContaTabelle, 15)
            MatriceSpostata(ContaTabelle, 15) = MatriceOriginale(ContaTabelle, 16)
            MatriceSpostata(ContaTabelle, 16) = 0 'SE C'ERA QUALCOSA E' STATO SPOSTATO VERSO SINISTRA
            MatriceSpostata(ContaTabelle, 17) = MatriceOriginale(ContaTabelle, 18)
            MatriceSpostata(ContaTabelle, 18) = MatriceOriginale(ContaTabelle, 19)
            MatriceSpostata(ContaTabelle, 19) = MatriceOriginale(ContaTabelle, 20)
            MatriceSpostata(ContaTabelle, 20) = MatriceOriginale(ContaTabelle, 21)
            MatriceSpostata(ContaTabelle, 21) = MatriceOriginale(ContaTabelle, 22)
            MatriceSpostata(ContaTabelle, 22) = MatriceOriginale(ContaTabelle, 23)
            MatriceSpostata(ContaTabelle, 23) = MatriceOriginale(ContaTabelle, 24)
            MatriceSpostata(ContaTabelle, 24) = 0 'SE C'ERA QUALCOSA E' STATO SPOSTATO VERSO SINISTRA
            MatriceSpostata(ContaTabelle, 25) = MatriceOriginale(ContaTabelle, 26)
            MatriceSpostata(ContaTabelle, 26) = MatriceOriginale(ContaTabelle, 27)
            MatriceSpostata(ContaTabelle, 27) = MatriceOriginale(ContaTabelle, 28)
            MatriceSpostata(ContaTabelle, 28) = MatriceOriginale(ContaTabelle, 29)
            MatriceSpostata(ContaTabelle, 29) = MatriceOriginale(ContaTabelle, 30)
            MatriceSpostata(ContaTabelle, 30) = MatriceOriginale(ContaTabelle, 31)
            MatriceSpostata(ContaTabelle, 31) = MatriceOriginale(ContaTabelle, 32)
            MatriceSpostata(ContaTabelle, 32) = 0 'SE C'ERA QUALCOSA E' STATO SPOSTATO VERSO SINISTRA
            MatriceSpostata(ContaTabelle, 33) = MatriceOriginale(ContaTabelle, 34)
            MatriceSpostata(ContaTabelle, 34) = MatriceOriginale(ContaTabelle, 35)
            MatriceSpostata(ContaTabelle, 35) = MatriceOriginale(ContaTabelle, 36)
            MatriceSpostata(ContaTabelle, 36) = MatriceOriginale(ContaTabelle, 37)
            MatriceSpostata(ContaTabelle, 37) = MatriceOriginale(ContaTabelle, 38)
            MatriceSpostata(ContaTabelle, 38) = MatriceOriginale(ContaTabelle, 39)
            MatriceSpostata(ContaTabelle, 39) = MatriceOriginale(ContaTabelle, 40)
            MatriceSpostata(ContaTabelle, 40) = 0 'SE C'ERA QUALCOSA E' STATO SPOSTATO VERSO SINISTRA
            MatriceSpostata(ContaTabelle, 41) = MatriceOriginale(ContaTabelle, 42)
            MatriceSpostata(ContaTabelle, 42) = MatriceOriginale(ContaTabelle, 43)
            MatriceSpostata(ContaTabelle, 43) = MatriceOriginale(ContaTabelle, 44)
            MatriceSpostata(ContaTabelle, 44) = MatriceOriginale(ContaTabelle, 45)
            MatriceSpostata(ContaTabelle, 45) = MatriceOriginale(ContaTabelle, 46)
            MatriceSpostata(ContaTabelle, 46) = MatriceOriginale(ContaTabelle, 47)
            MatriceSpostata(ContaTabelle, 47) = MatriceOriginale(ContaTabelle, 48)
            MatriceSpostata(ContaTabelle, 48) = 0 'SE C'ERA QUALCOSA E' STATO SPOSTATO VERSO SINISTRA
            MatriceSpostata(ContaTabelle, 49) = MatriceOriginale(ContaTabelle, 50)
            MatriceSpostata(ContaTabelle, 50) = MatriceOriginale(ContaTabelle, 51)
            MatriceSpostata(ContaTabelle, 51) = MatriceOriginale(ContaTabelle, 52)
            MatriceSpostata(ContaTabelle, 52) = MatriceOriginale(ContaTabelle, 53)
            MatriceSpostata(ContaTabelle, 53) = MatriceOriginale(ContaTabelle, 54)
            MatriceSpostata(ContaTabelle, 54) = MatriceOriginale(ContaTabelle, 55)
            MatriceSpostata(ContaTabelle, 55) = MatriceOriginale(ContaTabelle, 56)
            MatriceSpostata(ContaTabelle, 56) = 0 'SE C'ERA QUALCOSA E' STATO SPOSTATO VERSO SINISTRA
            MatriceSpostata(ContaTabelle, 57) = MatriceOriginale(ContaTabelle, 58)
            MatriceSpostata(ContaTabelle, 58) = MatriceOriginale(ContaTabelle, 59)
            MatriceSpostata(ContaTabelle, 59) = MatriceOriginale(ContaTabelle, 60)
            MatriceSpostata(ContaTabelle, 60) = MatriceOriginale(ContaTabelle, 61)
            MatriceSpostata(ContaTabelle, 61) = MatriceOriginale(ContaTabelle, 62)
            MatriceSpostata(ContaTabelle, 62) = MatriceOriginale(ContaTabelle, 63)
            MatriceSpostata(ContaTabelle, 63) = MatriceOriginale(ContaTabelle, 64)
            MatriceSpostata(ContaTabelle, 64) = 0 'SE C'ERA QUALCOSA E' STATO SPOSTATO VERSO SINISTRA
            
            'led laterali
            LateraliSpostata(ContaTabelle, 1) = LateraliOriginale(ContaTabelle, 1) 'NON SI SPOSTA
            LateraliSpostata(ContaTabelle, 2) = LateraliOriginale(ContaTabelle, 2) 'NON SI SPOSTA
            LateraliSpostata(ContaTabelle, 3) = LateraliOriginale(ContaTabelle, 3) 'NON SI SPOSTA
            LateraliSpostata(ContaTabelle, 4) = LateraliOriginale(ContaTabelle, 4) 'NON SI SPOSTA
            LateraliSpostata(ContaTabelle, 5) = LateraliOriginale(ContaTabelle, 5) 'NON SI SPOSTA
            LateraliSpostata(ContaTabelle, 6) = LateraliOriginale(ContaTabelle, 6) 'NON SI SPOSTA
            LateraliSpostata(ContaTabelle, 7) = LateraliOriginale(ContaTabelle, 7) 'NON SI SPOSTA
            LateraliSpostata(ContaTabelle, 8) = LateraliOriginale(ContaTabelle, 8) 'NON SI SPOSTA
        Next ContaTabelle
        
        'copio il contenuto della MATRICE Spostata sulla stringa (solo i primi 512 bit - led centrali)
        StringaSpostata = "" 'azzero la stringa da esportare
         For ContaTabelle = 1 To 8
            For ContaLed = 1 To 64
                StringaSpostata = StringaSpostata & MatriceSpostata(ContaTabelle, ContaLed)
            Next ContaLed
        Next ContaTabelle
        'copio il contenuto della MATRICE Spostata sulla stringa (solo gli ultimi 64 bit - led laterali)
        For ContaTabelle = 1 To 8
            For ContaLed = 1 To 8
                StringaSpostata = StringaSpostata & LateraliSpostata(ContaTabelle, ContaLed)
            Next ContaLed
        Next ContaTabelle
    
        'inserisco la stringa subito dopo quella originale
        .Row = PosizioneElemento + 1 'mi sposto alla posizione subito dopo la stringa originale
        .Text = StringaSpostata 'inserisco la stringa Spostata
        
        Call StringToTabellaEditor(.Text) 'riporto il contenuto della stringa sulla tabella
        Call RiempiPosTimelineEditor 'riempo la colonna delle posizioni
        
        .Col = Editor_Timeline_ColStringa 'seleziono la colonna delle stringhe
        .Row = PosizioneElemento + 1
    End With
End Function


