VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "EncoderMP3"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' LAME MP3 Encoder Wrapper

Implements IEncoder


Private Const Extension         As String = "mp3"
Private Const Description       As String = "Lame MP3 Encoder"

Private Const MP3_OUTBUFSIZE    As Long = 20000

Private Enum lame_errorcodes
    LAME_OKAY = 0
    LAME_NOERROR = 0
    LAME_GENERICERROR = -1
    LAME_NOMEM = -10
    LAME_BADBITRATE = -11
    LAME_BADSAMPFREQ = -12
    LAME_INTERNALERROR = -13
End Enum

Public Enum MPEG_mode
    MODE_STEREO = 0
    MODE_JOINT_STEREO
    MODE_DUAL_CHANNEL
    MODE_MONO
    MODE_NOT_SET
    MODE_FORCE_JOINT_STEREO
End Enum

Public Enum VBR_mode
    vbr_off
    vbr_mt
    vbr_rh
    vbr_abr
    vbr_mtrh
    vbr_max_indicator
    vbr_default = vbr_rh
End Enum

Private Enum preset_mode
    ' /*values from 8 to 320 should be reserved for abr bitrates*/
    ' /*for abr I'd suggest to directly use the targeted bitrate as a value*/
    ABR_8 = 8
    ABR_320 = 320

    V9 = 410    ' /*Vx to match Lame and VBR_xx to match FhG*/
    VBR_10 = 410
    V8 = 420
    VBR_20 = 420
    V7 = 430
    VBR_30 = 430
    V6 = 440
    VBR_40 = 440
    V5 = 450
    VBR_50 = 450
    V4 = 460
    VBR_60 = 460
    V3 = 470
    VBR_70 = 470
    V2 = 480
    VBR_80 = 480
    V1 = 490
    VBR_90 = 490
    V0 = 500
    VBR_100 = 500

    ' /*still there for compatibility*/
    R3MIX = 1000
    STANDARD = 1001
    EXTREME = 1002
    INSANE = 1003
    STANDARD_FAST = 1004
    EXTREME_FAST = 1005
    MEDIUM = 1006
    MEDIUAM_FAST = 1007
End Enum

Private Enum short_block
    short_block_not_set = -1
    short_block_allowed = 0
    short_block_coupled = 1
    short_block_dispensed = 2
    short_block_forced = 3
End Enum

Private Enum padding_type
    PAD_NO = 0
    PAD_ALL
    PAD_ADJUST
End Enum

Private Enum asm_optimizations
    ASM_OPT_MMX = 1
    ASM_OPT_3DNOW = 2
    ASM_OPT_SSE = 3
End Enum

Private Enum psycho_model
    PSY_GPSYCHO = 1
    PSY_NSPSYTUNE = 2
End Enum

Private Type lame_version
    major                   As Long
    minor                   As Long
    Alpha                   As Long
    Beta                    As Long

    psy_major               As Long
    psy_minor               As Long
    psy_alpha               As Long
    psy_beta                As Long

    features_ptr            As Long
End Type

Private Type ID3v1
  Tag                       As String * 3
  title                     As String * 30
  Artist                    As String * 30
  album                     As String * 30
  Year                      As String * 4
  Comments                  As String * 28
  filler                    As Byte
  track                     As Byte
  genre                     As Byte
End Type

Private Enum ID3v1_GENRE
    Blues = 0:              ClassicRock = 1
    Country = 2:            Dance = 3
    Disco = 4:              Funk = 5
    Grunge = 6:             HipHop = 7
    Jazz = 8:               Meta = 9
    NewAge = 10:            Oldies = 11
    Other = 12:             Pop = 13
    R_B = 14:               Rap = 15
    Reggae = 16:            Rock = 17
    Techno = 18:            Industrial = 19
    Alternative = 20:       Ska = 21
    DeathMetal = 22:        Pranks = 23
    Soundtrack = 24:        EuroTechno = 25
    Ambient = 26:           TripHop = 27
    Vocal = 28:             JazzFunk = 29
    Fusion = 30:            Trance = 31
    Classical = 32:         Instrumental = 33
    Acid = 34:              House = 35
    Game = 36:              SoundClip = 37
    Gospel = 38:            Noise = 39
    AltRock = 40:           Bas = 41
    Soul = 42:              pUnk = 43
    Space = 44:             Meditative = 45
    InstrumentalPop = 46:   InstrumentalRock = 47
    Ethnic = 48:            Gothic = 49
    Darkwave = 50:          TechnoIndustrial = 51
    Electronic = 52:        PopFolk = 53
    Eurodance = 54:         Dream = 55
    SouthernRock = 56:      Comedy = 57
    Cult = 58:              Gangsta = 59
    Top40 = 60:             ChristianRap = 61
    Pop_Funk = 62:          Jungle = 63
    NativeAmerican = 64:    Cabaret = 65
    NewWave = 66:           Psychadelic = 67
    Rave = 68:              Showtunes = 69
    Trailer = 70:           LoFi = 71
    Tribal = 72:            AcidPunk = 73
    AcidJazz = 74:          Polka = 75
    Retro = 76:             Musical = 77
    RockNRoll = 78:         HardRock = 79
    Folk = 80:              Folk_Rock = 81
    NationalFolk = 82:      Swing = 83
    Fusion1 = 84:           Bebob = 85
    Latin = 86:             Revival = 87
    Celtic = 88:            Bluegrass = 89
    Avantgarde = 90:        GothicRock = 91
    ProgressiveRock = 92:   PsychedelicRock = 93
    SymphonicRock = 94:     SlowRock = 95
    BigBand = 96:           Chorus = 97
    EasyListening = 98:     Acoustic = 99
    Humour = 100:           Speech = 101
    Chanson = 102:          Opera = 103
    ChamberMusic = 104:     Sonata = 105
    Symphony = 106:         BootyBass = 107
    Primus = 108:           PornGroove = 109
    Satire = 110:           SlowJam = 111
    Club = 112:             Tango = 113
    Samba = 114:            Folklore = 115
    GENRE_COUNT = 115
End Enum

Private clsLame             As clsDLL
Private blnReady            As Boolean

Private hFOut               As hFile

Private format_ptr          As Long

Private lngOutSamplerate    As Long
Private lngBitrate          As Long
Private lngQuality          As Long
Private udeMode             As MPEG_mode
Private udeVBR              As VBR_mode
Private blnVBRTag           As Boolean
Private blnVBRForceMin      As Boolean
Private lngVBR_min_bitr     As Long
Private lngVBR_max_bitr     As Long
Private lngVBR_mean_bitr    As Long
Private lngVBR_quality      As Long
Private blnCopyright        As Boolean
Private blnOriginal         As Boolean
Private blnErrorProt        As Boolean
Private blnStrictISO        As Boolean

Private strArtist           As String
Private strAlbum            As String
Private strTitle            As String
Private strGenre            As String
Private strComment          As String
Private strYear             As String
Private btTrackNum          As Byte

''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''

Private Sub Class_Initialize()
    Set clsLame = New clsDLL

    hFOut.handle = INVALID_HANDLE

    blnReady = clsLame.LoadDLL("lame_enc_vb.dll")

    If Not blnReady Then
        clsLame.UnloadDLL
        Exit Sub
    End If

    clsLame.IsCDECL = True

    lngBitrate = 128
    lngQuality = 5
    udeMode = MODE_STEREO
    udeVBR = vbr_rh
    lngVBR_max_bitr = 128
    lngVBR_mean_bitr = 128
    lngVBR_min_bitr = 64
    lngVBR_quality = 5
    blnVBRTag = True
End Sub

Private Sub Class_Terminate()
    clsLame.UnloadDLL
End Sub

''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''

Public Property Get bitrate( _
) As Long

    bitrate = lngBitrate
End Property

Public Property Let bitrate( _
    ByVal lngVal As Long _
)

    lngBitrate = lngVal
End Property

Public Property Get Out_Samplerate( _
) As Long

    Out_Samplerate = lngOutSamplerate
End Property

Public Property Let Out_Samplerate( _
    ByVal lngVal As Long _
)

    lngOutSamplerate = lngVal
End Property

Public Property Get Mode( _
) As MPEG_mode

    Mode = udeMode
End Property

Public Property Let Mode( _
    ByVal udeVal As MPEG_mode _
)

    udeMode = udeVal
End Property

Public Property Get VBR( _
) As VBR_mode

    VBR = udeVBR
End Property

Public Property Let VBR( _
    ByVal udeVal As VBR_mode _
)

    udeVBR = udeVal
End Property

Public Property Get WriteVBRTag( _
) As Boolean

    WriteVBRTag = blnVBRTag
End Property

Public Property Let WriteVBRTag( _
    ByVal blnVal As Boolean _
)

    blnVBRTag = blnVal
End Property

Public Property Get Quality( _
) As Long

    Quality = lngQuality
End Property

Public Property Let Quality( _
    ByVal lngVal As Long _
)

    lngQuality = lngVal
End Property

Public Property Get VBR_max_bitrate( _
) As Long

    VBR_max_bitrate = lngVBR_max_bitr
End Property

Public Property Let VBR_max_bitrate( _
    ByVal lngVal As Long _
)

    lngVBR_max_bitr = lngVal
End Property

Public Property Get VBR_min_bitrate( _
) As Long

    VBR_min_bitrate = lngVBR_min_bitr
End Property

Public Property Let VBR_min_bitrate( _
    ByVal lngVal As Long _
)

    lngVBR_min_bitr = lngVal
End Property

Public Property Get VBR_force_min_bitrate( _
) As Boolean

    VBR_force_min_bitrate = blnVBRForceMin
End Property

Public Property Let VBR_force_min_bitrate( _
    ByVal blnVal As Boolean _
)

    blnVBRForceMin = blnVal
End Property

Public Property Get ABR_bitrate( _
) As Long

    ABR_bitrate = lngVBR_mean_bitr
End Property

Public Property Let ABR_bitrate( _
    ByVal lngVal As Long _
)

    lngVBR_mean_bitr = lngVal
End Property

Public Property Get VBR_Quality( _
) As Long

    VBR_Quality = lngVBR_quality
End Property

Public Property Let VBR_Quality( _
    ByVal lngVal As Long _
)

    lngVBR_quality = lngVal
End Property

Public Property Get StrictISO( _
) As Boolean

    StrictISO = blnStrictISO
End Property

Public Property Let StrictISO( _
    ByVal blnVal As Boolean _
)

    blnStrictISO = blnVal
End Property

Public Property Get ErrorProtection( _
) As Boolean

    ErrorProtection = blnErrorProt
End Property

Public Property Let ErrorProtection( _
    ByVal bln As Boolean _
)

    blnErrorProt = bln
End Property

Public Property Get OriginalBit( _
) As Boolean

    OriginalBit = blnOriginal
End Property

Public Property Let OriginalBit( _
    ByVal blnVal As Boolean _
)

    blnOriginal = blnVal
End Property

Public Property Get CopyrightBit( _
) As Boolean

    CopyrightBit = blnCopyright
End Property

Public Property Let CopyrightBit( _
    ByVal blnVal As Boolean _
)

    blnCopyright = blnVal
End Property

Private Property Get IEncoder_ConfigString( _
) As String

    IEncoder_ConfigString = "MP3CFG " & lngBitrate & " " & _
                                        lngQuality & " " & _
                                        lngVBR_max_bitr & " " & _
                                        lngVBR_mean_bitr & " " & _
                                        lngVBR_min_bitr & " " & _
                                        lngVBR_quality & " " & _
                                        Abs(blnCopyright) & " " & _
                                        Abs(blnErrorProt) & " " & _
                                        Abs(blnOriginal) & " " & _
                                        Abs(blnStrictISO) & " " & _
                                        Abs(blnVBRForceMin) & " " & _
                                        Abs(blnVBRTag) & " " & _
                                        udeMode & " " & _
                                        udeVBR & " " & _
                                        lngOutSamplerate
End Property

Private Property Let IEncoder_ConfigString( _
    ByVal RHS As String _
)

    Dim strParts()  As String

    If InStr(RHS, " ") < 1 Then Exit Property

    strParts = Split(RHS, " ")
    If strParts(0) <> "MP3CFG" Then Exit Property

           lngBitrate = CLng(strParts(1))
           lngQuality = CLng(strParts(2))
      lngVBR_max_bitr = CLng(strParts(3))
     lngVBR_mean_bitr = CLng(strParts(4))
      lngVBR_min_bitr = CLng(strParts(5))
       lngVBR_quality = CLng(strParts(6))
        blnCopyright = CBool(strParts(7))
        blnErrorProt = CBool(strParts(8))
         blnOriginal = CBool(strParts(9))
       blnStrictISO = CBool(strParts(10))
     blnVBRForceMin = CBool(strParts(11))
          blnVBRTag = CBool(strParts(12))
             udeMode = CLng(strParts(13))
              udeVBR = CLng(strParts(14))
    lngOutSamplerate = CLng(strParts(15))
End Property

''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''

Private Function IEncoder_Encode( _
    ByVal buffer_ptr As Long, _
    ByVal buffer_len As Long, _
    buffer_used As Long _
) As SND_RESULT

    Dim btMP3Frames()   As Byte
    Dim lngOutSize      As Long

    Dim lngInSamples    As Long
    Dim lngOutBytes     As Long
    Dim lngWritten      As Long

    If hFOut.handle = INVALID_HANDLE Then
        IEncoder_Encode = SND_ERR_INVALID_OUTPUT
        Exit Function
    End If

    If buffer_len > IEncoder_EncoderMetrics(ENC_M_PCM_PER_DELIVERY_MAX) Then
        IEncoder_Encode = SND_ERR_INVALID_BUFFER
        Exit Function
    End If

    If buffer_len < IEncoder_EncoderMetrics(ENC_M_PCM_PER_DELIVERY_MIN) Then
        IEncoder_Encode = SND_ERR_INVALID_BUFFER
        Exit Function
    End If

    ' worst case estimate
    lngOutSize = 1.25 * (buffer_len / 2#) + 7200#
    ReDim btMP3Frames(lngOutSize - 1) As Byte

    lngInSamples = buffer_len / lame_get_num_channels(format_ptr) / 2

    If lame_get_num_channels(format_ptr) = 2 Then
        ' stereo
        lngOutBytes = lame_encode_buffer_interleaved(format_ptr, _
                                                     buffer_ptr, _
                                                     lngInSamples, _
                                                     VarPtr(btMP3Frames(0)), _
                                                     lngOutSize)
    Else
        ' mono
        lngOutBytes = lame_encode_buffer(format_ptr, _
                                         buffer_ptr, _
                                         0, _
                                         lngInSamples, _
                                         VarPtr(btMP3Frames(0)), _
                                         lngOutSize)
    End If

    If lngOutBytes >= 0 Then
        lngWritten = FileWrite(hFOut, VarPtr(btMP3Frames(0)), lngOutBytes)
        buffer_used = buffer_len

        If lngWritten = lngOutBytes Then
            IEncoder_Encode = SND_ERR_SUCCESS
        Else
            IEncoder_Encode = SND_ERR_WRITE_ERROR
        End If
    End If
End Function

Private Function IEncoder_EncoderClose( _
) As SND_RESULT

    Dim lngBytes        As Long
    Dim strFile         As String
    Dim udtID3          As ID3v1
    Dim btMP3Frames()   As Byte

    If hFOut.handle = INVALID_HANDLE Then
        IEncoder_EncoderClose = SND_ERR_INVALID_OUTPUT
        Exit Function
    End If

    ReDim btMP3Frames(MP3_OUTBUFSIZE - 1) As Byte

    lngBytes = lame_encode_flush_nogap(format_ptr, _
                                       VarPtr(btMP3Frames(0)), _
                                       MP3_OUTBUFSIZE)

    If lngBytes > 0 Then
        FileWrite hFOut, VarPtr(btMP3Frames(0)), lngBytes
    End If

    strFile = hFOut.path
    FileClose hFOut

    If lame_get_bWriteVbrTag(format_ptr) Then
        lame_mp3_tags_fid_ex format_ptr, strFile
    End If

    lame_close format_ptr
    format_ptr = 0

    With udtID3
        .album = strAlbum
        .Artist = strArtist
        .Comments = strComment
        .title = strTitle
        .Year = strYear
        .track = btTrackNum
        .genre = GetID3v1GenreNum(strGenre)
    End With

    WriteID3v1 strFile, udtID3

    IEncoder_EncoderClose = SND_ERR_SUCCESS
End Function

Private Function IEncoder_EncoderInit( _
    ByVal samplerate As Long, _
    ByVal Channels As Integer, _
    ByVal output As String, _
    tags As StreamTags _
) As SND_RESULT

    Dim lngRet  As Long
    Dim i       As Long
    Dim Tag     As StreamTag

    If Not blnReady Then
        IEncoder_EncoderInit = SND_ERR_INTERNAL
        Exit Function
    End If

    If samplerate < 1 Then
        IEncoder_EncoderInit = SND_ERR_INVALID_PARAM
        Exit Function
    End If

    If Channels < 1 Or Channels > 2 Then
        IEncoder_EncoderInit = SND_ERR_INVALID_PARAM
        Exit Function
    End If

    format_ptr = lame_init()

    lame_set_in_samplerate format_ptr, samplerate
    lame_set_num_channels format_ptr, Channels

    If lngOutSamplerate > 0 Then
        lame_set_out_samplerate format_ptr, lngOutSamplerate
    End If

    If Channels = 1 Then
        lame_set_mode format_ptr, MODE_MONO
    Else
        If udeMode = MODE_FORCE_JOINT_STEREO Then
            lame_set_force_ms format_ptr, 1
            lame_set_mode format_ptr, MODE_JOINT_STEREO
        Else
            lame_set_mode format_ptr, udeMode
        End If
    End If

    lame_set_brate format_ptr, lngBitrate
    lame_set_quality format_ptr, lngQuality

    lame_set_VBR format_ptr, udeVBR

    lame_set_VBR_q format_ptr, lngVBR_quality

    lame_set_bWriteVbrTag format_ptr, Abs(blnVBRTag)

    lame_set_VBR_max_bitrate_kbps format_ptr, lngVBR_max_bitr
    lame_set_VBR_min_bitrate_kbps format_ptr, lngVBR_min_bitr
    lame_set_VBR_mean_bitrate_kbps format_ptr, lngVBR_mean_bitr

    lame_set_VBR_hard_min format_ptr, Abs(blnVBRForceMin)

    lame_set_strict_ISO format_ptr, Abs(blnStrictISO)
    lame_set_error_protection format_ptr, Abs(blnErrorProt)
    lame_set_copyright format_ptr, Abs(blnCopyright)
    lame_set_original format_ptr, Abs(blnOriginal)

    lngRet = lame_init_params(format_ptr)

    If lngRet <> LAME_NOERROR Then
        IEncoder_EncoderInit = SND_ERR_INVALID_PARAM
        Exit Function
    End If

    hFOut = FileOpen(output, GENERIC_WRITE, , CREATE_ALWAYS)
    If hFOut.handle = INVALID_HANDLE Then
        IEncoder_EncoderInit = SND_ERR_INVALID_OUTPUT
        Exit Function
    End If

    If Not tags Is Nothing Then
        For i = 1 To tags.TagCount
            Set Tag = tags.TagItem(i)
            Select Case LCase$(Tag.TagName)
                Case "artist": strArtist = Tag.TagValue
                Case "album": strAlbum = Tag.TagValue
                Case "title": strTitle = Tag.TagValue
                Case "year": strYear = Tag.TagValue
                Case "tracknumber": btTrackNum = Tag.TagValue
                Case "comment": strComment = Tag.TagValue
                Case "genre": strGenre = Tag.TagValue
            End Select
        Next
    End If

    IEncoder_EncoderInit = SND_ERR_SUCCESS
End Function

Private Function IEncoder_EncoderMetrics( _
    ByVal info As ENCODER_METRICS _
) As Long

    Select Case True
        Case info = ENC_M_SUPPORT_TAGS
            IEncoder_EncoderMetrics = ENC_TAG_ALBUM Or _
                                      ENC_TAG_ARTIST Or _
                                      ENC_TAG_COMMENT Or _
                                      ENC_TAG_GENRE Or _
                                      ENC_TAG_TITLE Or _
                                      ENC_TAG_TRACK_NUM Or _
                                      ENC_TAG_YEAR

        Case info = ENC_M_PCM_PER_DELIVERY_MIN
            IEncoder_EncoderMetrics = 4

        Case info = ENC_M_PCM_PER_DELIVERY_MAX
            IEncoder_EncoderMetrics = lame_get_in_samplerate(format_ptr) * lame_get_num_channels(format_ptr) * 2

    End Select
End Function

Private Property Get IEncoder_Extension( _
) As String

    IEncoder_Extension = Extension
End Property

Private Property Get IEncoder_Description( _
) As String

    IEncoder_Description = Description
End Property

''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''

Private Sub WriteID3v1( _
    ByVal file As String, _
    Tag As ID3v1 _
)

    Dim fh      As Integer: fh = FreeFile
    Dim udtID   As ID3v1

    Tag.Tag = "TAG"

    Open file For Binary As #fh
        Get #fh, LOF(fh) - 128, udtID
        If udtID.Tag = "TAG" Then
            Put #fh, LOF(fh) - 128, Tag
        Else
            Put #fh, LOF(fh), Tag
        End If
    Close #fh
End Sub

''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''

' Lame Wrapper

Private Function lame_init( _
) As Long

    lame_init = clsLame.CallFunc("lame_init")
End Function

Private Function lame_set_num_samples( _
    ByVal lgs As Long, _
    ByVal samples As Long _
) As Long

    lame_set_num_samples = clsLame.CallFunc("lame_set_num_samples", _
                                            lgs, _
                                            samples)
End Function

Private Function lame_get_num_samples( _
    ByVal lgs As Long _
) As Long

    lame_get_num_samples = clsLame.CallFunc("lame_get_num_samples", lgs)
End Function

Private Function lame_set_in_samplerate( _
    ByVal lgs As Long, _
    ByVal samplerate As Long _
) As Long

    lame_set_in_samplerate = clsLame.CallFunc("lame_set_in_samplerate", _
                                              lgs, _
                                              samplerate)
End Function

Private Function lame_get_in_samplerate( _
    ByVal lgs As Long _
) As Long

    lame_get_in_samplerate = clsLame.CallFunc("lame_get_in_samplerate", lgs)
End Function

Private Function lame_set_num_channels( _
    ByVal lgs As Long, _
    ByVal Channels As Long _
) As Long

    lame_set_num_channels = clsLame.CallFunc("lame_set_num_channels", _
                                             lgs, _
                                             Channels)
End Function

Private Function lame_get_num_channels( _
    ByVal lgs As Long _
) As Long

    lame_get_num_channels = clsLame.CallFunc("lame_get_num_channels", lgs)
End Function

Private Function lame_set_scale( _
    ByVal lgs As Long, _
    ByVal fscale As Single _
) As Long

    Dim flng    As Long

    CpyMem flng, fscale, 4

    lame_set_scale = clsLame.CallFunc("lame_set_scale", lgs, flng)
End Function

Private Function lame_get_scale( _
    ByVal lgs As Long _
) As Single

    Dim flng    As Long
    Dim F       As Single

    flng = clsLame.CallFunc("lame_get_scale", lgs)

    CpyMem F, flng, 4

    lame_get_scale = F
End Function

Private Function lame_set_scale_left( _
    ByVal lgs As Long, _
    ByVal fscale As Single _
) As Long

    Dim flng    As Long

    CpyMem flng, fscale, 4

    lame_set_scale_left = clsLame.CallFunc("lame_set_scale_left", lgs, flng)
End Function

Private Function lame_set_scale_right( _
    ByVal lgs As Long, _
    ByVal fscale As Single _
) As Long

    Dim flng    As Long

    CpyMem flng, fscale, 4

    lame_set_scale_right = clsLame.CallFunc("lame_set_scale_right", lgs, flng)
End Function

Private Function lame_get_scale_left( _
    ByVal lgs As Long _
) As Single

    Dim flng    As Long
    Dim F       As Single

    flng = clsLame.CallFunc("lame_get_scale_left", lgs)

    CpyMem F, flng, 4

    lame_get_scale_left = F
End Function

Private Function lame_get_scale_right( _
    ByVal lgs As Long _
) As Single

    Dim flng    As Long
    Dim F       As Single

    flng = clsLame.CallFunc("lame_get_scale_right", lgs)

    CpyMem F, flng, 4

    lame_get_scale_right = F
End Function

Private Function lame_set_out_samplerate( _
    ByVal lgs As Long, _
    ByVal samplerate As Long _
) As Long

    lame_set_out_samplerate = clsLame.CallFunc("lame_set_out_samplerate", _
                                               lgs, _
                                               samplerate)
End Function

Private Function lame_get_out_samplerate( _
    ByVal lgs As Long _
) As Long

    lame_get_out_samplerate = clsLame.CallFunc("lame_get_out_samplerate", lgs)
End Function

Private Function lame_init_params( _
    ByVal lgs As Long _
) As Long

    lame_init_params = clsLame.CallFunc("lame_init_params", lgs)
End Function

Private Function lame_encode_buffer( _
    ByVal lgs As Long, _
    ByVal buffer_l As Long, _
    ByVal buffer_r As Long, _
    ByVal nsamples As Long, _
    ByVal mp3_buf_ptr As Long, _
    ByVal mp3buf_size As Long _
) As Long

    lame_encode_buffer = clsLame.CallFunc("lame_encode_buffer", _
                                          lgs, _
                                          buffer_l, _
                                          buffer_r, _
                                          nsamples, _
                                          mp3_buf_ptr, _
                                          mp3buf_size)
End Function

Private Function lame_encode_buffer_interleaved( _
    ByVal lgs As Long, _
    ByVal pcm_buf_ptr As Long, _
    ByVal num_samples As Long, _
    ByVal mp3_buf_ptr As Long, _
    ByVal mp3buf_size As Long _
) As Long

    lame_encode_buffer_interleaved = clsLame.CallFunc("lame_encode_buffer_interleaved", _
                                                      lgs, _
                                                      pcm_buf_ptr, _
                                                      num_samples, _
                                                      mp3_buf_ptr, _
                                                      mp3buf_size)
End Function

Private Function lame_encode_flush( _
    ByVal lgs As Long, _
    mp3buf_ptr As Long, _
    ByVal size As Long _
) As Long

    lame_encode_flush = clsLame.CallFunc("lame_encode_flush", _
                                         lgs, _
                                         mp3buf_ptr, _
                                         size)
End Function

Private Function lame_mp3_tags_fid( _
    ByVal lgs As Long, _
    ByVal c_hFile As Long _
) As Long

    lame_mp3_tags_fid = clsLame.CallFunc("lame_mp3_tags_fid", lgs, c_hFile)
End Function

Private Function lame_mp3_tags_fid_ex( _
    ByVal lgs As Long, _
    ByVal strFile As String _
) As Long

    Dim btFile()    As Byte

    btFile = StrConv(strFile & Chr$(0), vbFromUnicode)

    lame_mp3_tags_fid_ex = clsLame.CallFunc("lame_mp3_tags_fid_ex", _
                                            lgs, _
                                            VarPtr(btFile(0)))
End Function

Private Function lame_close( _
    ByVal lgs As Long _
) As Long

    lame_close = clsLame.CallFunc("lame_close", lgs)
End Function

Private Function lame_set_analysis( _
    ByVal lgs As Long, _
    ByVal analysis As Long _
) As Long

    lame_set_analysis = clsLame.CallFunc("lame_set_analysis", lgs, analysis)
End Function

Private Function lame_get_analysis( _
    ByVal lgs As Long _
) As Long

    lame_get_analysis = clsLame.CallFunc("lame_get_analysis", lgs)
End Function

Private Function lame_set_bWriteVbrTag( _
    ByVal lgs As Long, _
    ByVal WriteVBRTag As Long _
) As Long

    lame_set_bWriteVbrTag = clsLame.CallFunc("lame_set_bWriteVbrTag", _
                                             lgs, WriteVBRTag)
End Function

Private Function lame_get_bWriteVbrTag( _
    ByVal lgs As Long _
) As Long

    lame_get_bWriteVbrTag = clsLame.CallFunc("lame_get_bWriteVbrTag", lgs)
End Function

Private Function lame_set_quality( _
    ByVal lgs As Long, _
    ByVal Quality As Long _
) As Long

    lame_set_quality = clsLame.CallFunc("lame_set_quality", lgs, Quality)
End Function

Private Function lame_get_quality( _
    ByVal lgs As Long _
) As Long

    lame_get_quality = clsLame.CallFunc("lame_get_quality", lgs)
End Function

Private Function lame_set_mode( _
    ByVal lgs As Long, _
    ByVal Mode As MPEG_mode _
) As Long

    lame_set_mode = clsLame.CallFunc("lame_set_mode", lgs, Mode)
End Function

Private Function lame_get_mode( _
    ByVal lgs As Long _
) As MPEG_mode

    lame_get_mode = clsLame.CallFunc("lame_get_mode", lgs)
End Function

Private Function lame_set_force_ms( _
    ByVal lgs As Long, _
    ByVal forcems As Long _
) As Long

    lame_set_force_ms = clsLame.CallFunc("lame_set_force_ms", lgs, forcems)
End Function

Private Function lame_get_force_ms( _
    ByVal lgs As Long _
) As Long

    lame_get_force_ms = clsLame.CallFunc("lame_get_force_ms", lgs)
End Function

Private Function lame_set_free_format( _
    ByVal lgs As Long, _
    ByVal freeformat As Long _
) As Long

    lame_set_free_format = clsLame.CallFunc("lame_set_free_format", _
                                            lgs, freeformat)
End Function

Private Function lame_get_free_format( _
    ByVal lgs As Long _
) As Long

    lame_get_free_format = clsLame.CallFunc("lame_get_free_format", lgs)
End Function

Private Function lame_set_nogap_total( _
    ByVal lgs As Long, _
    ByVal the_nogap_total As Long _
) As Long

    lame_set_nogap_total = clsLame.CallFunc("lame_set_nogap_total", _
                                            lgs, the_nogap_total)
End Function

Private Function lame_get_nogap_total( _
    ByVal lgs As Long _
) As Long

    lame_get_nogap_total = clsLame.CallFunc("lame_get_nogap_total", lgs)
End Function

Private Function lame_set_nogap_currentindex( _
    ByVal lgs As Long, _
    ByVal the_nogap_index As Long _
) As Long

    lame_set_nogap_currentindex = clsLame.CallFunc("lame_set_nogap_currentindex", _
                                                   lgs, the_nogap_index)
End Function

Private Function lame_get_nogap_currentindex( _
    ByVal lgs As Long _
) As Long

    lame_get_nogap_currentindex = clsLame.CallFunc("lame_get_nogap_currentindex", _
                                                   lgs)
End Function

Private Function lame_set_brate( _
    ByVal lgs As Long, _
    ByVal bitrate As Long _
) As Long

    lame_set_brate = clsLame.CallFunc("lame_set_brate", lgs, bitrate)
End Function

Private Function lame_get_brate( _
    ByVal lgs As Long _
) As Long

    lame_get_brate = clsLame.CallFunc("lame_get_brate", lgs)
End Function

Private Function lame_set_compression_ratio( _
    ByVal lgs As Long, _
    ByVal ratio As Single _
) As Long

    Dim flng    As Long

    CpyMem flng, ratio, 4

    lame_set_compression_ratio = clsLame.CallFunc("lame_set_compression_ratio", _
                                                  lgs, flng)
End Function

Private Function lame_get_compression_ratio( _
    ByVal lgs As Long _
) As Single

    Dim F       As Single
    Dim flng    As Long

    flng = clsLame.CallFunc("lame_get_compression_ratio", lgs)

    CpyMem F, flng, 4

    lame_get_compression_ratio = F
End Function

Private Function lame_set_preset( _
    ByVal lgs As Long, _
    ByVal preset As Long _
) As Long

    lame_set_preset = clsLame.CallFunc("lame_set_preset", lgs, preset)
End Function

Private Function lame_set_asm_optimizations( _
    ByVal lgs As Long, _
    ByVal optim As asm_optimizations, _
    ByVal Mode As Long _
) As Long

    lame_set_asm_optimizations = clsLame.CallFunc("lame_set_asm_optimizations", _
                                                  lgs, optim, Mode)
End Function

Private Function lame_set_copyright( _
    ByVal lgs As Long, _
    ByVal cpyright As Long _
) As Long

    lame_set_copyright = clsLame.CallFunc("lame_set_copyright", lgs, cpyright)
End Function

Private Function lame_get_copyright( _
    ByVal lgs As Long _
) As Long

    lame_get_copyright = clsLame.CallFunc("lame_get_copyright", lgs)
End Function

Private Function lame_set_original( _
    ByVal lgs As Long, _
    ByVal original As Long _
) As Long

    lame_set_original = clsLame.CallFunc("lame_set_original", lgs, original)
End Function

Private Function lame_get_original( _
    ByVal lgs As Long _
) As Long

    lame_get_original = clsLame.CallFunc("lame_get_original", lgs)
End Function

Private Function lame_set_error_protection( _
    ByVal lgs As Long, _
    ByVal crc As Long _
) As Long

    lame_set_error_protection = clsLame.CallFunc("lame_set_error_protection", _
                                                 lgs, crc)
End Function

Private Function lame_get_error_protection( _
    ByVal lgs As Long _
) As Long

    lame_get_error_protection = clsLame.CallFunc("lame_get_error_protection", _
                                                 lgs)
End Function

Private Function lame_set_padding_type( _
    ByVal lgs As Long, _
    ByVal paddingtype As padding_type _
) As Long

    lame_set_padding_type = clsLame.CallFunc("lame_set_padding_type", _
                                             lgs, paddingtype)
End Function

Private Function lame_get_padding_type( _
    ByVal lgs As Long _
) As padding_type

    lame_get_padding_type = clsLame.CallFunc("lame_get_padding_type", lgs)
End Function

Private Function lame_set_extension( _
    ByVal lgs As Long, _
    ByVal priv_ext As Long _
) As Long

    lame_set_extension = clsLame.CallFunc("lame_set_extension", lgs, priv_ext)
End Function

Private Function lame_get_extension( _
    ByVal lgs As Long _
) As Long

    lame_get_extension = clsLame.CallFunc("lame_get_extension", lgs)
End Function

Private Function lame_set_strict_ISO( _
    ByVal lgs As Long, _
    ByVal strict_iso As Long _
) As Long

    lame_set_strict_ISO = clsLame.CallFunc("lame_set_strict_ISO", _
                                           lgs, strict_iso)
End Function

Private Function lame_get_strict_ISO( _
    ByVal lgs As Long _
) As Long

    lame_get_strict_ISO = clsLame.CallFunc("lame_get_strict_ISO", lgs)
End Function

Private Function lame_set_VBR( _
    ByVal lgs As Long, _
    ByVal Mode As VBR_mode _
) As Long

    lame_set_VBR = clsLame.CallFunc("lame_set_VBR", lgs, Mode)
End Function

Private Function lame_get_VBR( _
    ByVal lgs As Long _
) As VBR_mode

    lame_get_VBR = clsLame.CallFunc("lame_get_VBR", lgs)
End Function

Private Function lame_set_VBR_q( _
    ByVal lgs As Long, _
    ByVal q As Long _
) As Long

    lame_set_VBR_q = clsLame.CallFunc("lame_set_VBR_q", lgs, q)
End Function

Private Function lame_get_VBR_q( _
    ByVal lgs As Long _
) As Long

    lame_get_VBR_q = clsLame.CallFunc("lame_get_VBR_q", lgs)
End Function

Private Function lame_set_VBR_mean_bitrate_kbps( _
    ByVal lgs As Long, _
    ByVal bitrate As Long _
) As Long

    lame_set_VBR_mean_bitrate_kbps = clsLame.CallFunc("lame_set_VBR_mean_bitrate_kbps", _
                                                      lgs, bitrate)
End Function

Private Function lame_get_VBR_mean_bitrate_kbps( _
    ByVal lgs As Long _
) As Long

    lame_get_VBR_mean_bitrate_kbps = clsLame.CallFunc("lame_get_VBR_mean_bitrate_kbps", _
                                                      lgs)
End Function

Private Function lame_set_VBR_min_bitrate_kbps( _
    ByVal lgs As Long, _
    ByVal bitrate As Long _
) As Long

    lame_set_VBR_min_bitrate_kbps = clsLame.CallFunc("lame_set_VBR_min_bitrate_kbps", _
                                                     lgs, bitrate)
End Function

Private Function lame_get_VBR_min_bitrate_kbps( _
    ByVal lgs As Long _
) As Long

    lame_get_VBR_min_bitrate_kbps = clsLame.CallFunc("lame_get_VBR_min_bitrate_kbps", _
                                                     lgs)
End Function

Private Function lame_set_VBR_max_bitrate_kbps( _
    ByVal lgs As Long, _
    ByVal bitrate As Long _
) As Long

    lame_set_VBR_max_bitrate_kbps = clsLame.CallFunc("lame_set_VBR_max_bitrate_kbps", _
                                                     lgs, bitrate)
End Function

Private Function lame_get_VBR_max_bitrate_kbps( _
    ByVal lgs As Long _
) As Long

    lame_get_VBR_max_bitrate_kbps = clsLame.CallFunc("lame_get_VBR_max_bitrate_kbps", _
                                                     lgs)
End Function

Private Function lame_set_VBR_hard_min( _
    ByVal lgs As Long, _
    ByVal bitrate As Long _
) As Long

    lame_set_VBR_hard_min = clsLame.CallFunc("lame_set_VBR_hard_min", _
                                             lgs, bitrate)
End Function

Private Function lame_get_VBR_hard_min( _
    ByVal lgs As Long _
) As Long

    lame_get_VBR_hard_min = clsLame.CallFunc("lame_get_VBR_hard_min", lgs)
End Function

Private Function lame_set_preset_expopts( _
    ByVal lgs As Long, _
    ByVal preset_expopts As Long _
) As Long

    lame_set_preset_expopts = clsLame.CallFunc("lame_set_preset_expopts", _
                                               lgs, preset_expopts)
End Function

Private Function lame_set_lowpassfreq( _
    ByVal lgs As Long, _
    ByVal lowpassfreq As Long _
) As Long

    lame_set_lowpassfreq = clsLame.CallFunc("lame_set_lowpassfreq", _
                                            lgs, lowpassfreq)
End Function

Private Function lame_get_lowpassfreq( _
    ByVal lgs As Long _
) As Long

    lame_get_lowpassfreq = clsLame.CallFunc("lame_get_lowpassfreq", lgs)
End Function

Private Function lame_set_lowpasswidth( _
    ByVal lgs As Long, _
    ByVal passwidth As Long _
) As Long

    lame_set_lowpasswidth = clsLame.CallFunc("lame_set_lowpasswidth", _
                                             lgs, passwidth)
End Function

Private Function lame_get_lowpasswidth( _
    ByVal lgs As Long _
) As Long

    lame_get_lowpasswidth = clsLame.CallFunc("lame_get_lowpasswidth", lgs)
End Function

Private Function lame_set_highpassfreq( _
    ByVal lgs As Long, _
    ByVal highpassfreq As Long _
) As Long

    lame_set_highpassfreq = clsLame.CallFunc("lame_set_highpassfreq", _
                                             lgs, highpassfreq)
End Function

Private Function lame_get_highpassfreq( _
    ByVal lgs As Long _
) As Long

    lame_get_highpassfreq = clsLame.CallFunc("lame_get_highpassfreq", lgs)
End Function

Private Function lame_set_highpasswidth( _
    ByVal lgs As Long, _
    ByVal passwidth As Long _
) As Long

    lame_set_highpasswidth = clsLame.CallFunc("lame_set_highpasswidth", _
                                              lgs, passwidth)
End Function

Private Function lame_get_highpasswidth( _
    ByVal lgs As Long _
) As Long

    lame_get_highpasswidth = clsLame.CallFunc("lame_get_highpasswidth", lgs)
End Function

Private Function lame_set_no_short_blocks( _
    ByVal lgs As Long, _
    ByVal no_short_blocks As Long _
) As Long

    lame_set_no_short_blocks = clsLame.CallFunc("lame_set_no_short_blocks", _
                                                lgs, no_short_blocks)
End Function

Private Function lame_get_no_short_blocks( _
    ByVal lgs As Long _
) As Long

    lame_get_no_short_blocks = clsLame.CallFunc("lame_get_no_short_blocks", lgs)
End Function

Private Function lame_set_force_short_blocks( _
    ByVal lgs As Long, _
    ByVal fsb As Long _
) As Long

    lame_set_force_short_blocks = clsLame.CallFunc("lame_set_force_short_blocks", _
                                                   lgs, fsb)
End Function

Private Function lame_get_force_short_blocks( _
    ByVal lgs As Long _
) As Long

    lame_get_force_short_blocks = clsLame.CallFunc("lame_get_force_short_blocks", lgs)
End Function

Private Function lame_get_encoder_delay( _
    ByVal lgs As Long _
) As Long

    lame_get_encoder_delay = clsLame.CallFunc("lame_get_encoder_delay", lgs)
End Function

Private Function lame_get_encoder_padding( _
    ByVal lgs As Long _
) As Long

    lame_get_encoder_padding = clsLame.CallFunc("lame_get_encoder_padding", lgs)
End Function

Private Function lame_get_framesize( _
    ByVal lgs As Long _
) As Long

    lame_get_framesize = clsLame.CallFunc("lame_get_framesize", lgs)
End Function

Private Function lame_get_mf_samples_to_encode( _
    ByVal lgs As Long _
) As Long

    lame_get_mf_samples_to_encode = clsLame.CallFunc("lame_get_mf_samples_to_encode", _
                                                     lgs)
End Function

Private Function lame_get_size_mp3buffer( _
    ByVal lgs As Long _
) As Long

    lame_get_size_mp3buffer = clsLame.CallFunc("lame_get_size_mp3buffer", lgs)
End Function

Private Function lame_get_frameNum( _
    ByVal lgs As Long _
) As Long

    lame_get_frameNum = clsLame.CallFunc("lame_get_frameNum", lgs)
End Function

Private Function lame_get_totalframes( _
    ByVal lgs As Long _
) As Long

    lame_get_totalframes = clsLame.CallFunc("lame_get_totalframes", lgs)
End Function

Private Function lame_get_PeakSample( _
    ByVal lgs As Long _
) As Long

    lame_get_PeakSample = clsLame.CallFunc("lame_get_PeakSample", lgs)
End Function

Private Function lame_get_noclipGainChange( _
    ByVal lgs As Long _
) As Long

    lame_get_noclipGainChange = clsLame.CallFunc("lame_get_noclipGainChange", _
                                                 lgs)
End Function

Private Function lame_get_noclipScale( _
    ByVal lgs As Long _
) As Long

    lame_get_noclipScale = clsLame.CallFunc("lame_get_noclipScale", lgs)
End Function

Private Function get_lame_version( _
) As String

    get_lame_version = Ptr2Str(clsLame.CallFunc("get_lame_version"))
End Function

Private Function get_lame_short_version( _
) As String

    get_lame_short_version = Ptr2Str(clsLame.CallFunc("get_lame_short_version"))
End Function

Private Function get_lame_very_short_version( _
) As String

    get_lame_very_short_version = Ptr2Str(clsLame.CallFunc("get_lame_very_short_version"))
End Function

Private Function get_psy_version( _
) As String

    get_psy_version = Ptr2Str(clsLame.CallFunc("get_psy_version"))
End Function

Private Function get_lame_url( _
) As String

    get_lame_url = Ptr2Str(clsLame.CallFunc("get_lame_url"))
End Function

Private Sub get_lame_version_numerical( _
    udtVersion As lame_version _
)

    clsLame.CallFunc "get_lame_version_numerical", VarPtr(udtVersion)
End Sub

Private Function lame_encode_flush_nogap( _
    ByVal lgs As Long, _
    ByVal mp3buf_ptr As Long, _
    ByVal size As Long _
) As Long

    lame_encode_flush_nogap = clsLame.CallFunc("lame_encode_flush_nogap", _
                                               lgs, mp3buf_ptr, size)
End Function

'''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''

Private Function GetID3v1GenreNum( _
    ByVal strGenre As String _
) As ID3v1_GENRE

    Dim i   As Long

    For i = 0 To GENRE_COUNT
        If StrComp(strGenre, GetID3v1Genre(i), vbTextCompare) = 0 Then
            GetID3v1GenreNum = i
            Exit Function
        End If
    Next

    GetID3v1GenreNum = 255
End Function

Private Function GetID3v1Genre( _
    ByVal genre As ID3v1_GENRE _
) As String

    Dim strReturn   As String

    Select Case genre
        Case Blues:             strReturn = "Blues"
        Case ClassicRock:       strReturn = "ClassicRock"
        Case Country:           strReturn = "Country"
        Case Dance:             strReturn = "Dance"
        Case Disco:             strReturn = "Disco"
        Case Funk:              strReturn = "Funk"
        Case Grunge:            strReturn = "Grunge"
        Case HipHop:            strReturn = "HipHop"
        Case Jazz:              strReturn = "Jazz"
        Case Meta:              strReturn = "Meta"
        Case NewAge:            strReturn = "NewAge"
        Case Oldies:            strReturn = "Oldies"
        Case Other:             strReturn = "Other"
        Case Pop:               strReturn = "Pop"
        Case R_B:               strReturn = "R_B"
        Case Rap:               strReturn = "Rap"
        Case Reggae:            strReturn = "Reggae"
        Case Rock:              strReturn = "Rock"
        Case Techno:            strReturn = "Techno"
        Case Industrial:        strReturn = "Industrial"
        Case Alternative:       strReturn = "Alternative"
        Case Ska:               strReturn = "Ska"
        Case DeathMetal:        strReturn = "DeathMetal"
        Case Pranks:            strReturn = "Pranks"
        Case Soundtrack:        strReturn = "Soundtrack"
        Case EuroTechno:        strReturn = "EuroTechno"
        Case Ambient:           strReturn = "Ambient"
        Case TripHop:           strReturn = "TripHop"
        Case Vocal:             strReturn = "Vocal"
        Case JazzFunk:          strReturn = "JazzFunk"
        Case Fusion:            strReturn = "Fusion"
        Case Trance:            strReturn = "Trance"
        Case Classical:         strReturn = "Classical"
        Case Instrumental:      strReturn = "Instrumental"
        Case Acid:              strReturn = "Acid"
        Case House:             strReturn = "House"
        Case Game:              strReturn = "Game"
        Case SoundClip:         strReturn = "SoundClip"
        Case Gospel:            strReturn = "Gospel"
        Case Noise:             strReturn = "Noise"
        Case AltRock:           strReturn = "AltRock"
        Case Bas:               strReturn = "Bas"
        Case Soul:              strReturn = "Soul"
        Case pUnk:              strReturn = "Punk"
        Case Space:             strReturn = "Space"
        Case Meditative:        strReturn = "Meditative"
        Case InstrumentalPop:   strReturn = "InstrumentalPop"
        Case InstrumentalRock:  strReturn = "InstrumentalRock"
        Case Ethnic:            strReturn = "Ethnic"
        Case Gothic:            strReturn = "Gothic"
        Case Darkwave:          strReturn = "Darkwave"
        Case TechnoIndustrial:  strReturn = "TechnoIndustrial"
        Case Electronic:        strReturn = "Electronic"
        Case PopFolk:           strReturn = "PopFolk"
        Case Eurodance:         strReturn = "Eurodance"
        Case Dream:             strReturn = "Dream"
        Case SouthernRock:      strReturn = "SouthernRock"
        Case Comedy:            strReturn = "Comedy"
        Case Cult:              strReturn = "Cult"
        Case Gangsta:           strReturn = "Gangsta"
        Case Top40:             strReturn = "Top40"
        Case ChristianRap:      strReturn = "ChristianRap"
        Case Pop_Funk:          strReturn = "Pop_Funk"
        Case Jungle:            strReturn = "Jungle"
        Case NativeAmerican:    strReturn = "NativeAmerican"
        Case Cabaret:           strReturn = "Cabaret"
        Case NewWave:           strReturn = "NewWave"
        Case Psychadelic:       strReturn = "Psychadelic"
        Case Rave:              strReturn = "Rave"
        Case Showtunes:         strReturn = "Showtunes"
        Case Trailer:           strReturn = "Trailer"
        Case LoFi:              strReturn = "LoFi"
        Case Tribal:            strReturn = "Tribal"
        Case AcidPunk:          strReturn = "AcidPunk"
        Case AcidJazz:          strReturn = "AcidJazz"
        Case Polka:             strReturn = "Polka"
        Case Retro:             strReturn = "Retro"
        Case Musical:           strReturn = "Musical"
        Case RockNRoll:         strReturn = "RockNRoll"
        Case HardRock:          strReturn = "HardRock"
        Case Folk:              strReturn = "Folk"
        Case Folk_Rock:         strReturn = "Folk_Rock"
        Case NationalFolk:      strReturn = "NationalFolk"
        Case Swing:             strReturn = "Swing"
        Case Fusion1:           strReturn = "Fusion1"
        Case Bebob:             strReturn = "Bebob"
        Case Latin:             strReturn = "Latin"
        Case Revival:           strReturn = "Revival"
        Case Celtic:            strReturn = "Celtic"
        Case Bluegrass:         strReturn = "Bluegrass"
        Case Avantgarde:        strReturn = "Avantgarde"
        Case GothicRock:        strReturn = "GothicRock"
        Case ProgressiveRock:   strReturn = "ProgressiveRock"
        Case PsychedelicRock:   strReturn = "PsychedelicRock"
        Case SymphonicRock:     strReturn = "SymphonicRock"
        Case SlowRock:          strReturn = "SlowRock"
        Case BigBand:           strReturn = "BigBand"
        Case Chorus:            strReturn = "Chorus"
        Case EasyListening:     strReturn = "EasyListening"
        Case Acoustic:          strReturn = "Acoustic"
        Case Humour:            strReturn = "Humour"
        Case Speech:            strReturn = "Speech"
        Case Chanson:           strReturn = "Chanson"
        Case Opera:             strReturn = "Opera"
        Case ChamberMusic:      strReturn = "ChamberMusic"
        Case Sonata:            strReturn = "Sonata"
        Case Symphony:          strReturn = "Symphony"
        Case BootyBass:         strReturn = "BootyBass"
        Case Primus:            strReturn = "Primus"
        Case PornGroove:        strReturn = "PornGroove"
        Case Satire:            strReturn = "Satire"
        Case SlowJam:           strReturn = "SlowJam"
        Case Club:              strReturn = "Club"
        Case Tango:             strReturn = "Tango"
        Case Samba:             strReturn = "Samba"
        Case Folklore:          strReturn = "Folklore"
    End Select

    GetID3v1Genre = strReturn
End Function
