VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "EncoderWAV"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Implements IEncoder


Private Const Extension As String = "wav"
Private Const Description As String = "Wave ACM Encoder"


Private Const ACMFORMATDETAILS_FORMAT_CHARS         As Long = 128

Private Const ACMFORMATTAGDETAILS_FORMATTAG_CHARS   As Long = 48

Private Const ACM_FORMATENUMF_CONVERT               As Long = &H100000

Private Const MM_ACM_FORMATCHOOSE                   As Long = &H8000

Private Const FORMATCHOOSE_MESSAGE                  As Long = 0
Private Const FORMATCHOOSE_FORMATTAG_VERIFY         As Long = (FORMATCHOOSE_MESSAGE + 0)
Private Const FORMATCHOOSE_FORMAT_VERIFY            As Long = (FORMATCHOOSE_MESSAGE + 1)
Private Const FORMATCHOOSE_CUSTOM_VERIFY            As Long = (FORMATCHOOSE_MESSAGE + 2)

Private Const ACMFORMATCHOOSE_STYLEF_SHOWHELP             As Long = &H4
Private Const ACMFORMATCHOOSE_STYLEF_ENABLEHOOK           As Long = &H8
Private Const ACMFORMATCHOOSE_STYLEF_ENABLETEMPLATE       As Long = &H10
Private Const ACMFORMATCHOOSE_STYLEF_ENABLETEMPLATEHANDLE As Long = &H20
Private Const ACMFORMATCHOOSE_STYLEF_INITTOWFXSTRUCT      As Long = &H40
Private Const ACMFORMATCHOOSE_STYLEF_CONTEXTHELP          As Long = &H80

Private Declare Function acmStreamPrepareHeader Lib "msacm32" ( _
    ByVal has As Long, _
    pash As ACMSTREAMHEADER, _
    ByVal fdwPrepare As Long _
) As Long

Private Declare Function acmStreamUnprepareHeader Lib "msacm32" ( _
    ByVal has As Long, _
    pash As ACMSTREAMHEADER, _
    ByVal fdwUnprepare As Long _
) As Long

Private Declare Function acmStreamOpen Lib "msacm32" ( _
    phas As Long, _
    ByVal had As Long, _
    pwfxSrc As Any, _
    pwfxDst As Any, _
    ByVal pwfltr As Long, _
    ByVal dwCallback As Long, _
    ByVal dwInstance As Long, _
    ByVal fdwOpen As Long _
) As Long

Private Declare Function acmStreamSize Lib "msacm32" ( _
    ByVal has As Long, _
    ByVal cbInput As Long, _
    pdwOutputBytes As Long, _
    ByVal fdwSize As Long _
) As Long

Private Declare Function acmStreamConvert Lib "msacm32" ( _
    ByVal has As Long, _
    pash As ACMSTREAMHEADER, _
    ByVal fdwConvert As Long _
) As Long

Private Declare Function acmStreamReset Lib "msacm32" ( _
    ByVal has As Long, _
    ByVal fdwReset As Long _
) As Long

Private Declare Function acmStreamClose Lib "msacm32" ( _
    ByVal has As Long, _
    ByVal fdwClose As Long _
) As Long

Private Declare Function acmFormatChoose Lib "msacm32" _
Alias "acmFormatChooseA" ( _
    pfmtc As ACMFORMATCHOOSEA _
) As Long

Private Type ACMSTREAMHEADER
    cbStruct                    As Long
    fdwStatus                   As Long
    dwUser                      As Long
    pbSrc                       As Long
    cbSrcLength                 As Long
    cbSrcLengthUsed             As Long
    dwSrcUser                   As Long
    pbDst                       As Long
    cbDstLength                 As Long
    cbDstLengthUsed             As Long
    dwDstUser                   As Long
    dwReservedDriver(9)         As Long
End Type

Private Type ACMFORMATCHOOSEA
    cbStruct                    As Long
    fdwStyle                    As Long
    hwndOwner                   As Long
    pwfx                        As Long
    cbwfx                       As Long
    pszTitle                    As Long
    szFormatTag                 As String * ACMFORMATTAGDETAILS_FORMATTAG_CHARS
    szFormat                    As String * ACMFORMATDETAILS_FORMAT_CHARS
    pszName                     As Long
    cchName                     As Long
    fdwEnum                     As Long
    pwfxEnum                    As Long
    hInstance                   As Long
    pszTemplateName             As Long
    lCustData                   As Long
    pfnHook                     As Long
    btSpace(1023)               As Byte ' just to feel secure...
End Type

Private Type MMWAVEFORMATEX
    wFormatTag                  As Integer
    nChannels                   As Integer
    nSamplesPerSec              As Long
    nAvgBytesPerSec             As Long
    nBlockAlign                 As Integer
    wBitsPerSample              As Integer
    cbSize                      As Integer
End Type

Private Enum HACMSTREAM
    INVALID_STREAM_HANDLE = 0
End Enum

Private Enum ACM_STREAMSIZEF
    ACM_STREAMSIZEF_DESTINATION = &H1
    ACM_STREAMSIZEF_SOURCE = &H0
    ACM_STREAMSIZEF_QUERYMASK = &HF
End Enum

Private Enum ACM_STREAMCONVERTF
    ACM_STREAMCONVERTF_BLOCKALIGN = &H4
    ACM_STREAMCONVERTF_START = &H10
    ACM_STREAMCONVERTF_END = &H20
End Enum

Private Const WAVE_FORMAT_PCM   As Long = 1

' Vorbis ACM has extremly large formats...
Private Const WFXSize   As Long = 128& * 1024&

Private Const WAV_RIFF  As Long = 1179011410
Private Const WAV_WAVE  As Long = 1163280727
Private Const WAV_DATA  As Long = 1635017060
Private Const WAV_FMT   As Long = 544501094

Private Type WAVRIFF
    RIFF                As Long         ' "RIFF"
    hdrlen              As Long
    WAVE                As Long         ' "WAVE"
    fmt                 As Long         ' "fmt "
    chnksize            As Long
End Type

Private clsRsmp         As Resampler

Private udtWFXIn        As MMWAVEFORMATEX
Private btWfxOut()      As Byte
Private lngWFXOutLen    As Long
Private strFormatID     As String
Private strFormatTag    As String

Private btInp()         As Byte
Private btOut()         As Byte
Private lngInpLen       As Long
Private lngOutLen       As Long

Private udtStreamHdr    As ACMSTREAMHEADER
Private hStream         As HACMSTREAM

Private hFOut           As hFile

Private blnWriteHeader  As Boolean
Private blnResample     As Boolean

'''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''

Private Sub Class_Initialize()
    Dim wfx As MMWAVEFORMATEX

    ReDim btWfxOut(WFXSize - 1) As Byte
    blnWriteHeader = True
    blnResample = True

    Set clsRsmp = New Resampler

    wfx = CreateWFX(44100, 2, 16)
    SetFormat VarPtr(wfx), Len(wfx), "44.1 kHz 16 Bit Stereo", "PCM"

    hFOut.handle = INVALID_HANDLE
End Sub

Private Sub Class_Terminate()
    IEncoder_EncoderClose
End Sub

'''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''

Public Property Get Resample( _
) As Boolean

    Resample = blnResample
End Property

Public Property Let Resample( _
    ByVal Value As Boolean _
)

    blnResample = Value
End Property

Public Property Get WriteHeader( _
) As Boolean

    WriteHeader = blnWriteHeader
End Property

Public Property Let WriteHeader( _
ByVal bln As Boolean _
)

    If hFOut.handle = INVALID_HANDLE Then
        blnWriteHeader = bln
    Else
        Err.Raise 90, , "Encoder is running!"
    End If
End Property

Public Property Get FormatTag( _
) As String

    FormatTag = strFormatTag
End Property

Public Property Get FormatID( _
) As String

    FormatID = strFormatID
End Property

Public Sub SetPCMFormat( _
    ByVal samplerate As Long, _
    ByVal Channels As Integer, _
    Optional ByVal FormatID As String, _
    Optional ByVal FormatTag As String _
)

    Dim wfx As MMWAVEFORMATEX

    wfx = CreateWFX(samplerate, Channels, 16)

    If FormatID = "" Then
        With wfx
            strFormatID = Round(.nSamplesPerSec / 1000, 1) & " " & _
                          .wBitsPerSample & " Bit " & _
                          IIf(.nChannels = 2, "stereo", "mono")
        End With
    End If

    If FormatTag = "" Then
        FormatTag = "PCM"
    End If

    SetFormat VarPtr(wfx), Len(wfx), _
              FormatID, FormatTag
End Sub

Public Sub SetFormat( _
    ByVal wfx_ptr As Long, _
    ByVal wfx_len As Long, _
    Optional FormatID As String, _
    Optional FormatTag As String _
)

    If 0 = IsBadReadPtr(ByVal wfx_ptr, wfx_len) Then
        If wfx_len > UBound(btWfxOut) + 1 Then
            ReDim btWfxOut(wfx_len - 1) As Byte
        End If
        CpyMem btWfxOut(0), ByVal wfx_ptr, wfx_len

        lngWFXOutLen = wfx_len

        strFormatID = FormatID
        strFormatTag = FormatTag
    End If
End Sub

Public Function SelectFormat( _
    ByVal samplerate As Long, _
    ByVal Channels As Integer, _
    Optional ByVal hwndOwner As Long, _
    Optional ByVal Title As String = "WAV Format" _
) As SND_RESULT

    Dim btTitle()   As Byte
    Dim btWFX()     As Byte
    Dim wfx         As MMWAVEFORMATEX
    Dim wfxinp      As MMWAVEFORMATEX
    Dim udtFmtCh    As ACMFORMATCHOOSEA

    ReDim btWFX(WFXSize - 1) As Byte

    btTitle = StrConv(Title & Chr$(0), vbFromUnicode)

    With wfxinp
        .nSamplesPerSec = samplerate
        .nChannels = Channels
        .wBitsPerSample = 16
        .wFormatTag = WAVE_FORMAT_PCM
        .nBlockAlign = .nChannels * (.wBitsPerSample / 8)
        .nAvgBytesPerSec = .nSamplesPerSec * .nBlockAlign
    End With

    CpyMem btWFX(0), wfxinp, Len(wfxinp)

    With udtFmtCh
        .cbStruct = LenB(udtFmtCh)
        .hwndOwner = hwndOwner
        .pwfx = VarPtr(btWFX(0))
        .cbwfx = WFXSize
        .pwfxEnum = IIf(samplerate = 0, 0, VarPtr(wfxinp))
        .fdwEnum = IIf(samplerate = 0, 0, ACM_FORMATENUMF_CONVERT)
        .pszTitle = VarPtr(btTitle(0))
    End With

    If acmFormatChoose(udtFmtCh) = 0 Then
        btWfxOut = btWFX
        CpyMem wfx, btWFX(0), Len(wfx)
        lngWFXOutLen = CLng(18) + CLng(wfx.cbSize)

        strFormatID = RemNullChars(udtFmtCh.szFormat)
        strFormatTag = RemNullChars(udtFmtCh.szFormatTag)

        SelectFormat = SND_ERR_SUCCESS
    Else
        SelectFormat = SND_ERR_UNKNOWN
    End If
End Function

'''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''

Private Property Let IEncoder_ConfigString( _
    ByVal RHS As String _
)

    Dim strParts()  As String

    If InStr(RHS, " ") < 1 Then Exit Property

    strParts = Split(RHS, " ")
    If strParts(0) <> "WAVCFG" Then Exit Property

        blnResample = CBool(strParts(1))
     blnWriteHeader = CBool(strParts(2))
    strFormatTag = HexToStr(strParts(3))
      strFormatID = HexToStr(strParts(4))

    lngWFXOutLen = strParts(5)

    btWfxOut = StrConv(Mid$(RHS, Len(RHS) - strParts(5) + 1), vbFromUnicode)
End Property

Private Property Get IEncoder_ConfigString( _
) As String

    IEncoder_ConfigString = "WAVCFG " & Abs(blnResample) & " " & _
                                        Abs(blnWriteHeader) & " " & _
                                        StrToHex(strFormatTag) & " " & _
                                        StrToHex(strFormatID) & " " & _
                                        lngWFXOutLen & " " & _
                                        Left$(StrConv(btWfxOut, vbUnicode), lngWFXOutLen)
End Property

Private Property Get IEncoder_Description( _
) As String

    IEncoder_Description = Description
End Property

Private Property Get IEncoder_Extension( _
) As String

    IEncoder_Extension = Extension
End Property

Private Function IEncoder_EncoderClose( _
) As SND_RESULT

    If hFOut.handle = INVALID_HANDLE Then
        IEncoder_EncoderClose = SND_ERR_INVALID_OUTPUT
    Else
        ' ACM Flush
        udtStreamHdr.cbSrcLength = 0
        acmStreamConvert hStream, udtStreamHdr, ACM_STREAMCONVERTF_END
        udtStreamHdr.cbSrcLength = lngInpLen

        FileWrite hFOut, udtStreamHdr.pbDst, udtStreamHdr.cbDstLengthUsed
        If blnWriteHeader Then WriteWAVHdr

        acmStreamUnprepareHeader hStream, udtStreamHdr, 0
        acmStreamClose hStream, 0
        hStream = INVALID_STREAM_HANDLE

        clsRsmp.CloseConverter

        FileClose hFOut

        IEncoder_EncoderClose = SND_ERR_SUCCESS
    End If
End Function

Private Function IEncoder_Encode( _
    ByVal buffer_ptr As Long, _
    ByVal buffer_len As Long, _
    buffer_used As Long _
) As SND_RESULT

    Dim lngRet      As Long
    Dim lngWritten  As Long
    Dim intRsmp()   As Integer

    If buffer_len > lngInpLen Then
        IEncoder_Encode = SND_ERR_TOO_BIG
        Exit Function
    End If

    If 0 <> IsBadReadPtr(ByVal buffer_ptr, buffer_len) Then
        IEncoder_Encode = SND_ERR_INVALID_BUFFER
        Exit Function
    End If

    If clsRsmp.IsRunning Then
        clsRsmp.Resample buffer_ptr, buffer_len / 2, intRsmp, buffer_len
        buffer_ptr = VarPtr(intRsmp(0))
        buffer_len = (UBound(intRsmp) + 1) * 2
    End If

    CpyMem btInp(0), ByVal buffer_ptr, buffer_len
    udtStreamHdr.cbSrcLength = buffer_len

    lngRet = acmStreamConvert(hStream, _
                              udtStreamHdr, _
                              ACM_STREAMCONVERTF_BLOCKALIGN)

    If lngRet <> 0 Then
        If udtStreamHdr.cbSrcLengthUsed = 0 Then
            IEncoder_Encode = SND_ERR_NEED_MORE
        Else
            IEncoder_Encode = SND_ERR_SUCCESS
        End If
    Else
        lngWritten = FileWrite(hFOut, _
                               udtStreamHdr.pbDst, _
                               udtStreamHdr.cbDstLengthUsed)

        If lngWritten = udtStreamHdr.cbDstLengthUsed Then
            IEncoder_Encode = SND_ERR_SUCCESS
        Else
            IEncoder_Encode = SND_ERR_WRITE_ERROR
        End If
    End If

    buffer_used = udtStreamHdr.cbSrcLengthUsed
End Function

Private Function IEncoder_EncoderMetrics( _
    ByVal info As ENCODER_METRICS _
) As Long

    Select Case True

        Case info = ENC_M_PCM_PER_DELIVERY_MAX
            If hFOut.handle = INVALID_HANDLE Then
                IEncoder_EncoderMetrics = -1
            Else
                IEncoder_EncoderMetrics = udtWFXIn.nAvgBytesPerSec
            End If

        Case info = ENC_M_PCM_PER_DELIVERY_MIN
            If hFOut.handle = INVALID_HANDLE Then
                IEncoder_EncoderMetrics = -1
            Else
                IEncoder_EncoderMetrics = udtWFXIn.nBlockAlign
            End If

        Case info = ENC_M_SUPPORT_TAGS
            ' WAV Encoder doesn't support tags

    End Select
End Function

Private Function IEncoder_EncoderInit( _
    ByVal samplerate As Long, _
    ByVal Channels As Integer, _
    ByVal output As String, _
    tags As StreamTags _
) As SND_RESULT

    Dim lngRet  As Long
    Dim btHdr() As Byte
    Dim wfxout  As WAVEFORMATEX

    IEncoder_EncoderClose

    If samplerate < 1 Or Channels < 1 Then
        IEncoder_EncoderInit = SND_ERR_INVALID_PARAM
        Exit Function
    End If

    CpyMem wfxout, btWfxOut(0), Len(wfxout)

    If wfxout.lSamplesPerSec <> samplerate Then
        If blnResample Then
            If clsRsmp.InitConversion(samplerate, _
                                      wfxout.lSamplesPerSec, _
                                      Channels, _
                                      wfxout.nChannels, _
                                      RSMP_SINC_FASTEST) <> RSMP_ERR_NO_ERROR Then

                IEncoder_EncoderInit = SND_ERR_INVALID_PARAM
                Exit Function
            End If

            samplerate = clsRsmp.OutputSamplerate
            Channels = clsRsmp.OutputChannels
        End If
    End If

    udtWFXIn = CreateWFX(samplerate, Channels, 16)

    ' start ACM conversion
    lngRet = acmStreamOpen(hStream, 0, _
                           udtWFXIn, _
                           btWfxOut(0), _
                           0, 0, 0, 0)

    If lngRet <> 0 Then
        IEncoder_EncoderInit = SND_ERR_INVALID_PARAM
        Exit Function
    End If

    lngInpLen = CreateWFX(samplerate, Channels, 16).nAvgBytesPerSec

    ' needed input buffer size for
    ' wanted output buffer size
    lngRet = acmStreamSize(hStream, _
                           lngInpLen, _
                           lngOutLen, _
                           ACM_STREAMSIZEF_SOURCE)

    If lngRet <> 0 Then
        IEncoder_EncoderInit = SND_ERR_INVALID_PARAM
        acmStreamClose hStream, 0
        Exit Function
    End If

    ReDim btInp(lngInpLen - 1) As Byte
    ReDim btOut(lngOutLen - 1) As Byte

    ' ACM Stream Header saves pointers to
    ' the buffer, a stream must have atleast
    ' 1 Stream Header
    With udtStreamHdr
        .cbStruct = Len(udtStreamHdr)
        .cbDstLength = lngOutLen
        .cbSrcLength = lngInpLen
        .pbDst = VarPtr(btOut(0))
        .pbSrc = VarPtr(btInp(0))
    End With

    lngRet = acmStreamPrepareHeader(hStream, _
                                    udtStreamHdr, _
                                    0)

    If lngRet <> 0 Then
        IEncoder_EncoderInit = SND_ERR_INVALID_PARAM
        acmStreamClose hStream, 0
        Exit Function
    End If

    hFOut = FileOpen(output, _
                     GENERIC_WRITE, , _
                     CREATE_ALWAYS)

    If hFOut.handle = INVALID_HANDLE Then
        IEncoder_EncoderInit = SND_ERR_INVALID_OUTPUT
        Exit Function
    End If

    If blnWriteHeader Then
        ' space for the WAV header
        ReDim btHdr(20 + lngWFXOutLen + 4 * 2 - 1) As Byte
        FileWrite hFOut, VarPtr(btHdr(0)), UBound(btHdr) + 1
    End If

    IEncoder_EncoderInit = SND_ERR_SUCCESS
End Function

'''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''

Private Function CreateWFX( _
    sR As Long, _
    chs As Integer, _
    bps As Integer _
) As MMWAVEFORMATEX

    With CreateWFX
        .wFormatTag = WAVE_FORMAT_PCM
        .nChannels = chs
        .nSamplesPerSec = sR
        .wBitsPerSample = bps
        .nBlockAlign = chs * (bps / 8)
        .nAvgBytesPerSec = sR * .nBlockAlign
    End With
End Function

Private Sub WriteWAVHdr()
    Dim udtHdr      As WAVRIFF
    Dim lngDataID   As Long
    Dim lngData     As Long

    With udtHdr
        .RIFF = WAV_RIFF
        .WAVE = WAV_WAVE
        .fmt = WAV_FMT
        .hdrlen = FileLength(hFOut) - 8
        .chnksize = lngWFXOutLen
    End With

    FileSeek hFOut, 0, FILE_BEGIN
    FileWrite hFOut, VarPtr(udtHdr), Len(udtHdr)

    FileWrite hFOut, VarPtr(btWfxOut(0)), lngWFXOutLen

    lngDataID = WAV_DATA
    FileWrite hFOut, VarPtr(lngDataID), 4

    lngData = FileLength(hFOut) - (FilePosition(hFOut) + 4)
    FileWrite hFOut, VarPtr(lngData), 4
End Sub
