VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "PlaylistReaderM3U"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Implements IPlaylistReader

Const Extension     As String = "m3u"

Private colFiles    As Collection

Private Sub Class_Initialize()
    Set colFiles = New Collection
End Sub

Private Property Get IPlaylistReader_Extension( _
) As String

    IPlaylistReader_Extension = Extension
End Property

Private Property Get IPlaylistReader_Files( _
) As Long

    IPlaylistReader_Files = colFiles.count
End Property

Private Sub IPlaylistReader_GetFile( _
    ByVal Index As Long, _
    file As String, _
    title As String, _
    Length As Long _
)

    Dim strParts()  As String

    strParts = Split(colFiles.item(Index), Chr$(0) & Chr$(1))

    file = strParts(0)
    title = strParts(1)
    Length = Val(strParts(2))
End Sub

Private Function IPlaylistReader_OpenPlaylist( _
    ByVal Source As String _
) As Boolean

    Dim strContent  As String
    Dim strLines()  As String
    Dim strLength   As String
    Dim strTitle    As String
    Dim btFile()    As Byte
    Dim fIn         As hFile
    Dim i           As Long

    Set colFiles = New Collection

    If Not IsValidFile(Source) Then Exit Function

    fIn = FileOpen(Source, GENERIC_READ)
    If fIn.handle = INVALID_HANDLE Then Exit Function

    ReDim btFile(FileLength(fIn) - 1) As Byte

    FileRead fIn, VarPtr(btFile(0)), UBound(btFile) + 1

    FileClose fIn

    strContent = StrConv(btFile, vbUnicode)
    strLines = Split(strContent, vbCrLf)

    If strLines(0) <> "#EXTM3U" Then Exit Function

    For i = 2 To UBound(strLines)
        If Left$(strLines(i - 1), 8) = "#EXTINF:" Then
            If InStr(strLines(i - 1), ",") > 0 Then
                strTitle = Mid$(strLines(i - 1), InStr(strLines(i - 1), ",") + 1)
                strLength = Mid$(strLines(i - 1), 9, Len(strLines(i - 1)) - Len(strTitle) - 9)
            Else
                strTitle = GetFilename(strLines(i - 1))
                strLength = "0"
            End If

            colFiles.Add strLines(i) & Chr$(0) & Chr$(1) & _
                         strTitle & Chr$(0) & Chr$(1) & _
                         strLength
        End If
    Next

    IPlaylistReader_OpenPlaylist = True
End Function
