VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "PlaylistReaderPLS"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Implements IPlaylistReader

Const Extension     As String = "pls"

Private colFiles    As Collection

Private Sub Class_Initialize()
    Set colFiles = New Collection
End Sub

Private Property Get IPlaylistReader_Extension( _
) As String

    IPlaylistReader_Extension = Extension
End Property

Private Property Get IPlaylistReader_File( _
    ByVal Index As Long _
) As String

    IPlaylistReader_File = colFiles.item(Index)
End Property

Private Property Get IPlaylistReader_Files( _
) As Long

    IPlaylistReader_Files = colFiles.count
End Property

Private Sub IPlaylistReader_GetFile( _
    ByVal Index As Long, _
    file As String, _
    title As String, _
    Length As Long _
)

    Dim strParts()  As String

    strParts = Split(colFiles.item(Index), Chr$(0) & Chr$(1))

    file = strParts(0)
    title = strParts(1)
    Length = Val(strParts(2))
End Sub

Private Function IPlaylistReader_OpenPlaylist( _
    ByVal Source As String _
) As Boolean

    Dim strContent  As String
    Dim strLines()  As String
    Dim strFileName As String
    Dim strTitle    As String
    Dim strLength   As String
    Dim lngLastIdx  As Long
    Dim lngCurIdx   As Long
    Dim btFile()    As Byte
    Dim fIn         As hFile
    Dim i           As Long
    Dim intEquPos   As Integer

    Set colFiles = New Collection

    If Not IsValidFile(Source) Then Exit Function

    fIn = FileOpen(Source, GENERIC_READ)
    If fIn.handle = INVALID_HANDLE Then Exit Function

    ReDim btFile(FileLength(fIn) - 1) As Byte

    FileRead fIn, VarPtr(btFile(0)), UBound(btFile) + 1

    FileClose fIn

    strContent = StrConv(btFile, vbUnicode)
    strLines = Split(strContent, vbCrLf)

    If LCase$(strLines(0)) <> "[playlist]" Then Exit Function

    lngLastIdx = 1

    For i = 1 To UBound(strLines)
        If strLines(i) = "" Then
            GoTo NextLine
        End If

        If LCase$(Left$(strLines(i), 4)) = "file" Then
            intEquPos = InStr(1, strLines(i), "=")

            lngCurIdx = Mid$(strLines(i), 5, intEquPos - 5)
            If lngCurIdx <> lngLastIdx Then
                colFiles.Add strFileName & Chr$(0) & Chr$(1) & _
                             strTitle & Chr$(0) & Chr$(1) & _
                             strLength

                strFileName = ""
                strTitle = ""
                strLength = ""

                lngLastIdx = lngCurIdx
            End If

            strFileName = Mid$(strLines(i), intEquPos + 1)
            GoTo NextLine
        End If

        If LCase$(Left$(strLines(i), 5)) = "title" Then
            intEquPos = InStr(1, strLines(i), "=")

            lngCurIdx = Mid$(strLines(i), 6, intEquPos - 6)
            If lngCurIdx <> lngLastIdx Then
                colFiles.Add strFileName & Chr$(0) & Chr$(1) & _
                             strTitle & Chr$(0) & Chr$(1) & _
                             strLength

                strFileName = ""
                strTitle = ""
                strLength = ""

                lngLastIdx = lngCurIdx
            End If

            strTitle = Mid$(strLines(i), intEquPos + 1)
            GoTo NextLine
        End If

        If LCase$(Left$(strLines(i), 6)) = "length" Then
            intEquPos = InStr(1, strLines(i), "=")

            lngCurIdx = Mid$(strLines(i), 7, intEquPos - 7)
            If lngCurIdx <> lngLastIdx Then
                colFiles.Add strFileName & Chr$(0) & Chr$(1) & _
                             strTitle & Chr$(0) & Chr$(1) & _
                             strLength

                strFileName = ""
                strTitle = ""
                strLength = ""

                lngLastIdx = lngCurIdx
            End If

            strLength = Mid$(strLines(i), intEquPos + 1)
            GoTo NextLine
        End If

NextLine:
    Next

    colFiles.Add strFileName & Chr$(0) & Chr$(1) & _
                 strTitle & Chr$(0) & Chr$(1) & _
                 strLength

    IPlaylistReader_OpenPlaylist = True
End Function
