VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "StreamSND"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Implements ISoundStream
Implements ISoundInfo


Private Const Description   As String = "Sndfile Audio"
Private Const Extensions    As String = "wav;au;snd;aiff;aifc;aif;voc;vox"


Private Enum SF_FORMATS
    ' /* Major formats. */

    SF_FORMAT_WAV = &H10000               ' /* Microsoft WAV format (little endian default). */
    SF_FORMAT_AIFF = &H20000              ' /* Apple/SGI AIFF format (big endian). */
    SF_FORMAT_AU = &H30000                ' /* Sun/NeXT AU format (big endian). */
    SF_FORMAT_RAW = &H40000               ' /* RAW PCM data. */
    SF_FORMAT_PAF = &H50000               ' /* Ensoniq PARIS file format. */
    SF_FORMAT_SVX = &H60000               ' /* Amiga IFF / SVX8 / SV16 format. */
    SF_FORMAT_NIST = &H70000              ' /* Sphere NIST format. */
    SF_FORMAT_VOC = &H80000               ' /* VOC files. */
    SF_FORMAT_IRCAM = &HA0000             ' /* Berkeley/IRCAM/CARL */
    SF_FORMAT_W64 = &HB0000               ' /* Sonic Foundry's 64 bit RIFF/WAV */
    SF_FORMAT_MAT4 = &HC0000              ' /* Matlab (tm) V4.2 / GNU Octave 2.0 */
    SF_FORMAT_MAT5 = &HD0000              ' /* Matlab (tm) V5.0 / GNU Octave 2.1 */
    SF_FORMAT_PVF = &HE0000               ' /* Portable Voice Format */
    SF_FORMAT_XI = &HF0000                ' /* Fasttracker 2 Extended Instrument */
    SF_FORMAT_HTK = &H100000              ' /* HMM Tool Kit format */
    SF_FORMAT_SDS = &H110000              ' /* Midi Sample Dump Standard */
    SF_FORMAT_AVR = &H120000              ' /* Audio Visual Research */
    SF_FORMAT_WAVEX = &H130000            ' /* MS WAVE with WAVEFORMATEX */
    SF_FORMAT_SD2 = &H160000              ' /* Sound Designer 2 */
    SF_FORMAT_FLAC = &H170000             ' /* FLAC lossless file format */
    SF_FORMAT_CAF = &H180000              ' /* Core Audio File format */

    ' /* Subtypes from here on. */

    SF_FORMAT_PCM_S8 = &H1                ' /* Signed 8 bit data */
    SF_FORMAT_PCM_16 = &H2                ' /* Signed 16 bit data */
    SF_FORMAT_PCM_24 = &H3                ' /* Signed 24 bit data */
    SF_FORMAT_PCM_32 = &H4                ' /* Signed 32 bit data */

    SF_FORMAT_PCM_U8 = &H5                ' /* Unsigned 8 bit data (WAV and RAW only) */

    SF_FORMAT_FLOAT = &H6                 ' /* 32 bit float data */
    SF_FORMAT_DOUBLE = &H7                ' /* 64 bit float data */

    SF_FORMAT_ULAW = &H10                 ' /* U-Law encoded. */
    SF_FORMAT_ALAW = &H11                 ' /* A-Law encoded. */
    SF_FORMAT_IMA_ADPCM = &H12            ' /* IMA ADPCM. */
    SF_FORMAT_MS_ADPCM = &H13             ' /* Microsoft ADPCM. */

    SF_FORMAT_GSM610 = &H20               ' /* GSM 6.10 encoding. */
    SF_FORMAT_VOX_ADPCM = &H21            ' /* OKI / Dialogix ADPCM */

    SF_FORMAT_G721_32 = &H30              ' /* 32kbs G721 ADPCM encoding. */
    SF_FORMAT_G723_24 = &H31              ' /* 24kbs G723 ADPCM encoding. */
    SF_FORMAT_G723_40 = &H32              ' /* 40kbs G723 ADPCM encoding. */

    SF_FORMAT_DWVW_12 = &H40              ' /* 12 bit Delta Width Variable Word encoding. */
    SF_FORMAT_DWVW_16 = &H41              ' /* 16 bit Delta Width Variable Word encoding. */
    SF_FORMAT_DWVW_24 = &H42              ' /* 24 bit Delta Width Variable Word encoding. */
    SF_FORMAT_DWVW_N = &H43               ' /* N bit Delta Width Variable Word encoding. */

    SF_FORMAT_DPCM_8 = &H50               ' /* 8 bit differential PCM (XI only) */
    SF_FORMAT_DPCM_16 = &H51              ' /* 16 bit differential PCM (XI only) */

    ' /* Endian-ness options. */

    SF_ENDIAN_FILE = &H0&                 ' /* Default file endian-ness. */
    SF_ENDIAN_LITTLE = &H10000000         ' /* Force little endian-ness. */
    SF_ENDIAN_BIG = &H20000000            ' /* Force big endian-ness. */
    SF_ENDIAN_CPU = &H30000000            ' /* Force CPU endian-ness. */

    SF_FORMAT_SUBMASK = &HFFFF&
    SF_FORMAT_TYPEMASK = &HFFF0000
    SF_FORMAT_ENDMASK = &H30000000
End Enum

Private Enum SF_COMMANDS
    SFC_GET_LIB_VERSION = &H1000
    SFC_GET_LOG_INFO = &H1001

    SFC_GET_NORM_DOUBLE = &H1010
    SFC_GET_NORM_FLOAT = &H1011
    SFC_SET_NORM_DOUBLE = &H1012
    SFC_SET_NORM_FLOAT = &H1013
    SFC_SET_SCALE_FLOAT_INT_READ = &H1014

    SFC_GET_SIMPLE_FORMAT_COUNT = &H1020
    SFC_GET_SIMPLE_FORMAT = &H1021

    SFC_GET_FORMAT_INFO = &H1028

    SFC_GET_FORMAT_MAJOR_COUNT = &H1030
    SFC_GET_FORMAT_MAJOR = &H1031
    SFC_GET_FORMAT_SUBTYPE_COUNT = &H1032
    SFC_GET_FORMAT_SUBTYPE = &H1033

    SFC_CALC_SIGNAL_MAX = &H1040
    SFC_CALC_NORM_SIGNAL_MAX = &H1041
    SFC_CALC_MAX_ALL_CHANNELS = &H1042
    SFC_CALC_NORM_MAX_ALL_CHANNELS = &H1043

    SFC_SET_ADD_PEAK_CHUNK = &H1050

    SFC_UPDATE_HEADER_NOW = &H1060
    SFC_SET_UPDATE_HEADER_AUTO = &H1061

    SFC_FILE_TRUNCATE = &H1080

    SFC_SET_RAW_START_OFFSET = &H1090

    SFC_SET_DITHER_ON_WRITE = &H10A0
    SFC_SET_DITHER_ON_READ = &H10A1

    SFC_GET_DITHER_INFO_COUNT = &H10A2
    SFC_GET_DITHER_INFO = &H10A3

    SFC_GET_EMBED_FILE_INFO = &H10B0

    SFC_SET_CLIPPING = &H10C0
    SFC_GET_CLIPPING = &H10C1

    SFC_GET_INSTRUMENT = &H10D0
    SFC_SET_INSTRUMENT = &H10D1

    SFC_GET_LOOP_INFO = &H10E0

    ' /* Following commands for testing only. */
    SFC_TEST_IEEE_FLOAT_REPLACE = &H6001

    ' /*
    ' ** SFC_SET_ADD_* values are deprecated and will disappear at some
    ' ** time in the future. They are guaranteed to be here up to and
    ' ** including version 1.0.8 to avoid breakage of existng software.
    ' ** They currently do nothing and will continue to do nothing.
    ' */
    SFC_SET_ADD_DITHER_ON_WRITE = &H1070
    SFC_SET_ADD_DITHER_ON_READ = &H1071
End Enum

Private Enum SF_STRS
    SF_STR_TITLE = &H1
    SF_STR_COPYRIGHT = &H2
    SF_STR_SOFTWARE = &H3
    SF_STR_ARTIST = &H4
    SF_STR_COMMENT = &H5
    SF_STR_DATE = &H6
End Enum

Private Enum SF_BOOL
    SF_FALSE = 0
    SF_TRUE = 1
End Enum

Private Enum SF_FILE_MODES
    ' /* Modes for opening files. */
    SFM_READ = &H10
    SFM_WRITE = &H20
    SFM_RDWR = &H30
End Enum

Private Enum SF_ERRORS
    SF_ERR_NO_ERROR = 0
    SF_ERR_UNRECOGNISED_FORMAT = 1
    SF_ERR_SYSTEM = 2
    SF_ERR_MALFORMED_FILE = 3
    SF_ERR_UNSUPPORTED_ENCODING = 4
End Enum

Private Type sf_count_t
    lo              As Long
    hi              As Long
End Type

Private Type SF_INFO
    frames          As sf_count_t
    samplerate      As Long
    Channels        As Long
    format          As Long
    sections        As Long
    seekable        As Long
End Type

Private Type SF_FORMAT_INFO
    format          As Long
    lpstrName       As Long
    lpstrExtension  As Long
End Type

Private Enum SF_DITHER
    SFD_DEFAULT_LEVEL = 0
    SFD_CUSTOM_LEVEL = &H40000000

    SFD_NO_DITHER = 500
    SFD_WHITE = 501
    SFD_TRIANGULAR_PDF = 502
End Enum

Private Type SF_DITHER_INFO
    type            As Long
    level           As Double
    lpstrName       As String
End Type

Private Type SF_EMBED_FILE_INFO
    offset          As sf_count_t
    Length          As sf_count_t
End Type

Private Enum SF_SEEK_METHOD
    SF_SEEK_SET = 0
    SF_SEEK_CUR
    SF_SEEK_END
End Enum

Private Enum SF_LOOPS
    ' /*
    ' **  The loop mode field in SF_INSTRUMENT will be one of the following.
    ' */
    SF_LOOP_NONE = 800
    SF_LOOP_FORWARD
    SF_LOOP_BACKWARD
    SF_LOOP_ALTERNATING
End Enum

Private Type SF_LOOP
    Mode            As Long
    start           As Long
    end             As Long
    count           As Long
End Type

Private Type SF_INSTRUMENT
    gain            As Long
    basenote        As Byte
    detune          As Byte
    velocity_lo     As Byte
    velocity_hi     As Byte
    key_lo          As Byte
    key_hi          As Byte
    loop_count      As Long
    loops(15)       As SF_LOOP
End Type

Private Type SF_LOOP_INFO
    time_sig_num    As Integer  ' /* any positive integer    > 0  */
    time_sig_den    As Integer  ' /* any positive power of 2 > 0  */
    loop_mode       As Long     ' /* see SF_LOOP enum             */
    num_beats       As Long     ' /* this is NOT the amount of quarter notes !!!*/
                                ' /* a full bar of 4/4 is 4 beats */
                                ' /* a full bar of 7/8 is 7 beats */
    bpm             As Single   ' /* suggestion, as it can be calculated using other fields:*/
                                ' /* file's lenght, file's sampleRate and our time_sig_den*/
                                ' /* -> bpms are always the amount of _quarter notes_ per minute */
    root_key        As Long     ' /* MIDI note, or -1 for None */
    future(5)       As Long
End Type

Private Type WAVEFORMATEX
    wFormatTag      As Integer
    nChannels       As Integer
    nSamplesPerSec  As Long
    nAvgBytesPerSec As Long
    nBlockAlign     As Integer
    wBitsPerSample  As Integer
    cbSize          As Integer
End Type

Private Const NODIVZ    As Single = 0.0000000001

Private clsTags     As StreamTags

Private clsSnd      As clsDLL

Private udtFmt      As SF_INFO
Private hSnd        As Long

Private wfx_out     As WAVEFORMATEX

Private lngFileLen  As Long

Private Sub Class_Initialize()
    Set clsTags = New StreamTags
    Set clsSnd = New clsDLL

    libsnd_init_lib
End Sub

Private Sub Class_Terminate()
    libsnd_free_lib
End Sub

'''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''

Private Property Get ISoundInfo_BitsPerSample( _
) As Integer

    ISoundInfo_BitsPerSample = 16
End Property

Private Property Get ISoundInfo_BitsPerSecond( _
) As Long

    With wfx_out
        ISoundInfo_BitsPerSecond = .nSamplesPerSec * .nChannels * .wBitsPerSample
    End With
End Property

Private Property Get ISoundInfo_channels( _
) As Integer

    ISoundInfo_channels = udtFmt.Channels
End Property

Private Property Get ISoundInfo_Duration( _
) As Long

    With udtFmt
        ISoundInfo_Duration = .frames.lo / .samplerate * 1000
    End With
End Property

Private Property Get ISoundInfo_Position( _
) As Long

    Dim udtPos  As sf_count_t

    ISoundInfo_Position = sf_seek(hSnd, udtPos, SF_SEEK_CUR) / wfx_out.nSamplesPerSec * 1000
End Property

Private Property Get ISoundInfo_SamplesPerSecond( _
) As Long

    ISoundInfo_SamplesPerSecond = udtFmt.samplerate
End Property

Private Property Get ISoundInfo_Tags( _
) As StreamTags

    Set ISoundInfo_Tags = clsTags
End Property

'''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''

Private Property Get ISoundStream_Description( _
) As String

    ISoundStream_Description = Description
End Property

Private Property Get ISoundStream_EndOfStream( _
) As Boolean

    Dim udtPos  As sf_count_t

    ISoundStream_EndOfStream = sf_seek(hSnd, udtPos, SF_SEEK_CUR) >= lngFileLen
End Property

Private Function ISoundStream_Extensions( _
) As String()

    ISoundStream_Extensions = Split(Extensions, ";")
End Function

Private Function ISoundStream_QuickStreamInfo( _
    ByVal Source As String, _
    info As ISoundInfo _
) As SND_RESULT

    Dim hSndQ   As Long
    Dim udtFmtQ As SF_INFO
    Dim clsInfo As QuickStreamInfo
    Dim wfxQ    As WAVEFORMATEX

    Set clsInfo = New QuickStreamInfo
    Set info = clsInfo

    If clsSnd.ModuleHandle = 0 Then
        ISoundStream_QuickStreamInfo = SND_ERR_INTERNAL
        Exit Function
    End If

    hSndQ = sf_open(Source, SFM_READ, udtFmtQ)
    If hSndQ = 0 Then
        ISoundStream_QuickStreamInfo = SND_ERR_INVALID_SOURCE
        Exit Function
    End If

    With wfxQ
        .nSamplesPerSec = udtFmtQ.samplerate
        .nChannels = udtFmtQ.Channels

        Select Case (udtFmtQ.format And SF_FORMAT_SUBMASK)
            Case SF_FORMAT_PCM_S8
                .wBitsPerSample = 8
            Case SF_FORMAT_PCM_U8
                .wBitsPerSample = 8
            Case SF_FORMAT_PCM_16
                .wBitsPerSample = 16
            Case SF_FORMAT_PCM_24
                .wBitsPerSample = 24
            Case SF_FORMAT_PCM_32
                .wBitsPerSample = 32
            Case SF_FORMAT_FLOAT
                .wBitsPerSample = 32
            Case SF_FORMAT_DOUBLE
                .wBitsPerSample = 64

            ' maybe compressed
            Case Else
                .wBitsPerSample = 4
        End Select

        .nBlockAlign = .nChannels * (.wBitsPerSample / 8)
        .nAvgBytesPerSec = .nSamplesPerSec * .nBlockAlign
    End With

    sf_close hSndQ

    With wfxQ
        clsInfo.SetValues .nSamplesPerSec, _
                          .nChannels, _
                          16, _
                          .nAvgBytesPerSec / 8, _
                          udtFmtQ.frames.lo / .nSamplesPerSec * 1000, _
                          0, _
                          New StreamTags
    End With

    ISoundStream_QuickStreamInfo = SND_ERR_SUCCESS
End Function

Private Function ISoundStream_StreamClose( _
) As SND_RESULT

    If clsSnd.ModuleHandle = 0 Then
        ISoundStream_StreamClose = SND_ERR_INTERNAL
        Exit Function
    End If

    If hSnd <> 0 Then
        sf_close hSnd
        hSnd = 0
        ZeroMem udtFmt, Len(udtFmt)
        ZeroMem wfx_out, Len(wfx_out)

        ISoundStream_StreamClose = SND_ERR_SUCCESS
    Else
        ISoundStream_StreamClose = SND_ERR_INVALID_SOURCE
    End If
End Function

Private Property Get ISoundStream_StreamInfo( _
) As ISoundInfo

    Set ISoundStream_StreamInfo = Me
End Property

Private Function ISoundStream_StreamOpen( _
    ByVal Source As String _
) As SND_RESULT

    Dim udtPos  As sf_count_t

    If clsSnd.ModuleHandle = 0 Then
        ISoundStream_StreamOpen = SND_ERR_INTERNAL
        Exit Function
    End If

    ISoundStream_StreamClose

    hSnd = sf_open(Source, SFM_READ, udtFmt)
    If hSnd = 0 Then
        ISoundStream_StreamOpen = SND_ERR_INVALID_SOURCE
        Exit Function
    End If

    With wfx_out
        .nSamplesPerSec = udtFmt.samplerate
        .nChannels = udtFmt.Channels

        Select Case (udtFmt.format And SF_FORMAT_SUBMASK)
            Case SF_FORMAT_PCM_S8
                .wBitsPerSample = 8
            Case SF_FORMAT_PCM_U8
                .wBitsPerSample = 8
            Case SF_FORMAT_PCM_16
                .wBitsPerSample = 16
            Case SF_FORMAT_PCM_24
                .wBitsPerSample = 24
            Case SF_FORMAT_PCM_32
                .wBitsPerSample = 32
            Case SF_FORMAT_FLOAT
                .wBitsPerSample = 32
            Case SF_FORMAT_DOUBLE
                .wBitsPerSample = 64

            ' maybe compressed
            Case Else
                .wBitsPerSample = 4
        End Select

        .nBlockAlign = .nChannels * (.wBitsPerSample / 8)
        .nAvgBytesPerSec = .nSamplesPerSec * .nBlockAlign
    End With

    lngFileLen = sf_seek(hSnd, udtPos, SF_SEEK_END)
    sf_seek hSnd, udtPos, SF_SEEK_SET

    ISoundStream_StreamOpen = SND_ERR_SUCCESS
End Function

Private Function ISoundStream_StreamRead( _
    ByVal buffer_ptr As Long, _
    ByVal buffer_len As Long, _
    buffer_read As Long _
) As SND_RESULT

    Dim lngRet      As Long
    Dim udtItems    As sf_count_t

    buffer_read = 0

    If clsSnd.ModuleHandle = 0 Then
        ISoundStream_StreamRead = SND_ERR_INTERNAL
        Exit Function
    End If

    If hSnd = 0 Then
        ISoundStream_StreamRead = SND_ERR_INVALID_SOURCE
        Exit Function
    End If

    ' buffer size has to be even
    buffer_len = buffer_len - (buffer_len Mod 2)

    udtItems.lo = buffer_len / 2

    lngRet = sf_read_short(hSnd, _
                           buffer_ptr, _
                           udtItems) * 2

    buffer_read = lngRet

    If lngRet < buffer_len Then
        ISoundStream_StreamRead = SND_ERR_END_OF_STREAM
    Else
        ISoundStream_StreamRead = SND_ERR_SUCCESS
    End If
End Function

Private Function ISoundStream_StreamSeek( _
    ByVal Value As Long, _
    ByVal seek_mode As SND_SEEK_MODE _
) As SND_RESULT

    Dim lngNewPos   As Long
    Dim udtNewPos   As sf_count_t

    If clsSnd.ModuleHandle = 0 Then
        ISoundStream_StreamSeek = SND_ERR_INTERNAL
        Exit Function
    End If

    If hSnd = 0 Then
        ISoundStream_StreamSeek = SND_ERR_INVALID_SOURCE
        Exit Function
    End If

    If Value < 0 Then
        ISoundStream_StreamSeek = SND_ERR_OUT_OF_RANGE
        Exit Function
    End If

    Select Case seek_mode

        Case SND_SEEK_PERCENT
            If Value > 99 Then
                ISoundStream_StreamSeek = SND_ERR_OUT_OF_RANGE
                Exit Function
            End If

            lngNewPos = Value * lngFileLen / 100

        Case SND_SEEK_SECONDS
            If Value > (ISoundInfo_Duration / 1000) Then
                ISoundStream_StreamSeek = SND_ERR_OUT_OF_RANGE
                Exit Function
            End If

            lngNewPos = Value * udtFmt.samplerate

    End Select

    udtNewPos.lo = lngNewPos

    sf_seek hSnd, udtNewPos, SF_SEEK_SET

    ISoundStream_StreamSeek = SND_ERR_SUCCESS
End Function

''''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''

' sndfile.h translation

Private Function libsnd_init_lib() As Boolean
    libsnd_init_lib = clsSnd.LoadDLL("libsndfile.dll")
    clsSnd.IsCDECL = True
End Function

Private Sub libsnd_free_lib()
    clsSnd.UnloadDLL
End Sub

Private Function sf_open( _
    ByVal strFile As String, _
    ByVal Mode As Long, _
    sfinfo As SF_INFO _
) As Long

    Dim btFile()    As Byte

    btFile = StrConv(strFile & Chr$(0), _
                     vbFromUnicode)

    sf_open = clsSnd.CallFunc("sf_open", _
                              VarPtr(btFile(0)), _
                              Mode, _
                              VarPtr(sfinfo))
End Function

Private Function sf_error( _
    ByVal sndfile As Long _
) As Long

    sf_error = clsSnd.CallFunc("sf_error", sndfile)
End Function

Private Function sf_strerror( _
    ByVal sndfile As Long _
) As Long

    sf_strerror = clsSnd.CallFunc("sf_strerror", sndfile)
End Function

Private Function sf_error_number( _
    ByVal errnum As Long _
) As Long

    sf_error_number = clsSnd.CallFunc("sf_error_number", _
                                      errnum)
End Function

Private Function sf_command( _
    ByVal sndfile As Long, _
    ByVal command As Long, _
    ByVal data_ptr As Long, _
    ByVal data_len As Long _
) As Long

    sf_command = clsSnd.CallFunc("sf_command", _
                                 sndfile, _
                                 command, _
                                 data_ptr, _
                                 data_len)
End Function

Private Function sf_format_check( _
    info As SF_INFO _
) As Long

    sf_format_check = clsSnd.CallFunc("sf_format_check", _
                                      VarPtr(info))
End Function

Private Function sf_seek( _
    ByVal sndfile As Long, _
    frames As sf_count_t, _
    ByVal whence As Long _
) As Long

    sf_seek = clsSnd.CallFunc("sf_seek", _
                              sndfile, _
                              frames.lo, _
                              frames.hi, _
                              whence)
End Function

Private Function sf_set_string( _
    ByVal sndfile As Long, _
    ByVal str_type As Long, _
    ByVal str_ptr As Long _
) As Long

    sf_set_string = clsSnd.CallFunc("sf_set_string", _
                                    sndfile, _
                                    str_type, _
                                    str_ptr)
End Function

Private Function sf_get_string( _
    ByVal sndfile As Long, _
    ByVal str_type As Long _
) As Long

    sf_get_string = clsSnd.CallFunc("sf_get_string", _
                                    sndfile, _
                                    str_type)
End Function

Private Function sf_read_raw( _
    ByVal sndfile As Long, _
    ByVal data_ptr As Long, _
    data_len As sf_count_t _
) As Long

    sf_read_raw = clsSnd.CallFunc("sf_read_raw", _
                                  sndfile, _
                                  data_ptr, _
                                  data_len.lo, _
                                  data_len.hi)
End Function

Private Function sf_write_raw( _
    ByVal sndfile As Long, _
    ByVal data_ptr As Long, _
    data_len As sf_count_t _
) As Long

    sf_write_raw = clsSnd.CallFunc("sf_write_raw", _
                                   sndfile, _
                                   data_ptr, _
                                   data_len.lo, _
                                   data_len.hi)
End Function

Private Function sf_readf_short( _
    ByVal sndfile As Long, _
    ByVal data_ptr As Long, _
    frames As sf_count_t _
) As Long

    sf_readf_short = clsSnd.CallFunc("sf_readf_short", _
                                     sndfile, _
                                     data_ptr, _
                                     frames.lo, _
                                     frames.hi)
End Function

Private Function sf_writef_short( _
    ByVal sndfile As Long, _
    ByVal data_ptr As Long, _
    frames As sf_count_t _
) As Long

    sf_writef_short = clsSnd.CallFunc("sf_writef_short", _
                                      sndfile, _
                                      data_ptr, _
                                      frames.lo, _
                                      frames.hi)
End Function

Private Function sf_readf_int( _
    ByVal sndfile As Long, _
    ByVal data_ptr As Long, _
    frames As sf_count_t _
) As Long

    sf_readf_int = clsSnd.CallFunc("sf_readf_int", _
                                   sndfile, _
                                   data_ptr, _
                                   frames.lo, _
                                    frames.hi)
End Function

Private Function sf_writef_int( _
    ByVal sndfile As Long, _
    ByVal data_ptr As Long, _
    frames As sf_count_t _
) As Long

    sf_writef_int = clsSnd.CallFunc("sf_writef_int", _
                                    sndfile, _
                                    data_ptr, _
                                    frames.lo, _
                                    frames.hi)
End Function

Private Function sf_readf_float( _
    ByVal sndfile As Long, _
    ByVal data_ptr As Long, _
    frames As sf_count_t _
) As Long

    sf_readf_float = clsSnd.CallFunc("sf_readf_float", _
                                     sndfile, _
                                     data_ptr, _
                                     frames.lo, _
                                     frames.hi)
End Function

Private Function sf_writef_float( _
    ByVal sndfile As Long, _
    ByVal data_ptr As Long, _
    frames As sf_count_t _
) As Long

    sf_writef_float = clsSnd.CallFunc("sf_writef_float", _
                                      sndfile, _
                                      data_ptr, _
                                      frames.lo, _
                                      frames.hi)
End Function

Private Function sf_readf_double( _
    ByVal sndfile As Long, _
    ByVal data_ptr As Long, _
    frames As sf_count_t _
) As Long

    sf_readf_double = clsSnd.CallFunc("sf_readf_double", _
                                      sndfile, _
                                      data_ptr, _
                                      frames.lo, _
                                      frames.hi)
End Function

Private Function sf_writef_double( _
    ByVal sndfile As Long, _
    ByVal data_ptr As Long, _
    frames As sf_count_t _
) As Long

    sf_writef_double = clsSnd.CallFunc("sf_writef_double", _
                                       sndfile, _
                                       data_ptr, _
                                       frames.lo, _
                                       frames.hi)
End Function

Private Function sf_read_short( _
    ByVal sndfile As Long, _
    ByVal data_ptr As Long, _
    items As sf_count_t _
) As Long

    sf_read_short = clsSnd.CallFunc("sf_read_short", _
                                    sndfile, _
                                    data_ptr, _
                                    items.lo, _
                                    items.hi)
End Function

Private Function sf_write_short( _
    ByVal sndfile As Long, _
    ByVal data_ptr As Long, _
    items As sf_count_t _
) As Long

    sf_write_short = clsSnd.CallFunc("sf_read_short", _
                                     sndfile, _
                                     data_ptr, _
                                     items.lo, _
                                     items.hi)
End Function

Private Function sf_read_int( _
    ByVal sndfile As Long, _
    ByVal data_ptr As Long, _
    items As sf_count_t _
) As Long

    sf_read_int = clsSnd.CallFunc("sf_read_int", _
                                  sndfile, _
                                  data_ptr, _
                                  items.lo, _
                                  items.hi)
End Function

Private Function sf_write_int( _
    ByVal sndfile As Long, _
    ByVal data_ptr As Long, _
    items As sf_count_t _
) As Long

    sf_write_int = clsSnd.CallFunc("sf_write_int", _
                                   sndfile, _
                                   data_ptr, _
                                   items.lo, _
                                   items.hi)
End Function

Private Function sf_read_float( _
    ByVal sndfile As Long, _
    ByVal data_ptr As Long, _
    items As sf_count_t _
) As Long

    sf_read_float = clsSnd.CallFunc("sf_read_float", _
                                    sndfile, _
                                    data_ptr, _
                                    items.lo, _
                                    items.hi)
End Function

Private Function sf_write_float( _
    ByVal sndfile As Long, _
    ByVal data_ptr As Long, _
    items As sf_count_t _
) As Long

    sf_write_float = clsSnd.CallFunc("sf_write_float", _
                                     sndfile, _
                                     data_ptr, _
                                     items.lo, _
                                     items.hi)
End Function

Private Function sf_read_double( _
    ByVal sndfile As Long, _
    ByVal data_ptr As Long, _
    items As sf_count_t _
) As Long

    sf_read_double = clsSnd.CallFunc("sf_read_double", _
                                     sndfile, _
                                     data_ptr, _
                                     items.lo, _
                                     items.hi)
End Function

Private Function sf_write_double( _
    ByVal sndfile As Long, _
    ByVal data_ptr As Long, _
    items As sf_count_t _
) As Long

    sf_write_double = clsSnd.CallFunc("sf_write_double", _
                                      sndfile, _
                                      data_ptr, _
                                      items.lo, _
                                      items.hi)
End Function

Private Function sf_close( _
    ByVal sndfile As Long _
) As Long

    sf_close = clsSnd.CallFunc("sf_close", sndfile)
End Function

Private Sub sf_write_sync( _
    ByVal sndfile As Long _
)

    clsSnd.CallFunc "sf_write_sync", sndfile
End Sub
