VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "StreamWAV"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Implements ISoundStream
Implements ISoundInfo


Private Const Extensions    As String = "wav"
Private Const Description   As String = "ACM Wave Audio"


Private Declare Function acmStreamPrepareHeader Lib "msacm32" ( _
    ByVal has As Long, _
    pash As ACMSTREAMHEADER, _
    ByVal fdwPrepare As Long _
) As Long

Private Declare Function acmStreamUnprepareHeader Lib "msacm32" ( _
    ByVal has As Long, _
    pash As ACMSTREAMHEADER, _
    ByVal fdwUnprepare As Long _
) As Long

Private Declare Function acmStreamOpen Lib "msacm32" ( _
    phas As Long, _
    ByVal had As Long, _
    pwfxSrc As Any, _
    pwfxDst As Any, _
    ByVal pwfltr As Long, _
    ByVal dwCallback As Long, _
    ByVal dwInstance As Long, _
    ByVal fdwOpen As Long _
) As Long

Private Declare Function acmStreamSize Lib "msacm32" ( _
    ByVal has As Long, _
    ByVal cbInput As Long, _
    pdwOutputBytes As Long, _
    ByVal fdwSize As Long _
) As Long

Private Declare Function acmStreamConvert Lib "msacm32" ( _
    ByVal has As Long, _
    pash As ACMSTREAMHEADER, _
    ByVal fdwConvert As Long _
) As Long

Private Declare Function acmStreamReset Lib "msacm32" ( _
    ByVal has As Long, _
    ByVal fdwReset As Long _
) As Long

Private Declare Function acmStreamClose Lib "msacm32" ( _
    ByVal has As Long, _
    ByVal fdwClose As Long _
) As Long

Private Declare Function mmioClose Lib "winmm" ( _
    ByVal hmmio As Long, _
    ByVal uFlags As Long _
) As Long

Private Declare Function mmioDescend Lib "winmm" ( _
    ByVal hmmio As Long, _
    lpck As MMCKINFO, _
    lpckParent As MMCKINFO, _
    ByVal uFlags As Long _
) As Long

Private Declare Function mmioDescendParent Lib "winmm" _
Alias "mmioDescend" ( _
    ByVal hmmio As Long, _
    lpck As MMCKINFO, _
    ByVal x As Long, _
    ByVal uFlags As Long _
) As Long

Private Declare Function mmioOpen Lib "winmm" _
Alias "mmioOpenA" ( _
    ByVal szFileName As String, _
    lpmmioinfo As MMIOINFO, _
    ByVal dwOpenFlags As Long _
) As Long

Private Declare Function mmioSeek Lib "winmm" ( _
    ByVal hmmio As Long, _
    ByVal lOffset As Long, _
    ByVal iOrigin As Long _
) As Long

Private Declare Function mmioStringToFOURCC Lib "winmm" _
Alias "mmioStringToFOURCCA" ( _
    ByVal sz As String, _
    ByVal uFlags As Long _
) As Long

Private Type ACMSTREAMHEADER
    cbStruct                    As Long
    fdwStatus                   As Long
    dwUser                      As Long
    pbSrc                       As Long
    cbSrcLength                 As Long
    cbSrcLengthUsed             As Long
    dwSrcUser                   As Long
    pbDst                       As Long
    cbDstLength                 As Long
    cbDstLengthUsed             As Long
    dwDstUser                   As Long
    dwReservedDriver(9)         As Long
End Type

Private Type MMIOINFO
   dwFlags                      As Long
   fccIOProc                    As Long
   pIOProc                      As Long
   wErrorRet                    As Long
   htask                        As Long
   cchBuffer                    As Long
   pchBuffer                    As String
   pchNext                      As String
   pchEndRead                   As String
   pchEndWrite                  As String
   lBufOffset                   As Long
   lDiskOffset                  As Long
   adwInfo(4)                   As Long
   dwReserved1                  As Long
   dwReserved2                  As Long
   hmmio                        As Long
End Type

Private Type WAVE_FORMAT
    wFormatTag                  As Integer
    wChannels                   As Integer
    dwSampleRate                As Long
    dwBytesPerSec               As Long
    wBlockAlign                 As Integer
    wBitsPerSample              As Integer
End Type

Private Type MMCKINFO
   ckid                         As Long
   ckSize                       As Long
   fccType                      As Long
   dwDataOffset                 As Long
   dwFlags                      As Long
End Type

Private Type CHUNKINFO
    start                       As Long
    Length                      As Long
End Type

Private Type WAVEFORMATEX
    wFormatTag                  As Integer
    nChannels                   As Integer
    nSamplesPerSec              As Long
    nAvgBytesPerSec             As Long
    nBlockAlign                 As Integer
    wBitsPerSample              As Integer
    cbSize                      As Integer
End Type

Private Enum HACMSTREAM
    INVALID_STREAM_HANDLE = 0
End Enum

Private Enum ACM_STREAMSIZEF
    ACM_STREAMSIZEF_DESTINATION = &H1
    ACM_STREAMSIZEF_SOURCE = &H0
    ACM_STREAMSIZEF_QUERYMASK = &HF
End Enum

Private Enum ACM_STREAMCONVERTF
    ACM_STREAMCONVERTF_BLOCKALIGN = &H4
    ACM_STREAMCONVERTF_START = &H10
    ACM_STREAMCONVERTF_END = &H20
End Enum

Private Const MMIO_READ         As Long = &H0
Private Const MMIO_FINDCHUNK    As Long = &H10
Private Const MMIO_FINDRIFF     As Long = &H20

Private Const SEEK_CUR          As Long = 1

Private Const WAVE_FORMAT_PCM   As Long = 1


' Stream

Private hFWave                  As hFile
Private cnkData                 As CHUNKINFO
Private cnkInfo                 As CHUNKINFO
Private udtWFXIn                As WAVEFORMATEX
Private udtWFXOut               As WAVEFORMATEX
Private btWFX()                 As Byte

' ACM

Private Const OUTPUT_BUFFER_MS  As Long = 500

Private hStream                 As HACMSTREAM

Private btInput()               As Byte
Private intOutput()             As Integer

Private lngInputLen             As Long
Private lngOutputLen            As Long

Private lngPosInBuffer          As Long
Private lngBufferData           As Long

Private blnEndOfStream          As Boolean
Private blnFirst                As Boolean

Private lngKeepInBuffer         As Long

Private Sub Class_Initialize()
    hStream = INVALID_STREAM_HANDLE
    hFWave.handle = INVALID_HANDLE
End Sub

Private Sub Class_Terminate()
    ISoundStream_StreamClose
End Sub

Private Property Get ISoundStream_Description( _
) As String

    ISoundStream_Description = Description
End Property

Private Property Get ISoundStream_EndOfStream( _
) As Boolean

    If blnEndOfStream Then
        If lngPosInBuffer = lngBufferData Then
            ISoundStream_EndOfStream = True
        End If
    End If
End Property

Private Function ISoundStream_Extensions( _
) As String()

    ISoundStream_Extensions = Split(Extensions, ";")
End Function

Private Property Get ISoundStream_StreamInfo( _
) As ISoundInfo

    Set ISoundStream_StreamInfo = Me
End Property

Private Function ISoundStream_QuickStreamInfo( _
    ByVal Source As String, _
    info As ISoundInfo _
) As SND_RESULT

    Dim clsInfo     As QuickStreamInfo
    Dim hFQ         As hFile
    Dim cnkDataQ    As CHUNKINFO
    Dim cnkInfoQ    As CHUNKINFO
    Dim btWFXQ()    As Byte
    Dim udtWFXQ     As WAVE_FORMAT

    Set clsInfo = New QuickStreamInfo
    Set info = clsInfo

    If Not IsValidFile(Source) Then
        ISoundStream_QuickStreamInfo = SND_ERR_INVALID_SOURCE
        Exit Function
    End If

    ' find WAV chunks "data" and "fmt "
    cnkDataQ = GetWavChunkPos(Source, "data")
    cnkInfoQ = GetWavChunkPos(Source, "fmt ")

    ' valid chunks?
    If cnkDataQ.start = 0 Then
        ISoundStream_QuickStreamInfo = SND_ERR_INVALID_SOURCE
        Exit Function
    End If

    If cnkInfoQ.start = 0 Then
        ISoundStream_QuickStreamInfo = SND_ERR_INVALID_SOURCE
        Exit Function
    End If

    If cnkInfoQ.Length < 16 Then
        ISoundStream_QuickStreamInfo = SND_ERR_INVALID_SOURCE
        Exit Function
    End If

    hFQ = FileOpen(Source, _
                   GENERIC_READ, _
                   FILE_SHARE_READ)

    ' check for valid length of the data chunk
    If FileLength(hFQ) < (cnkDataQ.start + cnkDataQ.Length) Then
        cnkDataQ.Length = FileLength(hFQ) - cnkDataQ.start
    End If

    If hFQ.handle = INVALID_HANDLE Then
        ISoundStream_QuickStreamInfo = SND_ERR_INVALID_SOURCE
        Exit Function
    End If

    ' read info chunk
    ReDim btWFXQ(cnkInfoQ.Length - 1) As Byte
    FileSeek hFQ, cnkInfoQ.start, FILE_BEGIN
    FileRead hFQ, VarPtr(btWFXQ(0)), cnkInfoQ.Length

    CpyMem udtWFXQ, btWFXQ(0), Len(udtWFXQ)

    With udtWFXQ
        clsInfo.SetValues .dwSampleRate, _
                          .wChannels, _
                          16, _
                          .dwBytesPerSec * 8, _
                          cnkDataQ.Length / .dwBytesPerSec * 1000, _
                          0, New StreamTags
    End With

    FileClose hFQ

    ISoundStream_QuickStreamInfo = SND_ERR_SUCCESS
End Function

Private Function ISoundStream_StreamOpen( _
    ByVal Source As String _
) As SND_RESULT

    If Not IsValidFile(Source) Then
        ISoundStream_StreamOpen = SND_ERR_INVALID_SOURCE
        Exit Function
    End If

    ISoundStream_StreamClose

    ' find WAV chunks "data" and "fmt "
    cnkData = GetWavChunkPos(Source, "data")
    cnkInfo = GetWavChunkPos(Source, "fmt ")

    ' valid chunks?
    If cnkData.start = 0 Then
        ISoundStream_StreamOpen = SND_ERR_INVALID_SOURCE
        Exit Function
    End If

    If cnkInfo.start = 0 Then
        ISoundStream_StreamOpen = SND_ERR_INVALID_SOURCE
        Exit Function
    End If

    If cnkInfo.Length < 16 Then
        ISoundStream_StreamOpen = SND_ERR_INVALID_SOURCE
        Exit Function
    End If

    hFWave = FileOpen(Source, _
                      GENERIC_READ, _
                      FILE_SHARE_READ)

    ' check for valid length of the data chunk
    If FileLength(hFWave) < (cnkData.start + cnkData.Length) Then
        cnkData.Length = FileLength(hFWave) - cnkData.start
    End If

    If hFWave.handle = INVALID_HANDLE Then
        ISoundStream_StreamOpen = SND_ERR_INVALID_SOURCE
        Exit Function
    End If

    ' read info chunk
    ReDim btWFX(cnkInfo.Length - 1) As Byte
    FileSeek hFWave, cnkInfo.start, FILE_BEGIN
    FileRead hFWave, VarPtr(btWFX(0)), cnkInfo.Length

    CpyMem udtWFXIn, btWFX(0), Len(udtWFXIn)

    ' seek to the offset of the audio data
    FileSeek hFWave, cnkData.start, FILE_BEGIN

    ' start ACM conversion
    If Not InitConversion(True) Then
        ISoundStream_StreamOpen = SND_ERR_INTERNAL
        ISoundStream_StreamClose
        Exit Function
    End If

    ISoundStream_StreamOpen = SND_ERR_SUCCESS
End Function

Private Function ISoundStream_StreamClose( _
) As SND_RESULT

    If hFWave.handle = INVALID_HANDLE Then
        ISoundStream_StreamClose = SND_ERR_INVALID_SOURCE
    Else
        CloseConverter
        FileClose hFWave
        ISoundStream_StreamClose = SND_ERR_SUCCESS
    End If
End Function

Private Function ISoundStream_StreamRead( _
    ByVal buffer_ptr As Long, _
    ByVal buffer_len As Long, _
    ByRef buffer_read As Long _
) As SND_RESULT

    ISoundStream_StreamRead = SND_ERR_SUCCESS

    buffer_read = 0

    Do While buffer_read < buffer_len

        If lngBufferData = 0 Then
            If Not FillBuffer Then
                ISoundStream_StreamRead = SND_ERR_END_OF_STREAM
                Exit Function
            End If

        ElseIf (lngBufferData - lngPosInBuffer) < (buffer_len - buffer_read) Then
            If 0 < (lngBufferData - lngPosInBuffer) Then

                If 0 = IsBadReadPtr(ByVal VarPtr(intOutput(0)) + lngPosInBuffer, _
                                    lngBufferData - lngPosInBuffer) Then

                    If 0 = IsBadWritePtr(ByVal buffer_ptr + buffer_read, _
                                         lngBufferData - lngPosInBuffer) Then

                        CpyMem ByVal buffer_ptr + buffer_read, _
                               ByVal VarPtr(intOutput(0)) + lngPosInBuffer, _
                               lngBufferData - lngPosInBuffer

                    End If
                End If

                buffer_read = buffer_read + (lngBufferData - lngPosInBuffer)
            End If

            If Not FillBuffer Then
                ISoundStream_StreamRead = SND_ERR_END_OF_STREAM
                Exit Function
            End If

        Else
            If 0 = IsBadReadPtr(ByVal VarPtr(intOutput(0)) + lngPosInBuffer, _
                                buffer_len - buffer_read) Then

                If 0 = IsBadWritePtr(ByVal buffer_ptr + buffer_read, _
                                     buffer_len - buffer_read) Then

                    CpyMem ByVal buffer_ptr + buffer_read, _
                           ByVal VarPtr(intOutput(0)) + lngPosInBuffer, _
                           buffer_len - buffer_read

                End If
            End If

            lngPosInBuffer = lngPosInBuffer + (buffer_len - buffer_read)
            buffer_read = buffer_read + (buffer_len - buffer_read)

        End If

    Loop
End Function

Private Function ISoundStream_StreamSeek( _
    ByVal Value As Long, _
    ByVal seek_mode As SND_SEEK_MODE _
) As SND_RESULT

    Dim lngBytes    As Long

    If hFWave.handle = INVALID_HANDLE Then
        ISoundStream_StreamSeek = SND_ERR_INVALID_SOURCE
        Exit Function
    End If

    Select Case seek_mode

        Case SND_SEEK_PERCENT
            If Value < 0 Or Value > 99 Then
                ISoundStream_StreamSeek = SND_ERR_OUT_OF_RANGE
                Exit Function
            End If

            lngBytes = Value / 100 * cnkData.Length

        Case SND_SEEK_SECONDS
            If Value < 0 Or Value > (ISoundInfo_Duration / 1000) Then
                ISoundStream_StreamSeek = SND_ERR_OUT_OF_RANGE
                Exit Function
            End If

            lngBytes = udtWFXIn.nAvgBytesPerSec * Value

    End Select

    If Value = 0 Then
        FileSeek hFWave, cnkData.start, FILE_BEGIN
    Else
        lngBytes = AlignBytes(lngBytes) + cnkData.start
        FileSeek hFWave, lngBytes, FILE_BEGIN
    End If

    ' reset ACM stream to clear the codec's cache
    ResetConverter

    ISoundStream_StreamSeek = SND_ERR_SUCCESS
End Function

'''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''

Private Property Get ISoundInfo_Tags( _
) As StreamTags

    Set ISoundInfo_Tags = New StreamTags
End Property

Private Property Get ISoundInfo_Position( _
) As Long

    ISoundInfo_Position = (FilePosition(hFWave) - cnkData.start) / udtWFXIn.nAvgBytesPerSec * 1000
End Property

Private Property Get ISoundInfo_Duration( _
) As Long

    ISoundInfo_Duration = (cnkData.Length) / udtWFXIn.nAvgBytesPerSec * 1000
End Property

Private Property Get ISoundInfo_BitsPerSample( _
) As Integer

    ISoundInfo_BitsPerSample = 16
End Property

Private Property Get ISoundInfo_BitsPerSecond( _
) As Long

    ISoundInfo_BitsPerSecond = udtWFXIn.nAvgBytesPerSec * 8
End Property

Private Property Get ISoundInfo_channels( _
) As Integer

    ISoundInfo_channels = udtWFXIn.nChannels
End Property

Private Property Get ISoundInfo_SamplesPerSecond( _
) As Long

    ISoundInfo_SamplesPerSecond = udtWFXIn.nSamplesPerSec
End Property

'''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''

Private Function InitConversion( _
    Optional Force16Bit As Boolean = False _
) As Boolean

    Dim mmr     As Long

    If hStream <> INVALID_STREAM_HANDLE Then
        CloseConverter
    End If

    udtWFXOut = udtWFXIn

    If udtWFXOut.wBitsPerSample < 8 Then
        udtWFXOut.wBitsPerSample = 8
    ElseIf udtWFXOut.wBitsPerSample > 8 Then
        udtWFXOut.wBitsPerSample = 16
    End If

    If Force16Bit Then
        udtWFXOut.wBitsPerSample = 16
    End If

    With udtWFXOut
        udtWFXOut = CreateWFX(.nSamplesPerSec, _
                              .nChannels, _
                              .wBitsPerSample)
    End With

    mmr = acmStreamOpen(hStream, 0, _
                        btWFX(0), udtWFXOut, _
                        0, 0, 0, 0)

    If mmr <> 0 Then
        If Force16Bit Then Exit Function

        If udtWFXOut.wBitsPerSample = 16 Then
            udtWFXOut.wBitsPerSample = 8
        Else
            udtWFXOut.wBitsPerSample = 16
        End If

        mmr = acmStreamOpen(hStream, 0, _
                            btWFX(0), udtWFXOut, _
                            0, 0, 0, 0)

        If mmr <> 0 Then Exit Function
    End If

    ' set size of the output buffer
    lngOutputLen = OUTPUT_BUFFER_MS / 1000 * udtWFXOut.nAvgBytesPerSec

    ' needed size of the input buffer for
    ' wanted size of the output buffer
    mmr = acmStreamSize(hStream, _
                        lngOutputLen, _
                        lngInputLen, _
                        ACM_STREAMSIZEF_DESTINATION)

    If mmr <> 0 Then
        acmStreamClose hStream, 0
        hStream = 0
        Exit Function
    End If

    ReDim intOutput(lngOutputLen / 2 - 1) As Integer
    ReDim btInput(lngInputLen - 1) As Byte

    blnEndOfStream = False
    blnFirst = True

    lngKeepInBuffer = 0

    InitConversion = True
End Function

Private Function Convert( _
    ByVal lngInLen As Long, _
    ByVal lngOutLen As Long, _
    lngInUsed As Long, _
    lngOutUsed As Long, _
    Optional ByVal LastConversion As Boolean = False _
) As Boolean

    Dim lngFlags    As Long
    Dim udtHdr      As ACMSTREAMHEADER

    lngFlags = ACM_STREAMCONVERTF_BLOCKALIGN

    If blnFirst Then _
        lngFlags = lngFlags Or ACM_STREAMCONVERTF_START
    If LastConversion Then
        lngFlags = lngFlags Or ACM_STREAMCONVERTF_END
    End If

    With udtHdr
        .cbStruct = Len(udtHdr)
        .cbSrcLength = lngInLen
        .cbDstLength = lngOutLen
        .pbDst = VarPtr(intOutput(0))
        .pbSrc = VarPtr(btInput(0))
    End With

    acmStreamPrepareHeader hStream, udtHdr, 0

    blnFirst = False

    If 0 = acmStreamConvert(hStream, udtHdr, lngFlags) Then
        With udtHdr
            lngInUsed = .cbSrcLengthUsed
            lngOutUsed = .cbDstLengthUsed

            lngKeepInBuffer = .cbSrcLength - .cbSrcLengthUsed
        End With

        If lngKeepInBuffer > 0 Then
            ' codec hasn't used all bytes in the input buffer,
            ' move remaining bytes to btInput(0), so we
            ' can use it for the next decode
            CpyMem btInput(0), _
                   btInput(lngInLen - lngKeepInBuffer), _
                   lngKeepInBuffer
        End If

        Convert = True
    End If

    acmStreamUnprepareHeader hStream, udtHdr, 0
End Function

Private Function FillBuffer( _
) As Boolean

    Dim lngRead     As Long
    Dim lngWritten  As Long
    Dim udeRet      As SND_RESULT

    If blnEndOfStream Then
        'If lngPosInBuffer >= lngBufferData Then
            lngBufferData = 0
            lngPosInBuffer = 0
            ZeroMem intOutput(0), lngOutputLen
            ZeroMem btInput(0), lngInputLen
            Exit Function
        'Else
        '    FillBuffer = True
        '    Exit Function
        'End If
    End If

    ' read data from the WAV stream
    udeRet = ReadWAVData(VarPtr(btInput(lngKeepInBuffer)), _
                         lngInputLen - lngKeepInBuffer, _
                         lngRead)

    If udeRet <> SND_ERR_SUCCESS Then
        blnEndOfStream = True
    End If

    Convert lngRead + lngKeepInBuffer, lngOutputLen, _
            lngRead, lngWritten, _
            blnEndOfStream

    lngPosInBuffer = 0
    lngBufferData = lngWritten

    FillBuffer = True
End Function

Private Sub ResetConverter()
    If hStream = INVALID_STREAM_HANDLE Then
        Exit Sub
    End If

    CloseConverter

    acmStreamOpen hStream, 0, _
                  btWFX(0), udtWFXOut, _
                  0, 0, 0, 0

    lngOutputLen = OUTPUT_BUFFER_MS / 1000 * udtWFXOut.nAvgBytesPerSec

    acmStreamSize hStream, _
                  lngOutputLen, _
                  lngInputLen, _
                  ACM_STREAMSIZEF_DESTINATION

    ReDim intOutput(lngOutputLen / 2 - 1) As Integer
    ReDim btInput(lngInputLen - 1) As Byte

    blnEndOfStream = False
    blnFirst = True

    lngKeepInBuffer = 0
End Sub

Private Function CloseConverter( _
) As Boolean

    On Error Resume Next

    acmStreamClose hStream, 0
    hStream = INVALID_STREAM_HANDLE

    ZeroMem btInput(0), lngInputLen
    ZeroMem intOutput(0), lngOutputLen

    blnEndOfStream = False
    lngBufferData = 0
    lngPosInBuffer = 0
    lngInputLen = 0
    lngOutputLen = 0
    lngKeepInBuffer = 0

    CloseConverter = True
End Function

'''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''

Private Function ReadWAVData( _
    ByVal data_ptr As Long, _
    ByVal data_len As Long, _
    data_read As Long _
) As SND_RESULT

    ReadWAVData = SND_ERR_SUCCESS

    If hFWave.handle = INVALID_HANDLE Then
        ReadWAVData = SND_ERR_INVALID_SOURCE
        Exit Function
    End If

    If FilePosition(hFWave) > (cnkData.start + cnkData.Length) Then
        ReadWAVData = SND_ERR_END_OF_STREAM
        data_read = 0
        Exit Function
    End If

    If FilePosition(hFWave) + data_len > (cnkData.start + cnkData.Length) Then
        data_len = (cnkData.start + cnkData.Length) - FilePosition(hFWave)
        ReadWAVData = SND_ERR_END_OF_STREAM
    End If

    data_read = FileRead(hFWave, data_ptr, data_len)
End Function

Private Function GetWavChunkPos( _
    ByVal strFile As String, _
    ByVal strChunk As String _
) As CHUNKINFO

    Dim hMmioIn             As Long
    Dim lngRet              As Long
    Dim mmckinfoParentIn    As MMCKINFO
    Dim mmckinfoSubchunkIn  As MMCKINFO
    Dim mmioinf             As MMIOINFO

    hMmioIn = mmioOpen(strFile, mmioinf, MMIO_READ)
    If hMmioIn = 0 Then
        Exit Function
    End If

    mmckinfoParentIn.fccType = mmioStringToFOURCC("WAVE", 0)
    lngRet = mmioDescendParent(hMmioIn, _
                               mmckinfoParentIn, _
                               0, _
                               MMIO_FINDRIFF)

    If Not (lngRet = 0) Then
        mmioClose hMmioIn, 0
        Exit Function
    End If

    mmckinfoSubchunkIn.ckid = mmioStringToFOURCC(strChunk, 0)
    lngRet = mmioDescend(hMmioIn, _
                         mmckinfoSubchunkIn, _
                         mmckinfoParentIn, _
                         MMIO_FINDCHUNK)

    If Not (lngRet = 0) Then
        mmioClose hMmioIn, 0
        Exit Function
    End If

    GetWavChunkPos.start = mmioSeek(hMmioIn, 0, SEEK_CUR)
    GetWavChunkPos.Length = mmckinfoSubchunkIn.ckSize

    mmioClose hMmioIn, 0
End Function

Private Function AlignBytes( _
    ByVal bytes As Long _
) As Long

    AlignBytes = bytes - (bytes Mod udtWFXIn.nBlockAlign)
End Function

Private Function CreateWFX( _
    sR As Long, _
    chs As Integer, _
    bps As Integer _
) As WAVEFORMATEX

    With CreateWFX
        .wFormatTag = WAVE_FORMAT_PCM
        .nChannels = chs
        .nSamplesPerSec = sR
        .wBitsPerSample = bps
        .nBlockAlign = chs * (bps / 8)
        .nAvgBytesPerSec = sR * .nBlockAlign
    End With
End Function
