VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "WaveInRecorder"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Declare Function waveInAddBuffer Lib "winmm" ( _
    ByVal hwi As Long, _
    pwh As Any, _
    ByVal cbwh As Long _
) As Long

Private Declare Function waveInClose Lib "winmm" ( _
    ByVal hwi As Long _
) As Long

Private Declare Function waveInGetDevCaps Lib "winmm" _
Alias "waveInGetDevCapsA" ( _
    ByVal hwi As Long, _
    pwic As Any, _
    ByVal cbwic As Long _
) As Long

Private Declare Function waveInGetErrorText Lib "winmm" _
Alias "waveInGetErrorTextA" ( _
    ByVal mmrError As Long, _
    ByVal pszText As String, _
    ByVal cchText As Long _
) As Long

Private Declare Function waveInGetID Lib "winmm" ( _
    ByVal hwi As Long, _
    puDeviceID As Long _
) As Long

Private Declare Function waveInGetNumDevs Lib "winmm" ( _
) As Long

Private Declare Function waveInGetPosition Lib "winmm" ( _
    ByVal hwi As Long, _
    pmmt As Any, _
    ByVal cbmmt As Long _
) As Long

Private Declare Function waveInMessage Lib "winmm" ( _
    ByVal deviceid As Long, _
    ByVal uMsg As Long, _
    ByVal dwParam1 As Long, _
    ByVal dwParam2 As Long _
) As Long

Private Declare Function waveInOpen Lib "winmm" ( _
    phwi As Long, _
    ByVal uDeviceID As Long, _
    pwfx As Any, _
    ByVal dwCallback As Long, _
    ByVal dwCallbackInstance As Long, _
    ByVal fdwOpen As Long _
) As Long

Private Declare Function waveInPrepareHeader Lib "winmm" ( _
    ByVal hwi As Long, _
    pwh As Any, _
    ByVal cbwh As Long _
) As Long

Private Declare Function waveInUnprepareHeader Lib "winmm.dll" ( _
    ByVal hWaveIn As Long, _
    lpWaveInHdr As Any, _
    ByVal uSize As Long _
) As Long

Private Declare Function waveInReset Lib "winmm" ( _
    ByVal hwi As Long _
) As Long

Private Declare Function waveInStart Lib "winmm" ( _
    ByVal hwi As Long _
) As Long

Private Declare Function waveInStop Lib "winmm" ( _
    ByVal hwi As Long _
) As Long

Private Const CALLBACK_WINDOW                   As Long = &H10000

Private Const MM_WIM_OPEN                       As Long = &H3BE
Private Const MM_WIM_CLOSE                      As Long = &H3BF
Private Const MM_WIM_DATA                       As Long = &H3C0

Private Const WM_DESTROY                        As Long = &H2&
Private Const MMSYSERR_NOERROR                  As Long = 0

Private Type WAVEHDR
    lpData                                      As Long
    dwBufferLen                                 As Long
    dwBytesRec                                  As Long
    dwUser                                      As Long
    dwFlags                                     As Long
    dwLoops                                     As Long
    lpNext                                      As Long
    reserved                                    As Long
End Type

Private Type WAVEFORMAT
    wFormatTag                                  As Integer
    nChannels                                   As Integer
    nSamplesPerSec                              As Long
    nAvgBytesPerSec                             As Long
    nBlockAlign                                 As Integer
End Type

Private Type WAVEINCAPS
    wMid                                        As Integer
    wPid                                        As Integer
    vDriverVer                                  As Long
    szPname                                     As String * MAXPNAMELEN
    dwFormats                                   As Long
    wChannels                                   As Integer
    wReserved1                                  As Integer
End Type

Private Type MMTIME
    wType                                       As Long
    U                                           As Long
End Type

Private Type WaveInBuffer
    hdr                                         As WAVEHDR
    intBuffer()                                 As Integer
    pMem                                        As Long
End Type

Private Type DelegateFunction
    hMem                                        As Long
    addr                                        As Long
End Type

Private lngCurDev                               As Long
Private lngBufSize                              As Long
Private lngBufCnt                               As Long

Private udtBuffers()                            As WaveInBuffer

Private delegateWindow                          As DelegateFunction

Private lngPrevProc                             As Long
Private lngHwnd                                 As Long

Private hWaveIn                                 As Long

Public Event GotData( _
    intBuffer() As Integer, _
    lngLen As Long _
)

' Needs to be the first function in the class because of the VTable
Public Function zWndProc( _
    ByVal hWnd As Long, _
    ByVal Msg As Long, _
    ByVal wParam As Long, _
    ByVal lParam As Long _
) As Long

    Dim udtHdr  As WAVEHDR

    If Msg = MM_WIM_DATA Then
        CpyMem udtHdr, ByVal lParam, Len(udtHdr)

        RaiseEvent GotData(udtBuffers(udtHdr.dwUser).intBuffer, _
                           udtHdr.dwBytesRec)

        waveInAddBuffer hWaveIn, udtBuffers(udtHdr.dwUser), Len(udtHdr)
    End If

    zWndProc = CallWindowProc(lngPrevProc, hWnd, Msg, wParam, lParam)
End Function

Public Property Get IsRecording( _
) As Boolean

    IsRecording = hWaveIn <> 0
End Property

Private Function GetMixerLineCount( _
    ByVal devid As Long _
) As Long

    Dim pmxl        As MIXERLINE
    Dim pmxlc       As MIXERLINECONTROLS
    Dim pmxc        As MIXERCONTROL
    Dim rc          As Long

    pmxl.cbStruct = Len(pmxl)
    pmxl.dwComponentType = MIXERLINE_COMPONENTTYPE_DST_WAVEIN
    rc = mixerGetLineInfo(devid, pmxl, MIXER_GETLINEINFOF_COMPONENTTYPE)
    If rc <> 0 Then Exit Function

    pmxlc.cbStruct = Len(pmxlc)
    pmxlc.dwLineID = pmxl.dwLineID
    pmxlc.dwControl = MIXERCONTROL_CONTROLTYPE_MIXER
    pmxlc.cControls = pmxl.cControls
    pmxlc.cbmxctrl = Len(pmxc)
    pmxlc.pamxctrl = VarPtr(pmxc)

    rc = mixerGetLineControls(devid, pmxlc, MIXER_GETLINECONTROLSF_ONEBYTYPE)
    If rc <> 0 Then
        pmxlc.dwControl = MIXERCONTROL_CONTROLTYPE_MUX
        rc = mixerGetLineControls(devid, pmxlc, MIXER_GETLINECONTROLSF_ONEBYTYPE)
        If rc <> 0 Then Exit Function
    End If

    GetMixerLineCount = pmxc.cMultipleItems
End Function

Private Function GetMixerLineName( _
    ByVal devid As Long, _
    ByVal Index As Long _
) As String

    Dim pmxl        As MIXERLINE
    Dim pmxlc       As MIXERLINECONTROLS
    Dim pmxc        As MIXERCONTROL
    Dim pmxcd       As MIXERCONTROLDETAILS
    Dim mcdlt()     As MIXERCONTROLDETAILS_LISTTEXT
    Dim rc          As Long

    pmxl.cbStruct = Len(pmxl)
    pmxl.dwComponentType = MIXERLINE_COMPONENTTYPE_DST_WAVEIN
    rc = mixerGetLineInfo(devid, pmxl, MIXER_GETLINEINFOF_COMPONENTTYPE)
    If rc <> 0 Then Exit Function

    pmxlc.cbStruct = Len(pmxlc)
    pmxlc.dwLineID = pmxl.dwLineID
    pmxlc.dwControl = MIXERCONTROL_CONTROLTYPE_MIXER
    pmxlc.cControls = pmxl.cControls
    pmxlc.cbmxctrl = Len(pmxc)
    pmxlc.pamxctrl = VarPtr(pmxc)

    rc = mixerGetLineControls(devid, pmxlc, MIXER_GETLINECONTROLSF_ONEBYTYPE)
    If rc <> 0 Then
        pmxlc.dwControl = MIXERCONTROL_CONTROLTYPE_MUX
        rc = mixerGetLineControls(devid, pmxlc, MIXER_GETLINECONTROLSF_ONEBYTYPE)
        If rc <> 0 Then Exit Function
    End If

    ReDim mcdlt(pmxc.cMultipleItems - 1)
    pmxcd.cbStruct = Len(pmxcd)
    pmxcd.cChannels = 1
    pmxcd.dwControlID = pmxc.dwControlID
    pmxcd.item = pmxc.cMultipleItems
    pmxcd.cbDetails = Len(mcdlt(0))
    pmxcd.paDetails = VarPtr(mcdlt(0))

    rc = mixerGetControlDetails(devid, pmxcd, MIXER_GETCONTROLDETAILSF_LISTTEXT)
    If rc <> 0 Then Exit Function

    pmxl.dwLineID = mcdlt(Index).dwParam1
    rc = mixerGetLineInfo(devid, pmxl, MIXER_GETLINEINFOF_LINEID)
    If rc <> 0 Then Exit Function

    GetMixerLineName = pmxl.szName
End Function

Private Function SetMixerLine( _
    ByVal devid As Long, _
    ByVal Index As Long _
) As Boolean

    Dim pmxl        As MIXERLINE
    Dim pmxlc       As MIXERLINECONTROLS
    Dim pmxc        As MIXERCONTROL
    Dim pmxcd       As MIXERCONTROLDETAILS
    Dim mcdlt()     As MIXERCONTROLDETAILS_LISTTEXT
    Dim mcdb()      As Long
    Dim rc          As Long

    pmxl.cbStruct = Len(pmxl)
    pmxl.dwComponentType = MIXERLINE_COMPONENTTYPE_DST_WAVEIN
    rc = mixerGetLineInfo(devid, pmxl, MIXER_GETLINEINFOF_COMPONENTTYPE)
    If rc <> 0 Then Exit Function

    pmxlc.cbStruct = Len(pmxlc)
    pmxlc.dwLineID = pmxl.dwLineID
    pmxlc.dwControl = MIXERCONTROL_CONTROLTYPE_MIXER
    pmxlc.cControls = pmxl.cControls
    pmxlc.cbmxctrl = Len(pmxc)
    pmxlc.pamxctrl = VarPtr(pmxc)

    rc = mixerGetLineControls(devid, pmxlc, MIXER_GETLINECONTROLSF_ONEBYTYPE)
    If rc <> 0 Then
        pmxlc.dwControl = MIXERCONTROL_CONTROLTYPE_MUX
        rc = mixerGetLineControls(devid, pmxlc, MIXER_GETLINECONTROLSF_ONEBYTYPE)
        If rc <> 0 Then Exit Function
    End If

    ReDim mcdlt(pmxc.cMultipleItems - 1)
    pmxcd.cbStruct = Len(pmxcd)
    pmxcd.cChannels = 1
    pmxcd.dwControlID = pmxc.dwControlID
    pmxcd.item = pmxc.cMultipleItems
    pmxcd.cbDetails = Len(mcdlt(0))
    pmxcd.paDetails = VarPtr(mcdlt(0))

    rc = mixerGetControlDetails(devid, pmxcd, MIXER_GETCONTROLDETAILSF_LISTTEXT)
    If rc <> 0 Then Exit Function

    pmxl.dwLineID = mcdlt(Index).dwParam1
    rc = mixerGetLineInfo(devid, pmxl, MIXER_GETLINEINFOF_LINEID)
    If rc <> 0 Then Exit Function

    ReDim mcdb(pmxc.cMultipleItems - 1)
    pmxcd.cbDetails = Len(mcdb(0))
    pmxcd.paDetails = VarPtr(mcdb(0))
    mcdb(Index) = 1

    rc = mixerSetControlDetails(devid, pmxcd, MIXER_SETCONTROLDETAILSF_VALUE)
    If rc <> 0 Then Exit Function

    SetMixerLine = True
End Function

Private Function GetMixerLine( _
    ByVal devid As Long, _
    ByVal Index As Long _
) As Long

    Dim pmxl        As MIXERLINE
    Dim pmxlc       As MIXERLINECONTROLS
    Dim pmxc        As MIXERCONTROL
    Dim pmxcd       As MIXERCONTROLDETAILS
    Dim mcdlt()     As MIXERCONTROLDETAILS_LISTTEXT
    Dim mcdb()      As Long
    Dim rc          As Long
    Dim i           As Long

    pmxl.cbStruct = Len(pmxl)
    pmxl.dwComponentType = MIXERLINE_COMPONENTTYPE_DST_WAVEIN
    rc = mixerGetLineInfo(devid, pmxl, MIXER_GETLINEINFOF_COMPONENTTYPE)
    If rc <> 0 Then Exit Function

    pmxlc.cbStruct = Len(pmxlc)
    pmxlc.dwLineID = pmxl.dwLineID
    pmxlc.dwControl = MIXERCONTROL_CONTROLTYPE_MIXER
    pmxlc.cControls = pmxl.cControls
    pmxlc.cbmxctrl = Len(pmxc)
    pmxlc.pamxctrl = VarPtr(pmxc)

    rc = mixerGetLineControls(devid, pmxlc, MIXER_GETLINECONTROLSF_ONEBYTYPE)
    If rc <> 0 Then
        pmxlc.dwControl = MIXERCONTROL_CONTROLTYPE_MUX
        rc = mixerGetLineControls(devid, pmxlc, MIXER_GETLINECONTROLSF_ONEBYTYPE)
        If rc <> 0 Then Exit Function
    End If

    ReDim mcdlt(pmxc.cMultipleItems - 1)
    pmxcd.cbStruct = Len(pmxcd)
    pmxcd.cChannels = 1
    pmxcd.dwControlID = pmxc.dwControlID
    pmxcd.item = pmxc.cMultipleItems
    pmxcd.cbDetails = Len(mcdlt(0))
    pmxcd.paDetails = VarPtr(mcdlt(0))

    rc = mixerGetControlDetails(devid, pmxcd, MIXER_GETCONTROLDETAILSF_LISTTEXT)
    If rc <> 0 Then Exit Function

    pmxl.dwLineID = mcdlt(Index).dwParam1
    rc = mixerGetLineInfo(devid, pmxl, MIXER_GETLINEINFOF_LINEID)
    If rc <> 0 Then Exit Function

    ReDim mcdb(pmxc.cMultipleItems - 1)
    pmxcd.cbDetails = Len(mcdb(0))
    pmxcd.paDetails = VarPtr(mcdb(0))

    rc = mixerGetControlDetails(devid, pmxcd, MIXER_GETCONTROLDETAILSF_VALUE)
    If rc <> 0 Then Exit Function

    For i = 0 To UBound(mcdb)
        If mcdb(i) <> 0 Then
            GetMixerLine = i
            Exit For
        End If
    Next
End Function

Public Function StopRecord( _
) As Boolean

    Dim i   As Long

    waveInStop hWaveIn
    waveInReset hWaveIn

    For i = 0 To lngBufCnt - 1
        waveInUnprepareHeader hWaveIn, udtBuffers(i).hdr, Len(udtBuffers(i).hdr)
    Next

    waveInClose hWaveIn
    hWaveIn = 0

    StopRecord = True
End Function

Public Function StartRecord( _
    ByVal samplerate As Long, _
    ByVal Channels As Integer _
) As Boolean

    Dim udtWFX  As WAVEFORMATEX
    Dim res     As Long
    Dim i       As Long
    Dim j       As Long

    ReDim udtBuffers(lngBufCnt - 1) As WaveInBuffer

    With udtWFX
        .nFormatTag = WAVE_FORMAT_PCM
        .lSamplesPerSec = samplerate
        .nChannels = Channels
        .nBitsPerSample = 16
        .nBlockAlign = Channels * (.nBitsPerSample / 8)
        .lAvgBytesPerSec = .nBlockAlign * .lSamplesPerSec
    End With

    res = waveInOpen(hWaveIn, lngCurDev, udtWFX, lngHwnd, 0, CALLBACK_WINDOW)
    If res <> MMSYSERR_NOERROR Then
        Exit Function
    End If

    ' prepare headers/buffers
    For i = 0 To lngBufCnt - 1
        With udtBuffers(i)
            ReDim .intBuffer(lngBufSize / 2 - 1) As Integer
            .pMem = VarPtr(.intBuffer(0))
            .hdr.dwBufferLen = lngBufSize
            .hdr.lpData = .pMem
            .hdr.dwUser = i

            res = waveInPrepareHeader(hWaveIn, .hdr, Len(.hdr))
            If res <> MMSYSERR_NOERROR Then
                ' on error unprepare all prepared headers
                For j = (i - 1) To 0 Step -1
                    waveInUnprepareHeader hWaveIn, .hdr, Len(.hdr)
                Next

                waveInClose hWaveIn
                hWaveIn = 0

                Exit Function
            End If
        End With
    Next

    res = waveInStart(hWaveIn)
    If res <> MMSYSERR_NOERROR Then
        For i = 0 To lngBufCnt - 1
            waveInUnprepareHeader hWaveIn, udtBuffers(i).hdr, Len(udtBuffers(i).hdr)
        Next

        waveInClose hWaveIn
        hWaveIn = 0

        Exit Function
    End If

    For i = 0 To lngBufCnt - 1
        waveInAddBuffer hWaveIn, udtBuffers(i).hdr, Len(udtBuffers(i).hdr)
    Next

    StartRecord = True
End Function

Public Property Get BufferCount( _
) As Long

    BufferCount = lngBufCnt
End Property

Public Property Let BufferCount( _
    ByVal Index As Long _
)

    lngBufCnt = Index
End Property

Public Property Get BufferSize( _
) As Long

    BufferSize = lngBufSize
End Property

Public Property Let BufferSize( _
    ByVal bytes As Long _
)

    lngBufSize = bytes
End Property

Public Property Get DeviceCount( _
) As Long

    DeviceCount = waveInGetNumDevs()
End Property

Public Property Get DeviceName( _
    ByVal Index As Long _
) As String

    Dim udtInfo As WAVEINCAPS
    Dim strName As String

    waveInGetDevCaps Index, udtInfo, Len(udtInfo)
    strName = udtInfo.szPname

    If InStr(strName, Chr$(0)) > 0 Then
        strName = Left$(strName, InStr(strName, Chr$(0)) - 1)
    End If

    DeviceName = udtInfo.szPname
End Property

Public Function SelectDevice( _
    ByVal Index As Long _
) As Boolean

    If Index < 0 Or Index > DeviceCount - 1 Then
        Exit Function
    End If

    lngCurDev = Index

    SelectDevice = True
End Function

Public Property Get MixerLineCount( _
) As Long

    If lngCurDev < 0 Then Exit Property

    MixerLineCount = GetMixerLineCount(lngCurDev)
End Property

Public Property Get MixerLineName( _
    ByVal Index As Long _
) As String

    If lngCurDev < 0 Then Exit Property

    MixerLineName = GetMixerLineName(lngCurDev, Index)
End Property

Public Function SelectMixerLine( _
    ByVal Index As Long _
) As Boolean

    If lngCurDev < 0 Then Exit Function

    SelectMixerLine = SetMixerLine(lngCurDev, Index)
End Function

Public Property Get SelectedDevice( _
) As Long

    SelectedDevice = lngCurDev
End Property

Public Property Get SelectedMixerLine( _
) As Long

    SelectedMixerLine = GetMixerLine(lngCurDev, 0)
End Property

Public Property Get MixerLineVolume( _
) As Long

    Dim i       As Long
    Dim udtVol  As volume_stereo

    For i = 0 To MixerDestinations(lngCurDev) - 1
        If MixerDestinationType(lngCurDev, i) = MIXERLINE_COMPONENTTYPE_DST_WAVEIN Then
            udtVol = MixerConnectionVolume(lngCurDev, _
                                           i, _
                                           MixerLineCount - SelectedMixerLine - 1)

            Exit For
        End If
    Next

    MixerLineVolume = udtVol.L
End Property

Public Property Let MixerLineVolume( _
    ByVal Volume As Long _
)

    Dim i       As Long
    Dim udtVol  As volume_stereo

    udtVol.L = Volume
    udtVol.r = Volume

    For i = 0 To MixerDestinations(lngCurDev) - 1
        If MixerDestinationType(lngCurDev, i) = MIXERLINE_COMPONENTTYPE_DST_WAVEIN Then
            MixerSetConnectionVolume lngCurDev, _
                                     i, _
                                     MixerLineCount - SelectedMixerLine - 1, _
                                     udtVol
            Exit For
        End If
    Next
End Property

Private Sub Attach( _
    ByVal hWnd As Long _
)

    lngHwnd = hWnd
    lngPrevProc = SetWindowLong(lngHwnd, GWL_WNDPROC, delegateWindow.addr)
End Sub

Private Sub Detach()
   If lngHwnd Then
      SetWindowLong lngHwnd, GWL_WNDPROC, lngPrevProc
      lngHwnd = 0
   End If
End Sub

Private Function CreateDelegate( _
    obj As Object, _
    vtblindex As Long, _
    cParams As Long _
) As DelegateFunction

    Dim pADR        As Long, pASM       As Long
    Dim pOut        As Long
    Dim delegate    As DelegateFunction
    Dim i           As Integer

    CpyMem pADR, ByVal ObjPtr(obj), 4
    CpyMem pADR, ByVal pADR + &H1C& + (4 * vtblindex), 4

    If pADR = 0 Then Exit Function

    With delegate
        ' allocate some memory for ASM code
        .hMem = GlobalAlloc(GMEM_ZEROINIT, 31 + cParams * 3)
        .addr = GlobalLock(.hMem)
    End With

    pASM = delegate.addr
    If pASM = 0 Then Exit Function

    ' position of pOut in allocated mem
    pOut = delegate.addr + 31 + (cParams * 3) - 4

    AddLong pASM, &H68EC8B55            ' MOV EBP,ESP  PUSH EBP
    AddLong pASM, pOut                  ' PUSH OFFSET pOut

    For i = 4 + 4 * cParams To 5 Step -4
        AddInteger pASM, &H75FF         ' PUSH EBP+|||||||||
        AddByte pASM, CByte(i)          '          STACK POS
    Next i

    AddPush pASM, ObjPtr(obj)           ' PUSH Object Pointer
    AddCall pASM, pADR                  ' CALL addr
    AddByte pASM, &HA1                  ' MOV EAX, ||||
    AddLong pASM, pOut                  '          pOut
    AddInteger pASM, &HC2C9             ' RET ||||||||||
    AddInteger pASM, cParams * 4        '     PARAMETERS

    CreateDelegate = delegate
End Function

Private Sub FreeDelegateMem( _
    fnc As DelegateFunction _
)

    GlobalUnlock fnc.hMem
    GlobalFree fnc.hMem
    ZeroMem fnc, Len(fnc)
End Sub

Private Sub AddPush( _
    pASM As Long, _
    lng As Long _
)

    AddByte pASM, &H68
    AddLong pASM, lng
End Sub

Private Sub AddCall( _
    pASM As Long, _
    addr As Long _
)

    AddByte pASM, &HE8
    AddLong pASM, addr - pASM - 4
End Sub

Private Sub AddLong( _
    pASM As Long, _
    lng As Long _
)

    CpyMem ByVal pASM, lng, 4
    pASM = pASM + 4
End Sub

Private Sub AddInteger( _
    pASM As Long, _
    iInt As Integer _
)

    CpyMem ByVal pASM, iInt, 2
    pASM = pASM + 2
End Sub

Private Sub AddByte( _
    pASM As Long, _
    Bt As Byte _
)

    CpyMem ByVal pASM, Bt, 1
    pASM = pASM + 1
End Sub

Private Sub InitWaveInWnd()
    delegateWindow = CreateDelegate(Me, 0, 4)

    lngHwnd = CreateWindowEx(0&, _
                             "STATIC", _
                             "WAVE_IN_WINDOW", _
                             0&, 0&, 0&, 0&, _
                             0&, 0&, 0&, _
                             App.hInstance, _
                             0&)

    Attach lngHwnd
End Sub

Private Sub DeinitWaveInWnd()
    Detach
    DestroyWindow lngHwnd: lngHwnd = 0: lngPrevProc = 0
    FreeDelegateMem delegateWindow
End Sub

Private Sub Class_Initialize()
    lngBufCnt = 5
    lngBufSize = 10& * 1024&
    lngCurDev = -1

    InitWaveInWnd
End Sub

Private Sub Class_Terminate()
    DeinitWaveInWnd
End Sub
