Attribute VB_Name = "modActiveX"
Option Explicit

' register/unregister ActiveX

Private Declare Function CLSIDFromProgID Lib "ole32" ( _
    ByVal lpszProgID As String, _
    pclsid As CLSID _
) As Long

Private Const MAXCODE       As Long = &HEC00&

Private Type CLSID
    Data1           As Long
    Data2           As Integer
    Data3           As Integer
    Data4(7)        As Byte
End Type

Private Const CO_E_CLASSSTRING      As Long = &H800401F3
Private Const E_OUTOFMEMORY         As Long = &H8007000E
Private Const REGDB_E_WRITEREGDB    As Long = &H80040151
Private Const E_INVALIDARG          As Long = &H80070057
Private Const E_UNEXPECTED          As Long = &H8000FFFF

' http://www.codeguru.com/forum/archive/index.php/t-15027.html
Public Function IsProgIDRegistered( _
    ByVal strProgID As String _
) As Boolean

    On Error Resume Next

    Dim pclsid  As CLSID
    Dim HRESULT As Long

    HRESULT = CLSIDFromProgID(StrConv(strProgID, vbUnicode), pclsid)
    IsProgIDRegistered = (HRESULT = 0)
End Function

' like GetProcAddress, but with a more comfortable first parameter
Private Function GetFncAddress( _
    ByVal library As String, _
    ByVal sFunction As String _
) As Long

    Dim hModule As Long
    Dim pFunc   As Long

    ' check if module already loaded
    hModule = GetModuleHandle(library)
    If hModule = 0 Then
        ' module not loaded, try to load it
        hModule = LoadLibrary(library)
        If hModule = 0 Then
            Err.Raise 999, , "library missing!"
            Exit Function
        End If
    End If

    ' get entry point of function
    pFunc = GetProcAddress(hModule, sFunction)
    If pFunc = 0 Then
        Err.Raise 998, , "not a exported function!"
        Exit Function
    End If

    GetFncAddress = pFunc
End Function

' call function by its pointer
Private Function CallPointer( _
    ByVal fnc As Long, _
    ParamArray Params() _
) As Long

    Dim btASM(MAXCODE - 1)  As Byte
    Dim pASM                As Long
    Dim i                   As Integer

    pASM = VarPtr(btASM(0))

    ' fill code array with INT 3s (Debugger)
    FillMem ByVal pASM, MAXCODE, &HCC

    ' remove CallWindowProc parameters from stack
    AddByte pASM, &H58                  ' POP EAX
    AddByte pASM, &H59                  ' POP ECX
    AddByte pASM, &H59                  ' POP ECX
    AddByte pASM, &H59                  ' POP ECX
    AddByte pASM, &H59                  ' POP ECX
    AddByte pASM, &H50                  ' PUSH EAX

    For i = UBound(Params) To 0 Step -1
        AddPush pASM, CLng(Params(i))   ' PUSH dword
    Next

    AddCall pASM, fnc                   ' CALL rel addr
    AddByte pASM, &HC3                  ' RET

    CallPointer = CallWindowProc(VarPtr(btASM(0)), _
                                 0, 0, 0, 0)
End Function

Private Sub AddPush(pASM As Long, lng As Long)
    AddByte pASM, &H68
    AddLong pASM, lng
End Sub

Private Sub AddCall(pASM As Long, addr As Long)
    AddByte pASM, &HE8
    AddLong pASM, addr - pASM - 4
End Sub

Private Sub AddLong(pASM As Long, lng As Long)
    CpyMem ByVal pASM, lng, 4
    pASM = pASM + 4
End Sub

Private Sub AddByte(pASM As Long, Bt As Byte)
    CpyMem ByVal pASM, Bt, 1
    pASM = pASM + 1
End Sub

Public Function RegisterCOMServer( _
    ByVal strFile As String _
) As Boolean

    Dim pFnc    As Long

    On Error Resume Next
    pFnc = GetFncAddress(strFile, "DllRegisterServer")
    If Err Then Exit Function
    On Error GoTo 0

    CallPointer pFnc

    RegisterCOMServer = True
End Function

Public Function UnregisterCOMServer( _
    ByVal strFile As String _
) As Boolean

    Dim pFnc    As Long

    On Error Resume Next
    pFnc = GetFncAddress(strFile, "DllUnregisterServer")
    If Err Then Exit Function
    On Error GoTo 0

    CallPointer pFnc

    UnregisterCOMServer = True
End Function
